// ********************************************************************
//
//  Routine:      acread_
//  Author:       T.Oest
//
//  Description:  general steering routine to apply internal and
//                
//
//  Modification:
//  -  acGlobAlChange() switched off (causes a segmentation fault
//     if the database is not defined)                  T.Oest 2/8/99
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"


static int first       = 1;
static int KeyMajor    = 0;
static int KeyMinor    = 0;

int acReadTARGET();
int acReadVDS();
int acReadOTR();
int acReadITR();
int acReadHPT();
int acReadTRD();
int acReadRICH();
int acReadMUON();
int acReadGlobal();

extern int recoTARGET;
extern int recoVDS;
extern int recoOTR;
extern int recoECAL;
extern int recoMUON;
extern int recoRICH;
extern int recoTRD;
extern int recoHPT;

//*****************************************************************
// function
//*****************************************************************

extern "C" void acread_() {

//==================================================================
// no action for MC
//==================================================================

  if (ArteTable<MTRA>::size() > 0 ) return ;

//==================================================================
// no action if reconstruction is switched off
//==================================================================

 int recoITR    = 0;

 if (recoTARGET == 0 && recoVDS  == 0 && recoOTR  == 0 &
     recoITR    == 0 && recoECAL == 0 && recoMUON == 0 &
     recoRICH   == 0 && recoTRD  == 0 && recoHPT  == 0) return;

//==================================================================
// 1. check for a new alignment/calibration key (DKEY table)
//    KeyMajor = 0 : no database Key tabel available,
//                   in this case the time from the DDAQ table
//                   should be taken get the correct set of
//                   constants
//==================================================================

 /*
  int newKeyMajor    = ArtePointer<EVHD>(1)->dbmajor;
  int newKeyMinor    = ArtePointer<EVHD>(1)->dbminor;

  if (first == 0 && newKeyMajor == KeyMajor && 
                    newKeyMinor == KeyMinor &&
                    newKeyMajor != 0 ) {
   return;
  } else {
   first = 0;
   KeyMajor    = newKeyMajor;
   KeyMinor    = newKeyMinor;
  };

  */

//==================================================================
// 2. set internal alignment constants, transforms NEDE to GEDE tables
//  - no action if no reconstruction will be done
//  - alignment sensitive parameters should be taken from 
//    the subdetector database (no off values with respect to NEDE)
//  - constant values (pitch) should be taken from NEDE
//  - return flag: > 0   constants were changed
//                 = 0   no change of constants
//  -              < 0   error, old constants are kept
//==================================================================

  int flagTARGET = 0;
  int flagVDS    = 0;
  int flagITR    = 0;
  int flagOTR    = 0;
  int flagMUON   = 0;
  int flagTRD    = 0;
  int flagRICH   = 0;
  int flagHPT    = 0;

  /*
  flagTARGET = acReadTARGET();
  flagVDS    = acReadVDS();
  flagITR    = acReadITR();
  flagOTR    = acReadOTR();
  flagMUON   = acReadMUON();
  flagTRD    = acReadTRD();
  flagRICH   = acReadRICH();
  flagHPT    = acReadHPT();
  */

//==================================================================
// 3. Apply global alignment constants (in case internal constants
//    were changed)
//==================================================================

  int flagGLOBAL = 0;
  flagGLOBAL = acReadGlobal();

//==================================================================
// 4. error handling (not yet implemented)
//==================================================================

 return;
}

