
// ****************************************************************************
//
// source:    atregkuip
//
// created:   16 July 99
// updated:    
//
// Author:    C. Borgmeier
//
// symbol:    atprekuip( void (*function)(), int priority )
// called by: anywhere
//
// symbol:    extern "C" atcallkuip_()
// called by: atkuip
//
// ****************************************************************************


#include <set>


// internal structure
struct FunctionWithPriority
{
  void (*f)();
  int p;
};


static bool operator<( const FunctionWithPriority& e1,
		       const FunctionWithPriority& e2 )
{
  return e1.p > e2.p;
}


static std::set<FunctionWithPriority>* functions = 0;
static bool callsdone = false;

//
// register a function with priority p
//
void atregkuip( void (*function)(), int priority )
{
  if( !callsdone ) {
    FunctionWithPriority f;
    f.f = function;
    f.p = priority;
    
    if( functions==0 ) functions = new std::set<FunctionWithPriority>;
    functions->insert( f );
  } else {
    // if atcallkuip has been called already, call function immediately
    (*function)();
  }
}


//
// call the registered functions
//
extern "C" void atcallkuip_()
{
  if( functions!=0 ) {
    for( std::set<FunctionWithPriority>::iterator i = functions->begin();
	 i!=functions->end();
	 ++i ) {
      (*i).f();
    }
    delete functions;
    functions = 0;
  }
  callsdone = true;
}
