*-- Author :    Hartwig Albrecht   22/05/95

      SUBROUTINE DDCHCK

************************************************************************
*
* Description: Clean up table DDEF
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDCOM.fi"
#include "arte/ZDDEFP.fi"
#include "arte/ArteFlag.fi"

      INTEGER K1, K2, K3, N, IFL, ICOL, IFILE, CHCMPN
      CHARACTER CN*80, CC*80

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

C check sequence of commands

      CALL MEWARC (634575,
     +  'DDCHCK: syntax checker for DD commands')

C loop over the commands given by the user

      DO 10 K1 = 1, NDDUSR

        IF (IDDEF_FLAG(K1) .EQ. LDDEF_NAM)  CALL MEERRC (419845,
     +    'DDCHCK: DNAMSEQ command is not allowed in DD input')

        IF (IDDEF_FLAG(K1) .EQ. LDDEF_REL)  CALL MEERRC (419845,
     +    'DDCHCK: DRELAT command is not allowed in DD input')

 10   CONTINUE

C make more DRELAT commands (those which are not user-defined))

      CALL DDRELA

C Make Dmenu commands

      N = NDDEF()
      DO 50 K1 = 1, N

        IF (IDDEF_FLAG(K1) .GE. LDDEF_TAB .AND.
     +      IDDEF_FLAG(K1) .LE. LDDEF_MEN)  GO TO 30
        IF (IDDEF_FLAG(K1) .NE. LDDEF_RE1 .AND.
     +      IDDEF_FLAG(K1) .NE. LDDEF_REM)  GO TO 50

 30     DO 40 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_MEN .AND.
     +        CHCMPN (IQ(HQDDEF_NAM2(1,K1)),
     +                IQ(HQDDEF_NAME(1,K2))) .NE. 0)  GO TO 50
 40     CONTINUE

        CALL KADZZI (LDDEF_MEN)
        CALL CHCOPN (IQ(HQDDEF_NAM2(1,K1)), IQ(HQDDEF_NAME_L(1)))

 50   CONTINUE

C loop over user commands + commands from all.kumac

      DO 80 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .LT. LDDEF_TAB .OR.
     +      IDDEF_FLAG(K1) .GT. LDDEF_MEN)  GO TO 80

        IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +              IQ(HQDDEF_NAM2(1,K1))) .NE. 0 .AND.
     +      HDDEF_NAME(1,K1) .NE. HBLANKSP)  THEN
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (675765,
     +      'DDCHCK: don''t use a name twice on one DD command')
        END IF

C check that table/relat/menu names appear only once

        DO 70 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .LT. LDDEF_TAB .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_MEN)  GO TO 70
          IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                IQ(HQDDEF_NAME(1,K2))) .EQ. 0)  GO TO 70

          CALL MESELP ('DD redefined:', 'TP')
          CALL LIDDE0 (K2, 'TP')
          CALL LIDDE0 (K1, 'TP')
          IF (K2 .LT. NDDUSR .AND.
     +      (IDDEF_FLAG(K1) .NE. LDDEF_REL .OR.
     +       IDDEF_FLAG(K2) .NE. LDDEF_REL))  THEN
            CALL MEERRC (2946184,
     +        'DDCHCK: table/relat/menu is doubly defined')
          END IF

C erase the old DD commands

          IQ(IQDDEF_FLAG(K2)) = LDDEF_SKP
          DO 60 K3 = K2 + 1, NDDEF()
            IF (IDDEF_FLAG(K3) .GE. LDDEF_TAB .AND.
     +          IDDEF_FLAG(K3) .LE. LDDEF_NAM)  GO TO 70
            IQ(IQDDEF_FLAG(K3)) = LDDEF_SKP
 60       CONTINUE

 70     CONTINUE
 80   CONTINUE

C check relations and inverse relations

      DO 140 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_RE1 .AND.
     +      IDDEF_FLAG(K1) .NE. LDDEF_REM)  GO TO 140

        DO 110 K2 = K1 - 1, 1, -1
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  THEN
            IQ(IQDDEF_DIV(K1)) = IDDEF_DIV(K2)
            DO K3 = 1, 20
              IQ(HQDDEF_NAM2(K3,K1)) = HDDEF_NAM2(K3,K2)
            END DO
            GO TO 120
          END IF
 110    CONTINUE

 120    IFL = 0
        DO 130 K2 = 1, NDDEF()
          IF (CHCMPN (IQ(HQDDEF_NAM3(1,K1)),
     +                IQ(HQDDEF_NAM3(1,K2))) .EQ. 0 .OR.
     +       K1 .EQ. K2)  GO TO 130

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_REM)  THEN

            CALL MEWARN ('Old:')
            CALL LIDDE0 (K2, 'TPL')
            CALL MEWARN ('New:')
            CALL LIDDE0 (K1, 'TPL')
            CALL MEERRC (6483434,
     +        'DDCHCK: relation is doubly defined')
            IQ(IQDDEF_FLAG(K2)) = LDDEF_SKP
          END IF

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN
            IF (IDDEF_FLAG(K1) .EQ. LDDEF_RE1)  THEN
              IFL = 1
              IQ(IQDDEF_RFLG(K2)) = 1
            ELSE
              IFL = -1
              CALL MEERRC (813245,
     +        'DDCHCK: many-to-one relation: use one-to many instead')
            END IF
          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN
            IF (IDDEF_FLAG(K1) .EQ. LDDEF_RE1)  THEN
              IFL = 2
            ELSE
              IFL = 4
            END IF
            IQ(IQDDEF_RFLG(K2)) = IFL
          END IF

 130    CONTINUE

        IQ(IQDDEF_RFLG(K1)) = IFL

        IF (IFL .EQ. 0)  THEN
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (2351334, 'DDCHCK: relation is undefined')
          IQ(IQDDEF_FLAG(K1)) = LDDEF_SKP
        END IF

 140  CONTINUE

      DO 160 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_IN1 .AND.
     +      IDDEF_FLAG(K1) .NE. LDDEF_INM)  GO TO 160

        IFL = 0
        DO 150 K2 = 1, NDDEF()
          IF (CHCMPN (IQ(HQDDEF_NAM3(1,K1)),
     +                IQ(HQDDEF_NAM3(1,K2))) .EQ. 0 .OR.
     +      K1 .EQ. K2)  GO TO 150

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_IN1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CALL MEWARN ('Old:')
            CALL LIDDE0 (K2, 'TPL')
            CALL MEWARN ('New:')
            CALL LIDDE0 (K1, 'TPL')
            IQ(IQDDEF_FLAG(K2)) = LDDEF_SKP
            CALL MEERRC (6483434,
     +        'DDCHCK: relation is doubly defined')
          END IF

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_REM)  IFL = 1

 150    CONTINUE

        IF (IFL .EQ. 0)  THEN
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (2351334, 'DDCHCK: relation is undefined')
          IQ(IQDDEF_FLAG(K1)) = LDDEF_SKP
        END IF

 160  CONTINUE

C check sequence of DD commands

      CC = 'unknown'
      IFILE = 1
      IFL = -1
      DO 290 K1 = 1, NDDEF()

        IF (IDDEF_FLAG(K1) .LE. LDDEF_SKP)  GO TO 290
        IF (IDDEF_FLAG(K1) .LE. LDDEF_NAM)  IFL = IDDEF_FLAG(K1)

C Ddefini

        IF (IDDEF_FLAG(K1) .EQ. LDDEF_INI)  THEN

          IF (IFL .GE. 0)  IQ(IQDDEF_FLAG(K1)) = LDDEF_SKP
          GO TO 290

C Dtable

        ELSE IF (IDDEF_FLAG(K1) .LE. LDDEF_TAB)  THEN


          IF (IFILE .NE. 1)  THEN
            CALL MEALLP ('Error in table ' // CC)
            CALL MEERRC (74857,
     +      'DDCHCK: exactly one DFFILE command for every table!')
          END IF
          IFILE = 0
          ICOL = 1
          IQ(L_A(JDDEF_RFLG,K1,JDDEF)) = 0
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CC)
          GO TO 290

C Drelat, Dmenu, Dnamseq


        ELSE IF (IDDEF_FLAG(K1) .LE. LDDEF_NAM)  THEN

          GO TO 290

C Dtext

        ELSE IF (IDDEF_FLAG(K1) .EQ. LDDEF_TEX)  THEN

          IF (IFL .GT. 0)  GO TO 290
          CALL MEALLP ('Error in table ' // CC)
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (8634643,
     +      'DDCHCK: DTEXT not meaningful after DDEF')
          IQ(L_A(JDDEF_FLAG,K1,JDDEF)) = LDDEF_SKP
          GO TO 290

        END IF

C commands related to DTABLE

        IF (IFL .NE. LDDEF_TAB)  THEN

          CALL MEALLP ('Error in table ' // CC)
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (1347634,
     +      'DDCHCK: attributes allowed only after DTABLE')
          IQ(IQDDEF_FLAG(K1)) = LDDEF_SKP
          GO TO 290

        END IF

C Dattrib, Dpointer, Drelxxx, Dinvxxx

        IF (IDDEF_FLAG(K1) .LE. LDDEF_INM)  THEN

          IQ(L_A(JDDEF_COL,K1,JDDEF)) = ICOL
          ICOL = ICOL + MAX (IDDEF_DIM(K1), 1)

          DO 210 K2 = K1 + 1, NDDEF()
            IF (IDDEF_FLAG(K2) .LE. LDDEF_SKP)  GO TO 210
            IF (IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 290
            IF (IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 210

            IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAME(1,K2))) .NE. 0)  THEN

              CALL MEALLP ('Error in table ' // CC)
              CALL LIDDE0 (K1, 'TPL')
              CALL LIDDE0 (K2, 'TPL')
              CALL MEERRC (7613244,
     +          'DDCHCK: 2 attributes of a table have the same name')
              IQ(IQDDEF_FLAG(K2)) = LDDEF_SKP

            END IF

 210      CONTINUE

          IF (IDDEF_FLAG(K1) .EQ. LDDEF_POI)  THEN
            DO 220 K2 = 1, NDDEF()
              IF (IDDEF_FLAG(K2) .NE. LDDEF_TAB)  GO TO 220
              IF (CHCMPN (IQ(HQDDEF_NAM2(1,K1)),
     +                    IQ(HQDDEF_NAME(1,K2))) .NE. 0)  GO TO 230
 220        CONTINUE
            CALL LIDDE0 (K1, 'TPL')
            CALL MEERRC (346155, 'DDCHCK: table does not exist')
            
 230        CONTINUE
          END IF
C Dfile

        ELSE IF (IDDEF_FLAG(K1) .EQ. LDDEF_FIL)  THEN

          IFILE = IFILE + 1

C Dsub_of, Dpar_to

        ELSE IF (IDDEF_FLAG(K1) .LE. LDDEF_PAR)  THEN

          IF (IQ(L_A(JDDEF_RFLG,K1,JDDEF)) .NE. 0)  THEN
            CALL MEALLP ('Error in table ' // CC)
            CALL LIDDE0 (K1, 'TPL')
            CALL MEERRC (346155,
     +        'DDCHCK: more than one DSUB_OF/DPAR_TO for one table')
            IQ(L_A(JDDEF_FLAG,K1,JDDEF)) = LDDEF_SKP
          END IF
          IQ(L_A(JDDEF_RFLG,K1,JDDEF)) = -1
          IF (IDDEF_FLAG(K1) .EQ. LDDEF_PAR)
     +        IQ(L_A(JDDEF_RFLG,K1,JDDEF)) = -2

          DO 240 K2 = 1, NDDEF()
            IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB .AND.
     +          CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAME(1,K2))) .NE. 0)  GO TO 290
 240      CONTINUE

          CALL MEALLP ('Error in table ' // CC)
          CALL LIDDE0 (K1, 'TPL')
          CALL MEERRC (7934645,
     +      'DDCHCK: DSUB_OF/DPAR_TO points to a non-existing table')
          IQ(L_A(JDDEF_FLAG,K1,JDDEF)) = LDDEF_SKP

        END IF

 290  CONTINUE

        IF (IFILE .NE. 1)  THEN
          CALL MEALLP ('Error in table ' // CC)
          CALL MEERRC (74857,
     +    'DDCHCK: exactly one DFFILE command for every table!')
        END IF

C make name sequence

      N = NDDEF()
      DO 420 K1 = NDDNEW + 1, N
        IF (IDDEF_FLAG(K1) .LT. LDDEF_TAB .OR.
     +      IDDEF_FLAG(K1) .GT. LDDEF_REL)  GO TO 420

        DO 410 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_NAM .AND.
     +          CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAME(1,K2))) .NE. 0)  GO TO 420
 410    CONTINUE

        CALL KADZZI (LDDEF_NAM)
        CALL CHCOPN (IQ(HQDDEF_NAME(1,K1)), IQ(HQDDEF_NAME_L(1)))

 420  CONTINUE

      DO 440 K1 = 1, NDDNEW
        IF (IDDEF_FLAG(K1) .LT. LDDEF_TAB .OR.
     +      IDDEF_FLAG(K1) .GT. LDDEF_REL)  GO TO 440

        DO 430 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_NAM .AND.
     +          CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAME(1,K2))) .NE. 0)  GO TO 440
 430    CONTINUE

        CALL KADZZI (LDDEF_NAM)
        CALL CHCOPN (IQ(HQDDEF_NAME(1,K1)), IQ(HQDDEF_NAME_L(1)))

 440  CONTINUE

      DO 530 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_REL)  GO TO 530

        CN = 'relation'

        DO 520 N = 1, 2

          DO 510 K2 = 1, NDDEF()
            IF (IDDEF_FLAG(K2) .EQ. LDDEF_TAB)  K3 = K2
            IF  (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                   IQ(HQDDEF_NAM3(1,K2))) .EQ. 0)  GO TO 510
            IF (N .EQ. 1 .AND. IDDEF_FLAG(K2) .GT. LDDEF_REM)
     +        GO TO 510
            IF (N .EQ. 2 .AND. IDDEF_FLAG(K2) .LE. LDDEF_REM)
     +        GO TO 510
            IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +          IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN
              CALL CH78BC ('one')
            ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +               IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN
              CALL CH78BC ('many')
            ELSE
              GO TO 510
            END IF
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CN)
            CALL CH78BC (CN)
            CALL CH78BC ('in')
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K3)), CN)
            CALL CH78BC (CN)

            IF (N .EQ. 1)  CALL CH78BC ('<->')
 510      CONTINUE

 520    CONTINUE

        CALL CHCTOH (CN, IQ(HQDDEF_TEXT(1,K1)), NDDEF_TEXT)

 530  CONTINUE

      IF (PROGERR .EQ. 0)  THEN
        CALL MEWARC (865345, 'DDCHCK syntax checker: OK')
      ELSE
        CALL MEERRC (1834, 'DDEXEC: job ran with errors. Give up ?')
      END IF

      END

************************************************************************
* End of DDCHCK
************************************************************************
