
      SUBROUTINE QNEXT

************************************************************************
*-- Author :    Olga Igonkina   02.02.1997
*__Modified by Vitali Khachatryan 29.08.1999
* Description: process event, skip event in case of ZEBRA errors
*
* Called from: QNEXTE 
*
* External references:
*
* Argument in/out description
*
************************************************************************
      IMPLICIT NONE
#include "arte/ArteSelect.fi"
#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZQUEST.fi"
#include "arte/ZTELLC.fi"
#include "auto/MEIO.fi"
#include "auto/EVHD.fi"

      INTEGER IEV, LEOD, LOCF
      REAL T

#include "arte/Arte.ff"
#include "auto/MEIO.ff"
#include "auto/EVHD.ff"

C do the rest of the initalization here:

      IF (PROGSTAT .LT. 0)  THEN
        IF (IMEIO_FLAG(IMEIO_CURRENT(LHIST)) .NE. 3)  CALL MEWARC
     +    (7612354, 'HBOOK: no HBOOK output file declared')
c        CALL DGSELE
cc        IF (LUNDINIT .NE. 0)  CALL ALINIT
cc  Call ALINIT only if Monte Carlo is ON (V.K.)
        IF (LUNDINIT .NE. 0)  CALL ARTESELECT(I_MONTE_CARLO,I_ALINIT)
        CALL MEWARC (7631254, 'ARTE: call USINIT')
        CALL USINIT
        PROGSTAT = 0
        CALL ZPHASE(1)
        CALL MEWARC (1345134, 'ARTE initialization finished')
        CALL TIMEX (TIMEINIT)
        TIMESTOP = TIMEINIT
      END IF

      IF( MODE.NE.0 )THEN       ! break from ZEBRA

        EVENTOUT = -1           ! do not write old event
                                ! EVHD bank should be checked!

        CALL MZNEED(IXEVNT,1,' ')
        C78 = 'QNEXT: ZFATAL error,MODE='
        CALL CH78BI( MODE)
        CALL CH78CC( 'IQUEST(11/12/13)=') 
        CALL CH78BI( IQUEST(11)) 
        CALL CH78CI( IQUEST(12)) 
        CALL CH78CI( IQUEST(13))
        CALL MEMESC( 3924778,ILARGEST,ILARGEST,C78)
        C78 = 'regenerate event'
        CALL ME78AP
        MODE = 0
      ENDIF

C            loop over events

        IEV = 0

C            write and drop old event

 10   IF (JEVHD .NE. 0)  CALL MMWEVT

C check time limit

      CALL TIMEL (T)

C Does anybody understand the following statement? I do NOT (H.A.).

      IF (T .LE. -360000. + TIMELIMIT)
     +  CALL ATSTOP ('STOP: time limit reached')
      CALL TIMEX (T)
      TIMEEMAX = MAX (TIMEEMAX, T - TIMESTOP)
      TIMESTOP = T

C event number for MC etc.:
      NUMEVT = NUMEVT + 1
C event loop:
      NEVENTS = NEVENTS + 1
      EVENTOUT = 1

C generate next event a la phase space

      IF(PHSPINIT.NE.0) THEN

CC         CALL PHEVNT
cc  Call PHEVNT only if Monte Carlo is ON (V.K.)
         CALL ARTESELECT(I_MONTE_CARLO,I_PHEVNT)

C read next record from event input file ...

      ELSEIF (LUNDINIT .EQ. 0)  THEN

        CALL MMREVT (LEOD)

C no more events ?

        IF (LEOD .LT. 0)  GO TO 90

      ELSE

C ... or generate event

CC        CALL ALEVNT
cc  Call ALEVNT only if Monte Carlo is ON (V.K.)
         CALL ARTESELECT(I_MONTE_CARLO,I_ALEVNT)

      END IF

C print event number etc. in interactive mode

      IF (IBATCH .EQ. 0)  THEN
        CALL LIEVH1
        CALL ME78SP ('T')
      END IF

      IF (IQ(BQEVHD_IPADDR(1)) .EQ. 0.)  IQ(BQEVHD_IPADDR(1)) = IPADDR

C user event routine

      CALL USEVNT

      IEV = IEV + 1
      IF (IEV .LT. NEVENTL)  GO TO 10


 90   END

**************************************************************
*     END of QNEXT
**************************************************************
