*-- Author :    Hartwig Albrecht   15/03/95

      SUBROUTINE UTINIT

************************************************************************
*
* Description: General initialization.
*              This routine is awfully machine-dependent; actually,
*              most of the machine-dependency should be put here.
*              This version is written for the Zeuthen Hydra. The final
*              version needs lots of ornaments with +IF etc. !
*
* Called from the VERY BEGIN of the program.
*
* External references: CERNLIB: DATIMH, GETARG, GETPIDF, GETWDF
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "jets/LUDAT1.fi"
#include "digi/ZUTSEL.fi"

#ifdef _LINUX_
      INTEGER ISHFT
#endif
      INTEGER I, J
      CHARACTER DIGIT10*10,ABCL26*26,ABCU26*26,COLLAB(50)*12
      EQUIVALENCE (A__(1,1),ABCL26),(A__(1,2),ABCU26),
     + (D__(1),DIGIT10)

C Allowed: rename collaborators; extend the list.
C Not allowed: remove any collaborator (the order is significant).
      DATA COLLAB /
     + 'AMSTERDAM   ', 'AUSTIN      ', 'BEIJING     ', 'BERLIN      ',
     + 'BOLOGNA     ', 'DORTMUND    ', 'NORTHWESTERN', 'GLASGOW     ',
     + 'DESY        ', 'UNI_HAMBURG ', 'MPI_HEIDELB ', 'UNI_HEIDELB ',
     + 'HELSINKI    ', 'KIEV        ', 'NBI         ', 'LJUBLJANA   ',
     + 'UCLA        ', 'LUND        ', 'ITEP_MOSCOW ', 'MEPHI_MOSCOW',
     + 'MUNICH      ', 'YALE        ', 'PRINCETON   ', 'ROMA        ',
     + 'SIEGEN      ', 'BROOKHAVEN  ', 'ZEUTHEN     ', '            ',
     + 22 * ' '/

#include "arte/Arte.ff"

C timing

      CALL DATIMH (PROGDATE,PROGTIME)
      TIMEINIT = 0.
      TIMESTOP = 0.
      TIMEEMAX = 0.
      TIMELIMIT = 5.

      IBATCH = 2

C machine-dependent initialization

      CALL UTMACH

C job environment variables

      CALL UTENVI

      HBDIRV = HBDIR
      CALL CHAPPC (HBDIRV, '/')
      CALL CHAPPC (HBDIRV, HBVERS)

      PROGSTAT = -1
      PROGERR = 0
      DO INSTNUM = 1, 50
        IF (COLLAB(INSTNUM) .EQ. INSTNAME)  GO TO 10
      END DO
      INSTNUM = 0

C event/run/experiment number for MC events

 10   NUMEVT = 0
      NUMRUN = 1
      NUMEXP = -INSTNUM

      B__(1) = 1
      DO I = 2, 32
        B__(I) = ISHFT(B__(I-1),1)
      END DO

      DIGIT10 = '0123456789'
      ABCL26 = 'abcdefghijklmnopqrstuvwxyz'
      ABCU26 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

      CALL CHCTOH ('    ', HBLANKSP, 1)
      CALL CHHTOC (0,        CHNULL)
      CALL CHHTOC (10*2**24, CHLINEF)
      CALL CHHTOC (11*2**24, CHVERTT)
      CALL CHHTOC (12*2**24, CHFORMF)
      CALL CHHTOC (13*2**24, CHCARRR)

      DO I = 0,255
        K__(I+1,1) = I
        K__(I+1,2) = I
        K__(I+1,3) = 0
        K__(I+1,4) = -3
        DO J = 0, 9
          IF (CHAR(I) .EQ. DIGIT(J))  K__(I+1,4) = J
        END DO
        DO J = 1, 26
          IF (CHAR(I) .EQ. ABCLOW(J))  THEN
            K__(I+1,2) = ICHAR(ABCUP(J))
            K__(I+1,3) = - J
            K__(I+1,4) = -1
          END IF
          IF (CHAR(I) .EQ. ABCUP(J))  THEN
            K__(I+1,1) = ICHAR(ABCLOW(J))
            K__(I+1,3) = J
            K__(I+1,4) = -2
          END IF
        END DO
      END DO

C initialization flags

      DATDINIT = 0
      DECAINIT = 0
      RECOINIT = 0
      PRISINIT = 0
      LUNDINIT = 0
      GEANINIT = 0
      CMINIT = 0
      NOPRINT = 0
      MIMPSW = 1
      HERAEBEAM = 920.
      TARGETMAT = 'AL'

      LUNDSEED(1) = 0
      LUNDSEED(2) = 0

      ARTEVERS = 8.01
      LUNDVERS = 0.
      PYTHVERS = 0.
      FRITVERS = 0.
      GEANVERS = 0.
      GEOMVERS = 0.
      RECOVERS = 0.

C initialize selection of detector components

      NGSEL = 0

C parameters on the Unix command line

      CALL UTCARG

      JOBNAME = 'J'
      CALL CHAPPC (JOBNAME, PROGNAME)
      CALL CHAPPC (JOBNAME, '.')
      CALL CHAPPI (JOBNAME, PROCESSID)

      END

************************************************************************
* End of UTINIT
************************************************************************
