//                              -*- Mode: C++ -*-
//: CmdCareCalib.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
/* $Log: CmdCareCalib.C,v $
 * Revision 1.4  1999/08/04 15:21:28  natasha
 * new care version from Mauro
 *
 * Revision 1.2  1999/06/01  16:07:30  villa
 * before HH
 *
 */
#include "care/CmdCareCalib.hh"
#include "care/ECMCcalib.hh"


/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {
  void carecalib_(){
    CmdCareCalib calCmd;
    calCmd.readAndExe();
  }
}; // end of extern
#endif
//////////////////////////////////////////////////////////

/*
CLASS
  CmdCareCalib
  Class to deal with the care/calib kuip command.

*/

CmdCareCalib::CmdCareCalib() : inner(30.0), middle(6.7), outer(6.7) {}

CmdCareCalib::~CmdCareCalib(){}

void CmdCareCalib::defValues(){
  inner = 30.0;
  middle = 6.7;
  outer = 6.7;
}

//--
//   Execute stored command
void CmdCareCalib::execute(){
  ECMCcalib::setCalibration(inner,middle,outer);
}

# ifdef USEKUIP
//--
//   Read a command from external
void CmdCareCalib::read(){
  inner = readFloat();
  middle = readFloat();
  outer = readFloat();
}
#else
//void CmdCareCalib::read(){}
# endif                          
//--
//   Printout Information for the current MinimumEnergy data stored
void CmdCareCalib::dump(){
  ECMCcalib::dumpCalib();
}






