//                              -*- Mode: C++ -*-
//:ELNearHitCells.C
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 27/5/97
/* $Log: ELNearHitCells.C,v $
 * Revision 1.7  1999/08/04 15:21:39  natasha
 * new care version from Mauro
 *
 * Revision 1.3  1999/06/01  16:07:41  villa
 * before HH
 *
 */
//

#include "care/ELNearHitCells.hh"
#include "care/EMClusterTree.hh"
#include "arte/arte.hh"
#include "care/ELNearCells.hh"
#undef WRITE

/*
CLASS 
  ELNearHitCells
  Get the list of nearby clusterized cells
  and provide access to the list

*/

///////////////// ELNearHitCells.C member function definitions ////////
//--
//  constructor
ELNearHitCells::ELNearHitCells() : 
   numNeib(0), curr(0) {}
//--
//  destructor
ELNearHitCells::~ELNearHitCells(){}


//--
//--
//  Get the neibours of a given cell
void ELNearHitCells::of(const EMHitCell* hcell, const EMClusterTree & tree){
  //--
  // find the index of the cell pointed by the current cell
  of(hcell->cellIdx(), tree);
}

//--
//  Get neibouring cells of a given cell
void ELNearHitCells::of(CellIdx_t cell, const EMClusterTree & tree){

  //
  ELNearCells nearCells;
  nearCells.of(cell);
  // for each neibouring cell find if it is linked with a cluster
  numNeib = 0;
  CellIdx_t nearCell; 
  EMHitCell * nearCluster;

# ifdef WRITE
  cout<<" Looking for neiboouring of cell "<< cell.index()<<endl;
# endif
  for(nearCells.begin(); nearCells.more(); nearCells.next()){
    nearCell = *nearCells;// get the index of the neibouring cell i
    
# ifdef WRITE
    cout<<" "<< nearCell.index();
# endif
    nearCluster = tree.whichHitCell(nearCell);
    if(nearCluster!=0){
       
# ifdef WRITE
     cout<<"Stored   ";
# endif
      // found a nearby cell already clusterized. 
      neibCells[numNeib] = nearCluster;
      numNeib++;
    }
  }
# ifdef WRITE
     cout<<endl;
# endif

  curr = 0;
}

