//                              -*- Mode: C++ -*-
//: ESPosition.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/ESPosition.hh"

//////////// member function definitions

//-- constructors
ESPosition::ESPosition() : 
  zf(0.0), xf(0.0), yf(0.0), energyf(0.0), sqenerrf(0.0), ndata(0), 
  type(Peak), maxHitC(0) {
  varf[0] = 0.0;
  varf[1] = 0.0;
  varf[2] = 0.0;
}

ESPosition::ESPosition(const ESPosition & pos) :
  zf(pos.z()),  xf(pos.x()), yf(pos.y()), 
  energyf(pos.energy()), sqenerrf(pos.sqenerr()),
  ndata(pos.width()),  type(pos.posType()), maxHitC(pos.cell()) {
    varf[0] = pos.var(0);
    varf[1] = pos.var(1);
    varf[2] = pos.var(2);
}

//-- destructor
ESPosition::~ESPosition(){}


//--
//  Operator function for assigning the pos struct:
const ESPosition & ESPosition::operator = (const ESPosition & pos){
  xf = pos.x();
  yf = pos.y();
  zf = pos.z();
  energyf = pos.energy(); 
  sqenerrf = pos.sqenerr();
  ndata = pos.width(); 
  type = pos.posType();
  maxHitC = pos.cell();
  varf[0] = pos.var(0);
  varf[1] = pos.var(1);
  varf[2] = pos.var(2);
  return *this;
}
 
