//                              -*- Mode: C++ -*-
//: EDBoundCellModifier.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 2/5/97
// Last Update ........
//

#ifndef EDBOUNDCELLMODIFIER_HH_
#define EDBOUNDCELLMODIFIER_HH_

#include "care/EDClusterModifier.hh"
class ECBuilder;

/**
class EDBoundCellModifier.
  Class for distributing boundary cells to signal clusters.


*/

class EDBoundCellModifier : public EDClusterModifier {
public:
  //-- Constructors
  /// Default constructor
  EDBoundCellModifier(ECBuilder* pbuilder);
  /// The virtual default destructor
  virtual ~EDBoundCellModifier();
  //-- 
  // ClusterMember Analyzer
  //
  /**@name Beheavioral methods */
  //@{ 
  /// EMClusterMember Modifier
  virtual void doModify(EMClusterMember * clsMem);
  //--
  /// EMHitCell Modifier
  virtual void doModify(EMHitCell * hitT) ;
  //--
  /// EMCluster Modifier
  virtual void doModify(EMCluster * clus);
  //--
  /// EMClusterTree Modifier
  virtual void doModify(EMClusterTree * tree);
  //--
  /// TrackOnEcal Modifier
  virtual void doModify(EMTrackOnEcal * track);

  //--
  ///  Base function to be called with the TopCluster List
  void analyzeTopList(EMClusterTree & topList);
  //@}

private:
  //--
  /// the builder pointer
  ECBuilder* builder;
  //--
  //  vector of cells to split in some way
  vector<EMHitCell *> cells_to_split;

};

#endif // EDBOUNDCELLMODIFIER_HH_

