//                              -*- Mode: C++ -*-
//:ELNearClustersRec.hh
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 27/5/97
// Last Update ........
//
//

#ifndef ELNEARCLUSREC_HH_
#define ELNEARCLUSREC_HH_

#include "care/ELNearClusters.hh"

/**
class ELNearClustersRec.
  Get the list of clusters nearby a given cell
  and provide access to the list
*/

class ELNearClustersRec : public ELNearClusters {
public:
  //--
  /// default constructor
  ELNearClustersRec();
  //--
  /// constructor with an already initialized ELNearHitCells object
  ELNearClustersRec(ELNearHitCells & nearT);
  //--
  ///  destructor
  virtual ~ELNearClustersRec();
  //--

  /**@name Beheavioral methods */
  //@{ 
  //--
  ///  Minimize the internal near cluster array
  virtual void minimize();
  //@}
  
};

#endif // ELNEARCLUSREC_HH_
