#include <stdio.h>
#include <strings.h>
#include <ctype.h>
#include <stdlib.h>
#include "arte/Arte.h"
#include "auto/MEIO.h"
#include "dbarte/DbArteBridge.h"
#include "arte/ArteFlag.h"
#include "arte/mecCount.h"


extern DbFileDesc *DbFileDescList;


void mmbook_(int *, int *), mmrupd_(int *), mmdrop_(int *), mmfree_(int *);
void chhtot_(char *, char *, int *);
void iounit_(char *, int *, int);
int  mmrstat_(int *, int *);
int  mmwstat_(int *, int *);


void DbClose(int lun, int *ierr) 
{

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   * 12.08.98: Modified by A. Semenov (JINR, Dubna)
   *
   * Description: Close a MIZZI file/server and disconnect the
   *              symbolic name from it.
   *
   * Called from: anywhere.
   *
   * External references: CloseTables
   *
   * Argument in/out description
   *  lun  in        IO stream ID
   *
   *  ierr    out    Operation status 
   *               0 success
   *               1 error (lun was not connected to file/server)
   *
   *
   ************************************************************************/
  
  char mess[80]="DBCLOS: ", warn[80]="DBCLOS: ";
  char Csym[DB_MAX_NAME_SIZE+1];
  int var;
  DbFileDesc *FD;
  
  strncpy(Csym,MEIO(lun).stream,DB_MAX_NAME_SIZE);
  for(var=0;var<DB_MAX_NAME_SIZE && Csym[var] && Csym[var]!=' ';var++);
  Csym[var]=0;


  for(FD=DbFileDescList;FD;FD=FD->next)
	  if(FD->lun==lun)
		  break;

   if(FD==NULL)
   {
    static int errPtr;
    sprintf(mess+strlen(mess),
       "symbolic name %s not connected to a file/server",Csym );
    mecErrorCount( &errPtr, mess );
    *ierr = 1;
	return;
   }

  sprintf(warn+strlen(warn),
     "closing file/server %s on %s",FD->Name,FD->Csym );
  if (arteflag_.ibatch == 0)
     mecAllPrint( warn );
  else
     {
     static int errPtr;
     mecWarningCount( &errPtr, warn );
     }

  CloseTables( FD->Id );
  FD->active=0;
  FD->Csym[0]=0;
  FD->Name[0]=0;
  FD->lun=0;

  *ierr = 0;
  return;
}
