
      SUBROUTINE CAFMLI(J)

************************************************************************
* Author :    Olga Igonkina   10/09/96
*
* Description: arc integration ( ECAL miniMC package)
*
* Called from: CAFMLO
*
* External references:
*
* Argument in/out description
*
************************************************************************
      IMPLICIT NONE

      REAL ALPHA, SHELP
      INTEGER J
      REAL X1,X2,Y1,Y2, YR

#include "arte/Arte.fi"
#include "gean/cafmco.fi"
#include "gean/cafmcc.fi"
#include "arte/Arte.ff"

       X1 = LC(J,1)
       Y1 = LC(J,2)
       X2 = LC(J+1,1)
       Y2 = LC(J+1,2)

       SHELP = X1 * Y2 - X2*Y1

       IF( X1.GE.R2.AND.X2.GE.R2 )THEN
         IF( SHELP.LT.0. )RETURN
          X1 = R2
          Y1 = -SQRT( RC*RC - R2*R2 )
          X2 = R2
          Y2 = -Y1
       ENDIF

       IF( X1.LE.R1.AND.X2.LE.R1 )THEN
         IF( SHELP.LT.0. )RETURN
          X1 = R1
          Y1 = SQRT( RC*RC - R1*R1 )
          X2 = R1
          Y2 = -Y1
       ENDIF

       IF( ABS(SHELP).LE.0.1E-8 )THEN
         IF( ABS( X1-X2).GT.0.1-8.OR.
     +       ABS( Y1-Y2).GT.0.1-8 )THEN
           SUM = SUM + 1.57079635* RC * RC
         ENDIF
       ELSE
         ALPHA = SQRT((X1-X2)**2 + (Y1-Y2)**2) /2. /RC
         IF( ALPHA.LT.(1.-0.1E-6) )THEN
           IF( SHELP.LT.0. )THEN
             SUM = SUM + RC*RC * ( ALPHA - SIN(2*ALPHA)/2.)
           ELSE
             SUM = SUM +
     +       RC*RC * (3.1415927 -ALPHA + SIN(2*ALPHA)/2. )
           ENDIF
         ELSE
           SUM = SUM + 1.57079635* RC * RC
         ENDIF
       ENDIF
C...

      IF( ABS(R1).GT.RC.AND.ABS(R2).GT.RC )GOTO 999

      IF( X1.LT.R2 .AND. X2.LT.R2 .AND. R2.LT.RC
     +     .AND. Y1.GT.0. .AND. Y2.LT.0.)THEN
         ALPHA = ACOS( R2/RC )
         SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.)
         GOTO 999
      ENDIF

      IF( X1.GT.R1 .AND. X2.GT.R1 .AND. ABS(R1).LT.RC
     +     .AND. Y2.GT.0. .AND. Y1.LT.0.)THEN
         ALPHA = ACOS( ABS(R1)/RC )
         SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.)
         GOTO 999
      ENDIF
C...
      IF( X1.GT.R2 )THEN
        YR = -SQRT(RC*RC - R2*R2 )
        ALPHA = SQRT( (R2-X1)**2 + (YR-Y1)**2) / 2. / RC
        IF( ALPHA.LT.(1-0.1e-6) )THEN
         ALPHA = ASIN( ALPHA )
        ELSE
         ALPHA=1.570796
        ENDIF
        SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.) -
     +   0.5*ABS( (X1-R2)*( Y1 + (Y2-Y1)*(R2-X1)/(X2-X1) - YR ))
      ENDIF

      IF( X2.GT.R2 )THEN
        YR = SQRT(RC*RC - R2*R2 )
        ALPHA =  SQRT( (R2-X2)**2 + (YR-Y2)**2) / 2. / RC
        IF( ALPHA.LT.(1-0.1e-6) )THEN
         ALPHA = ASIN( ALPHA )
        ELSE
         ALPHA=1.570796
        ENDIF
        SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.) -
     +   0.5*ABS( (X2-R2)*( YR - Y1 - (Y2-Y1)*(R2-X1)/(X2-X1) ))
      ENDIF
C...
      IF( X1.LT.R1 )THEN
        YR = SQRT(RC*RC - R1*R1 )
        ALPHA = SQRT( (R1-X1)**2 + (YR-Y1)**2) / 2. / RC
        IF( ALPHA.LT.(1-0.1e-6) )THEN
         ALPHA = ASIN( ALPHA )
        ELSE
         ALPHA=1.570796
        ENDIF
        SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.) -
     +   0.5*ABS( (R1-X1)*( YR - Y1 - (Y2-Y1)*(R1-X1)/(X2-X1) ))
      ENDIF

      IF( X2.LT.R1 )THEN
        YR = -SQRT(RC*RC - R1*R1 )
        ALPHA =  SQRT( (R1-X2)**2 + (YR-Y2)**2) / 2. / RC
        IF( ALPHA.LT.(1-0.1e-6) )THEN
         ALPHA = ASIN( ALPHA )
        ELSE
         ALPHA=1.570796
        ENDIF
        SUM = SUM - RC*RC * ( ALPHA - SIN(2*ALPHA)/2.) -
     +   0.5*ABS( (R1-X2)*( Y1 + (Y2-Y1)*(R1-X1)/(X2-X1) - YR ))
      ENDIF

 999  RETURN

      END

************************************************************************
* End of CAFMLI
************************************************************************
