/************************************************************************
* GEOACT
* written by Siegmund Nowak, 30/08/95 09.18.12
*
* Description: Reads data card DETV from ASCII kumac file and selects
*              the short, long or user variant of a detector version
*
* called from  KUIP
***********************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/ZGESL.h"
#include "gean/ZGDETV.h"

extern "C" { char* ku_getc();   
static int  geoact_first=1;
void geoact_() {   
 
  char name[96]; 
  if(geoact_first) {
    arteMsg <<"The card DETV is valid only to install an user version i.e SIDU";
    arteMsg.warn();
    arteMsg <<"long/short selects should be made by an entry in gversxxxx.dat";
    arteMsg.warn();
    arteMsg <<"To force the magnet on/off use the card 'MAGN ON' or 'MAGN OFF'";
    arteMsg.warn();
    memset(name,' ',96);  
    strncpy(&name[3*LGESL_SIL-3],"SID",3);
    strncpy(&name[3*LGESL_SML-3],"SMD",3);
    strncpy(&name[3*LGESL_WCH-3],"WTD",3);
    strncpy(&name[3*LGESL_MSG-3],"MTD",3);
    strncpy(&name[3*LGESL_PTC-3],"PTL",3);
    strncpy(&name[3*LGESL_RIC-3],"RIC",3);
    strncpy(&name[3*LGESL_ECA-3],"CAL",3);
    strncpy(&name[3*LGESL_TAR-3],"TAR",3);
    strncpy(&name[3*LGESL_FLD-3],"FLD",3);
    strncpy(&name[3*LGESL_HOD1-3],"SZ0",3);
    strncpy(&name[3*LGESL_HOD2-3],"SZ1",3);
    strncpy(&name[3*LGESL_HOD3-3],"SZ2",3);
    strncpy(&name[3*LGESL_TRSL-3],"TRD",3);
    strncpy(&name[3*LGESL_RPOT-3],"RPO",3);
    strncpy(&name[3*LGESL_MAG-3] ,"MAG",3);
    strncpy(&name[3*LGESL_PPIP-3],"PPI",3);
    strncpy(&name[3*LGESL_EPIP-3],"EPI",3);
    strncpy(&name[3*LGESL_MUON-3],"MUD",3);
    geoact_first=0;       
  }
  char input[5],  text[60];
  strncpy(input,ku_getc(),4);
  input[4] = '\0';
  if(strlen(input)>0) {
    for(int i=0; i<32; i=i++) {
       if(!strncmp(&name[3*i],input,3)) {
          if(input[3] != 'U') {
             strcpy(text,input); 
             strcat(text, " DETV should be used only to select U");  
             arteMsg << text;
             arteMsg.warn();                     break;
          }
          else{   
             zgdetv_.DETV[i] = input[3];         break;
          }
       }
    }
  }
}}

/*   END    GEOACT    */




