
/************************************************************************
*
* GRADLN
* written by Siegmund Nowak, 30/12/94 10.45.29
*
* This routine calculates the radition length XMS for a material with
* volumen number IVO
*
*       called from geometry routines
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* IVOL       in           Geant volumen number
* XMS        out          Radiation length
************************************************************************/

#include "arte/arte.hh"
#include "gean/gclink.h"

extern "C" {

  void gradln_(const int &ivo, float &xms) {
    union { int ji; float jx;};
    int jvo = *(gcbank_.lq + gclink_.jvolum -1 - ivo);
    ji = *(gcbank_.iq + jvo+3); 
    int numed = int(jx);
    int jmd = *(gcbank_.lq + gclink_.jtmed -1 - numed);
    ji = *(gcbank_.iq + jmd + 5);
    int nmat = int(jx);
    int jmt = *(gcbank_.lq + gclink_.jmate -1 - nmat);
    ji = *(gcbank_.iq + jmt +8);
    xms = jx;
  }
}


