*CMZ :  3.01/00 27/08/96  13.03.26  by  Siegmund Nowak
*CMZ :  3.00/01 02/07/96  18.08.47  by  Siegmund Nowak
*-- Author :    Siegmund Nowak   16/03/95
************************************************************************
*
* KADGMD
* written by Siegmund Nowak, 30/08/95 09.18.12
*
* Description: Reads data card DGMOD from ASCII kumac file and selects
*              the short, long or user variant of a detector digitization
*
* called from  KUIP
*
* External references:
*
* Changes since last version: addition of more selection choices
*
************************************************************************

      SUBROUTINE KADGMD
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/ZGESL.fi"
      CHARACTER*4 DGMOD
      COMMON /DIGMOD/ DGMOD(20)
      INTEGER IWKSTY,IGIWTY,NPAR,IFIRST,J,LENGTH,IUCOMP
      CHARACTER CHPATL*32,INPUT1*4,INPUT2*4,GMOD(20)*4
      DATA IFIRST /0/
#include "arte/Arte.ff"

      IF(IFIRST.EQ.0) THEN
         CALL VFILL(GMOD ,20,'    ')
         CALL VFILL(DGMOD,20,'    ')
         GMOD (LGESL_SIL) = 'SID '
         DGMOD(LGESL_SIL) = 'SIDS'
         GMOD (LGESL_WCH) = 'WTD '
         DGMOD(LGESL_WCH) = 'WTDS'
         GMOD (LGESL_MSG) = 'MTD '
         DGMOD(LGESL_MSG) = 'MTDS'
         GMOD (LGESL_PTC) = 'PTL '
         DGMOD(LGESL_PTC) = 'PTLS'
         GMOD (LGESL_RIC) = 'RIC '
         DGMOD(LGESL_RIC) = 'RICS'
         GMOD (LGESL_TRD) = 'TRD '
         DGMOD(LGESL_TRD) = 'TRDS'
         GMOD (LGESL_ECA) = 'CAL '
         DGMOD(LGESL_ECA) = 'CALS'
         GMOD (LGESL_MUO) = 'MUD '
         DGMOD(LGESL_MUO) = 'MUDS'
         GMOD (LGESL_TAR) = 'TAR '
         DGMOD(LGESL_TAR) = 'TARS'
         GMOD (LGESL_FLD) = 'FLD '
         DGMOD(LGESL_FLD) = 'FLDS'
         GMOD (LGESL_HOD1) = 'SZ0 '
         DGMOD(LGESL_HOD1) = '   '
         GMOD (LGESL_HOD2) = 'SZ1'
         DGMOD(LGESL_HOD2) = '   '
         GMOD (LGESL_HOD3) = 'SZ2'
         DGMOD(LGESL_HOD3) = '   '
         IFIRST = 1
      ENDIF

 10   IWKSTY = IGIWTY(1)
      CALL KUPATL(CHPATL,NPAR)
*
      IF(NPAR.EQ.0) GO TO 999
      IF(CHPATL.EQ.'DGMOD') THEN
         CALL KUGETC(INPUT1,LENGTH)
         INPUT2 = INPUT1(1:3)
         INPUT2(4:4) = ' '
         J = IUCOMP(INPUT2,GMOD,20)
         IF(J.EQ.0.OR.J.GT.20) THEN
            C78 = 'IN THE DATA CARD DGMOD IS UNDEFINED:'
            CALL CH78BC(INPUT1)
            CALL ME78ER
            GO TO 999
         ELSE
            DGMOD(J) = INPUT1
         ENDIF
      ENDIF

 999  RETURN
      END

************************   END    GEOACT    *****************************




