        subroutine otrchm
******************************************************************
*
* Reads definition of OTR superlayer from text files
* and declare related Arte tables and Geant volumes.
*
* Called from otrgeo
*
* Author: Alexander Lanyov     Aug 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "auto/CON.fi"

#include "gean/otrgeo.fi"


        integer i,l,nmod,isec,ierr,readdir,iottz,iotts
        integer il,is,ip,iz,sec1,sec2,nsec,iy,iy1,iy2
        logical ebeam,shortmod
        save nmod

        real sinrot,cosrot,xrot,yrot,z,xlab,ylab,xp,yp,zp,xp_rot,yp_rot
        real xp_mo,yp_mo,zp_mo,xp_,yp_,xnew,ynew
        real xmin,xmax,ymin,ymax,zmin,zmax
        real xmin_lab,xmax_lab,ymin_lab,ymax_lab
        real xmin_de,xmax_de,ymin_de,ymax_de,zmin_de,zmax_de
        real xmin_des,xmax_des,ymin_des,ymax_des,zmin_des,zmax_des,ymid
        real sxmn_de,sxmx_de,symn_de,symx_de
        real xmin_mo,xmax_mo,ymin_mo,ymax_mo,zmin_mo,zmax_mo
        real xmin_ge,xmax_ge,ymin_ge,ymax_ge,zmin_ge,zmax_ge
        real ydivul(motlay,6),ydivdl(motlay,6)
        real d,pit,pit1,x1,x2,x1_,x2_,dx(5),dx1,dx2
        real xpin,ypin,angpar,ping_up,ping_down
        real par(10),xmsc,xms_tmp,tmp

        integer nwires,ncells,mcells,mcells_ge,dfi,dla,dfio,dlao
        integer ilay,ilay1,ilay2,il0,il1,il2,jl
        integer ndiv,idiv,ndiv0,idiv0,lastdiv

        integer inede,nvol,ivo,jvo,numed,jtm,nmat,imat
        integer ityp,ityp0,ityp_g,ityp_ge,laytyp,npar
        character modnam*8,secnam*11,modfile*120
        character modshape*4,nam*4,matnam*20,hwcname*12

        logical nowires,ldiv,ldummy


c Function types
        integer lenocc,iucomp,matnum,otrsec
        logical otrcomc

c required for icdeci (M432)
        integer nd,ne,nf,ng,num
        real dummy
        common /slate/ nd,ne,nf,ng,num(2),dummy(34)

        data nmod/0/              ! # of module definition loaded

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/CON.ff"


           nmodule = nmodule + 1

           if (buf(1:1).eq.'s'.and.ichar(buf(2:2)).ge.ichar('1')
     @                        .and.ichar(buf(2:2)).le.ichar('3'))
     @                     laynam(2:5) = buf(1:4)     ! For mini-superlayers: s1-2


           if (buf(1:4).eq.laynam(2:5)) then
              modnam(1:5) = laynam(:5)
              modnam(6:) = buf(5:7)             ! modnam = '-t2-3-01'
              read (modnam(7:8),*,err=99) i
              if (i.ne.nmodule .and. slname(1:1).eq.'m') then
               c78 = 'Missmatch in module number: '//modnam//', N(mod)='
                 call ch78ai(nmodule)
                 call meerro (c78)
              end if

              buf(:7) = 'module '
              ldummy = otrcomc('module',buf1,8)
              if (.not.ldummy) call meerro('Eror in module command')
           else
              if (slname(1:1).eq.'m') then
                 write (modnam,'(a,i2.2)') laynam//'-',nmodule
              else
                 modnam = laynam//'-00'
              end if
           end if

           angpar = 0.
           do i=1,len(buf1(1))
              if (buf1(1)(i:i).eq.'/') buf1(1)(i:i)='_'
           end do
           modtype = buf1(1)

           if (buf1(2)(2:2).eq.'c'
     @         .and.(buf1(2)(3:3).eq.'-' .or. buf1(2)(4:4).eq.'-')) then
              buf1(2) = buf1(3)
              buf1(3) = buf1(4)
              buf1(4) = buf1(5)
              buf1(5) = buf1(6)
           end if
           read (buf1(2),*,err=99) xpin
           read (buf1(3),*,err=99) ypin
           read (buf1(4),*,err=99) z

c------------------------------- Extract module information
           l = min(len(cotnam(1)),len(modtype))
           do imod=1,nmod
              if (cotnam(imod)(:l).eq.modtype(:l)) goto 30
           end do

           write (modfile,'(a)') modtype(:lenocc(modtype))//'.txt'

           nmod=nmod+1
           imod=nmod

           call otrmod(modfile,ierr)

           if (otdiam(imod).eq.0. .or. ierr.ne.0) then
              c78 = ' ? Module "'//modtype(:l)//'" not loaded'
              call me78wa

              nmod=nmod-1
              imod=nmod

              goto 100
           end if

           maxcell(imod) = 0
           do ilay=1,notlay(imod)
              do is=1,4                 ! is = sectors A,B,C,D
                 maxcell(imod) = max(maxcell(imod),notsew(ilay,is,imod))
              end do
           end do

30         continue
c----------------------------------------------- module found

c shortmod = short module above and below the beam
c            or some not complete module in the right half of PC,TC
           if (abs(otdist(imod)).lt.1.e-3) then
              shortmod = .true.
           else
              shortmod = .false.
           end if

c----------------------------------------------- Process coordinates
           xpin = 0.1 * xpin
           ypin = 0.1 * ypin
           z    = 0.1 * z

           xlab = xpin
           ylab = ypin

           if (otdisd .eq. 0.) then
              c78 = 'Illegal default pin distance:'
              call ch78bf(otdisd,-6)
              call ch78bc('cm.')
              call meerro(c78)
           end if

           if (otdist(imod) .gt. 0.
     @        .and. abs(otdist(imod)-otdisd) .gt. 1.e-3
     @        .and. abs(otdist(imod)-otdisds) .gt. 1.e-3) then
              c78 = 'Illegal pin distance:'
              call ch78bf(otdist(imod),-6)
              call ch78bc('cm, but default is')
              call ch78bf(otdisd,-6)
              if (otdisds.ne.0.) then
                 call ch78bc('or')
                 call ch78bf(otdisds,-6)
              end if
              call ch78bc('cm.')
              call meerro(c78)
           end if

c Calculate center of pins position from one pin position.
           d = 0.5 * otdisd
           if (ylab .lt. 0.) d = -d
           ylab = ylab - cosang * d
           xlab = xlab - sinang * d

c------------------------------------------------ Alignment corrections
           xlab = xlab + dalign(1)
           ylab = ylab + dalign(2)
           z    = z    + dalign(3)

           sinrot = sin(rotzwt(nsl))
           cosrot = cos(rotzwt(nsl))

c alignment rotation around Z axis
c          xnew =   xlab * cosrot + ylab * sinrot
c          ynew =  -xlab * sinrot + ylab * cosrot

c alignment rotation around a point with given X,Y-coordinates
           xnew = xref + (xlab-xref) * cosrot + (ylab-yref) * sinrot
           ynew = yref - (xlab-xref) * sinrot + (ylab-yref) * cosrot
           xlab = xnew
           ylab = ynew

           zstereo(iside,istereo) = min(z,zstereo(iside,istereo))
c-----------------------------------------------------------------------
c calculate distances Pin-G10 strip.
c (take into account that in database there are distances to G10 end,
c  not G10 middle line)
           if (slname.eq.'MC05') then
              ping_up = ping_mc5 - 0.5*dyg10
           else
              if (abs(otdiam(imod)-0.5).lt.1.e-3) then
                 ping_up = ping_st5 - 0.5*dyg10         ! 5-mm module
              else
                 ping_up = ping_st10 - 0.5*dyg10        ! 10-mm module
              end if
           end if

           ping_down = ping_up
           if (slname(1:1).eq.'M'
     @     .and. ichar(slname(4:4)).gt.ichar('2') .and. iside.eq.1) then
              if (abs(otdiam(imod)-0.5).lt.1.e-3) then
                 ping_down = ping_sp5 - 0.5*dyg10       ! 5-mm module
              else
                 ping_down = ping_sp10 - 0.5*dyg10      ! 10-mm module
              end if
           end if

           if (ping_up.eq.0) then
              ping_up = 100.
           end if
           if (ping_down.eq.0) then
              ping_down = 100.
           end if

           xrot =  xlab * cosang - ylab * sinang        ! lab --> rot
           yrot = +xlab * sinang + ylab * cosang

           if (abs(angle).gt.100.) then
              c78 = 'No HALF command was given (angle is undefined)'
              call meerro (c78)
           end if

        sec1 =  100
        sec2 = -100

        if (otg10p(1,1,imod).ne.0.
     @.and. otg10p(1,2,imod).ne.0.
     @.and. otg10p(1,3,imod).ne.0.) then
           sec1=1
           sec2=4
        end if

        do ilay=1,notlay(imod)
           do is=1,4                 ! is = sectors A,B,C,D
              if (notsew(ilay,is,imod).ne.0
     @       .or. notnsw(ilay,is,imod).ne.0 ) then
                 sec1 = min(sec1,is)
                 sec2 = max(sec2,is)
              end if
           end do
        end do
        nsec = sec2-sec1+1

        if (sec1.ne.1 .and. .not.shortmod) then
           c78 = 'Illegal sector number for short modules: sec1 ='
           call ch78bi(sec1)
           call ch78ac(', sec2 =')
           call ch78bi(sec2)
           call meerro(c78)
        end if

c mc5-101, mc5-102 should be not rotated
        if (iside.eq.1 .or. modtype(:6).eq.'mc5-10') then  ! ======= right side or 97 run
           do ilay=1,notlay(imod)
              do iy=1,2                 ! iy = y>0, y<0
                 ttcefi(ilay,iy,imod) = otcefi(ilay,iy,imod)
                 ttcela(ilay,iy,imod) = otcela(ilay,iy,imod)
                 if (ttcefi(ilay,iy,imod).gt.otcela(ilay,iy,imod)) then
                    tmp = ttcela(ilay,iy,imod)
                    ttcela(ilay,iy,imod) = ttcefi(ilay,iy,imod)
                    ttcefi(ilay,iy,imod) = tmp
                 end if
              end do

              do iy=1,2                 ! iy = y>0, y<0
                 ttwifi(ilay,iy,imod) = min(ttcefi(ilay,1,imod),
     @                                      ttcefi(ilay,2,imod))
                 ttwila(ilay,iy,imod) = max(ttcela(ilay,1,imod),
     @                                      ttcela(ilay,2,imod))
              end do

              do is=1,nsec                 ! is = sectors A,B,C,D
                 if (notsew(ilay,is+sec1-1,imod).eq.0
     @         .and. fotsew(ilay,is+sec1-1,imod).eq.0) then
                    nttsew(ilay,is,imod) = 0
                    fttsew(ilay,is,imod) = 0
                 else
                    fttsew(ilay,is,imod) =
     @                   maxcell(imod) + 1 - notsew(ilay,is+sec1-1,imod)

                    nttsew(ilay,is,imod) =
     @                   maxcell(imod) + 1 - fotsew(ilay,is+sec1-1,imod)
                 end if
              end do

              do ip=1,3                 ! ip = up,mid,down
                 ttg10p(ilay,ip,imod) = otg10p(ilay,ip,imod)
              end do
              do ip=1,6                 ! ip = up:a,b,c, down:a,b,c
                 ttsupp(ilay,ip,imod) = otsupp(ilay,ip,imod)
              end do
           end do
           nttcht(imod) = notcht(imod)
           nttchb(imod) = notchb(imod)

        else if (iside.eq.-1) then      ! =============== left side

           do ilay=1,notlay(imod)
              do iy=1,2                 ! iy = y>0, y<0
                 ttcela(ilay,iy,imod) = otcefi(ilay,3-iy,imod) * iside
                 ttcefi(ilay,iy,imod) = otcela(ilay,3-iy,imod) * iside
                 if (ttcefi(ilay,iy,imod).gt.otcela(ilay,iy,imod)) then
                    tmp = ttcela(ilay,iy,imod)
                    ttcela(ilay,iy,imod) = ttcefi(ilay,iy,imod)
                    ttcefi(ilay,iy,imod) = tmp
                 end if
              end do

              do iy=1,2
                 ttwifi(ilay,iy,imod) = min(ttcefi(ilay,1,imod),
     @                                      ttcefi(ilay,2,imod))
                 ttwila(ilay,iy,imod) = max(ttcela(ilay,1,imod),
     @                                      ttcela(ilay,2,imod))
              end do

              do is=1,nsec                 ! is = sectors A,B,C,D
                 nttsew(ilay,is,imod)=notsew(ilay,sec2+1-is,imod)
                 fttsew(ilay,is,imod)=fotsew(ilay,sec2+1-is,imod)
              end do

              do ip=1,3                 ! ip = up,mid,down
                 ttg10p(ilay,ip,imod) = otg10p(ilay,4-ip,imod) * iside
              end do
              do ip=1,6                 ! ip = up:a,b,c, down:a,b,c
                 ttsupp(ilay,ip,imod) = otsupp(ilay,ip,imod) * iside
              end do
           end do

           if (cotsid(1,imod)(1:1).ne.' '
     @   .and. cotsid(2,imod)(1:1).ne.' ') then
              nttchb(imod) = notcht(imod)  ! up side down
              nttcht(imod) = notchb(imod)
           else
              nttcht(imod) = notcht(imod)  ! identical copy
              nttchb(imod) = notchb(imod)
           end if

        else
           c78 = 'Illegal iside ='
           call ch78bi(iside)
           call meerro(c78)
        end if

        if (shortmod) then  ! module with only one pin
           if (ypin.gt.0.) then         ! only top pin
              nttcht(imod) = notcht(imod) + notchb(imod)
              nttchb(imod) = 0
           else if (ypin.lt.0.) then    ! only bottom pin
              nttcht(imod) = 0
              nttchb(imod) = notcht(imod) + notchb(imod)
           end if
        end if



c---------------------- In MC05 all modules have baseplate upstream.
c   Therefore one should rotate module around Y axis and modify Z coordinate
        if (slname.eq.'MC05') then

           z = z - 0.5 * (notlay(imod)+1) * otdiam(imod)
           do iy=1,2
              do ilay=1,notlay(imod)/2

                 tmp = -ttcela(notlay(imod)+1-ilay,iy,imod)
                 ttcela(notlay(imod)+1-ilay,iy,imod) =
     @                 -ttcefi(ilay,iy,imod)
                 ttcefi(ilay,iy,imod) = tmp

                 tmp = -ttcefi(notlay(imod)+1-ilay,iy,imod)
                 ttcefi(notlay(imod)+1-ilay,iy,imod) =
     @                 -ttcela(ilay,iy,imod)
                 ttcela(ilay,iy,imod) = tmp

                 tmp = -ttwila(notlay(imod)+1-ilay,iy,imod)
                 ttwila(notlay(imod)+1-ilay,iy,imod) =
     @                 -ttwifi(ilay,iy,imod)
                 ttwifi(ilay,iy,imod) = tmp

                 tmp = -ttwifi(notlay(imod)+1-ilay,iy,imod)
                 ttwifi(notlay(imod)+1-ilay,iy,imod) =
     @                 -ttwila(ilay,iy,imod)
                 ttwila(ilay,iy,imod) = tmp
              end do
           end do

           do is=1,nsec
              do ilay=1,notlay(imod)/2
                 if (nttsew(ilay,is,imod).ne.0
     @         .and. fttsew(ilay,is,imod).ne.0
     @         .and. nttsew(notlay(imod)+1-ilay,is,imod).ne.0
     @         .and. fttsew(notlay(imod)+1-ilay,is,imod).ne.0) then

                   tmp =
     @             maxcell(imod)-nttsew(notlay(imod)+1-ilay,is,imod)+1
                                 nttsew(notlay(imod)+1-ilay,is,imod) =
     @             maxcell(imod)-fttsew(ilay,is,imod)+1
                                 fttsew(ilay,is,imod) = tmp

                   tmp =
     @             maxcell(imod)-fttsew(notlay(imod)+1-ilay,is,imod)+1
                                 fttsew(notlay(imod)+1-ilay,is,imod) =
     @             maxcell(imod)-nttsew(ilay,is,imod)+1
                                 nttsew(ilay,is,imod) = tmp

                 else if (nttsew(ilay,is,imod).eq.0
     @              .and. fttsew(ilay,is,imod).eq.0
     @              .and. nttsew(notlay(imod)+1-ilay,is,imod).eq.0
     @              .and. fttsew(notlay(imod)+1-ilay,is,imod).eq.0) then

                    continue

                 else if (nttsew(ilay,is,imod).eq.0
     @              .and. fttsew(ilay,is,imod).eq.0) then

                    nttsew(ilay,is,imod) =
     @              maxcell(imod)-fttsew(notlay(imod)+1-ilay,is,imod)+1
                    fttsew(ilay,is,imod) =
     @              maxcell(imod)-nttsew(notlay(imod)+1-ilay,is,imod)+1

                    nttsew(notlay(imod)+1-ilay,is,imod) = 0
                    fttsew(notlay(imod)+1-ilay,is,imod) = 0

                 else if (nttsew(notlay(imod)+1-ilay,is,imod).eq.0
     @              .and. fttsew(notlay(imod)+1-ilay,is,imod).eq.0) then

                    nttsew(notlay(imod)+1-ilay,is,imod) =
     @              maxcell(imod)-fttsew(ilay,is,imod)+1
                    fttsew(notlay(imod)+1-ilay,is,imod) =
     @              maxcell(imod)-nttsew(ilay,is,imod)+1

                    nttsew(ilay,is,imod) = 0
                    fttsew(ilay,is,imod) = 0

                 else
                    call meerro('Illgeal nttsew/fttsew in MC05')
                 end if
              end do
           end do

           do ip=1,3
              do ilay=1,notlay(imod)/2
                 tmp = ttg10p(notlay(imod)+1-ilay,ip,imod)
                 ttg10p(notlay(imod)+1-ilay,ip,imod) =
     @              ttg10p(ilay,ip,imod)
                 ttg10p(ilay,ip,imod) = tmp
              end do
           end do

           do ip=1,6
              do ilay=1,notlay(imod)/2
                 tmp = ttsupp(notlay(imod)+1-ilay,ip,imod)
                 ttsupp(notlay(imod)+1-ilay,ip,imod) =
     @              ttsupp(ilay,ip,imod)
                 ttsupp(ilay,ip,imod) = tmp
              end do
           end do
        end if

c-----------------------------------------------
c Find out the volume division over y axis
c (maximum 4 volumes are possible).
c Division is made by dividing G10 strips.
c-----------------------------------------------

        if (nttcht(imod).eq.0 .and. nttchb(imod).eq.0)
     @               call meerro('Both nttcht and nttchb are zero')

        if (shortmod
     @     .and. nttcht(imod).ne.0 .and. nttchb(imod).ne.0 ) then
           c78 = 'Illegal: no pin distance,'//
     @           ' but both top and bottom channels'
           call meerro(c78)
        end if

        ndiv=1          ! ndiv will denote number of initialized divisions on y

        do ilay=1,notlay(imod)
           if (.not.shortmod) then
              ydivul(ilay,ndiv) = 0.5*otdisd - ping_up            ! normal module
           else if (ypin.gt.0.) then
              ydivul(ilay,ndiv) = 0.5*otdisd - ping_up            ! top pin
           else if (ypin.lt.0.) then
              ydivul(ilay,ndiv) = ttg10p(ilay,3,imod)             ! bottom pin
           end if
        end do

        lastdiv = 3
        if (shortmod) lastdiv = min(nsec-1,2)

        do idiv=1,lastdiv
           ldiv = .false.
           do ilay=1,notlay(imod)
              if (ttg10p(ilay,idiv,imod).ne.0.
     @            .and. (.not.ignore_g10(imod))) ldiv = .true.
           end do
           if (ldiv) then
              do ilay=1,notlay(imod)
                 ydivdl(ilay,ndiv  ) = ttg10p(ilay,idiv,imod)
                 ydivul(ilay,ndiv+1) = ttg10p(ilay,idiv,imod)
              end do
              ndiv = ndiv+1
           end if
        end do

        do ilay=1,notlay(imod)
           if (.not.shortmod) then                                ! normal module
              ydivdl(ilay,ndiv) = -0.5*otdist(imod) + ping_down
           else if (ypin.gt.0.) then                              ! top pin
              ydivdl(ilay,ndiv) = ttg10p(ilay,ndiv,imod)
           else if (ypin.lt.0.) then                              ! bottom pin
              ydivdl(ilay,ndiv) = - 0.5*otdisd + ping_down
           end if
        end do

c If ttg10p=0, then this position is not used for declaring wires.
c But it will be still used for ymin,ymax, so fill it with reasonable information
        do idiv=1,ndiv
           do ilay=1,notlay(imod)

              if (ydivdl(ilay,idiv).eq.0.) then
                 do i=1,notlay(imod)
                    if (ydivdl(i,idiv).ne.0.) then
                       ydivdl(ilay,idiv) = ydivdl(i,idiv)
                       goto 91
                    end if
                 end do
 91              continue
              end if

              if (ydivul(ilay,idiv).eq.0.) then
                 do i=1,notlay(imod)
                    if (ydivul(i,idiv).ne.0.) then
                       ydivul(ilay,idiv) = ydivul(i,idiv)
                       goto 92
                    end if
                 end do
 92              continue
              end if

           end do
        end do

        ebeam = .false.
        do ip=1,2
           do il=1,notlay(imod)
              if (otbeam(il,ip,imod) .ne. 0) ebeam = .true.
           end do
        end do

        ndiv0 = ndiv
        if (ebeam) then
           ndiv = ndiv+2
           do ilay=1,notlay(imod)
              ydivul(ilay,ndiv  ) = otbeam(ilay,2,imod)
              ydivdl(ilay,ndiv  ) = ydivdl(ilay,ndiv-2)

              ydivul(ilay,ndiv-1) = otbeam(ilay,1,imod)
              ydivdl(ilay,ndiv-1) = otbeam(ilay,2,imod)

              ydivdl(ilay,ndiv-2) = otbeam(ilay,1,imod)
           end do
        end if

c---------- Extract trailing empty monolayers - they will be declared as walls.
        il1=100
        il2=-1
        do jl=1,notlay(imod)
           nowires=.true.
           do is=1,nsec
              if (nttsew(jl,is,imod).ne.0) nowires=.false.
           end do
           if (.not.nowires) il1=min(il1,jl)
           if (.not.nowires) il2=max(il2,jl)
        end do

        if ((il2-il1).gt.3 .or. (il2-il1).lt.0) then
           c78 = 'Module "'
           call ch78ac(modtype(:lenocc(modtype)))
           call ch78ac('" has illegal number of monolayers:')
           call ch78ai(il2-il1+1)
           call meerro(c78)
        end if

        if (lhadec) then
           if (il2-il1.gt.2 .and.mod(iq(iqnesl_ltyp(currsl)),10).le.2)
     @     iq(iqnesl_ltyp(currsl)) = iq(iqnesl_ltyp(currsl)) + 3 ! layer types/sequences
           lhadec = .false.
        end if

c----- Form volume index ITYP
c--1     10 mm single layer    sensitive
c--2      5 mm single layer    sensitive
c--3      5 mm single layer nonsensitive
c--4     10 mm double layer    sensitive
c--5      5 mm double layer    sensitive
c--6      5 mm double layer nonsensitive
c
c--7     10 mm single layer    sensitive in magnetic field
c--8      5 mm single layer    sensitive in magnetic field
c--9      5 mm single layer nonsensitive in magnetic field
c
c--10    10 mm double layer    sensitive in magnetic field
c--11     5 mm double layer    sensitive in magnetic field
c--12     5 mm double layer nonsensitive in magnetic field

        pit1=otdiam(imod)*sqrt(3.)      ! ideal-geometry pitch

        if (otdiam(imod).eq.1.) then
           ityp0 = 1            ! sensitive wires (10 mm)
           pit = 1.74
        else if (otdiam(imod).eq.0.5) then

c          if (sense_wires) then
              ityp0 = 2         ! sensitive wires (5 mm)
c          else
c             ityp0 = 3         ! nonsensitive wires (5 mm)
c          end if

           pit = 0.87

        else
           c78 = 'Wrong OTR cell diameter:'
           call ch78bf(otdiam(imod),-2)
           call ch78ac(' cm')
           call meerro (c78)
        end if

        if (notlay(imod).le.2) then
           laytyp = 0      ! single layers
        else
           laytyp = 1      ! double layers
        end if

        ityp = 6*imflag + 3*laytyp + ityp0
        if (ityp.le.0 .or. ityp.gt.12) then
           c78 = 'Illegal ITYP = '
           call ch78bi(ityp)
           call atstop(c78)
        end if

        if (abs(pit/pit1-1.).gt.0.005) then
          c78 = 'For module "'//modtype(:lenocc(modtype))//'"'
             call ch78ac(', monolayer # ')
             call ch78ai(il0)
             call ch78ac(' Ideal pitch = ')
             call ch78af(pit1,-4)
             call ch78ac(' and real pitch = ')
             call ch78af(pit,-4)
          call meerro(c78)
        end if

c---------------------- loop on subvolumes (NEDE volumes)
        xmin_mo = 1.e10 ! big positive number
        xmax_mo =-xmin_mo
        ymin_mo = xmin_mo
        ymax_mo = xmax_mo
        zmin_mo = xmin_mo
        zmax_mo = xmax_mo
        mcells=0


        do idiv=1,ndiv          ! division on y

          call mmbook(jnede,1)

          inede = nnede()
          if (idiv.eq.1) inede1=inede

          iq(iqnede_nwl_l())=0  ! number of walls connected to this detector
          iq(iqnede_fwl_l())=0  ! first wall connected to this detector

          if (inede.eq.inede1) then
             if (iq(iqnede_fwl(inede1)).eq.0)
     @            iq(iqnede_fwl(inede1)) = nnwal() + 1
             if (iq(iqnesl_fwl(currsl)).eq.0)
     @            iq(iqnesl_fwl(currsl)) = nnwal() + 1
          end if

          call mmbrel(jnsnd,currsl,inede)

          if (inesl_fpl(currsl).eq.0) iq(iqnesl_fpl(currsl)) = inede ! 1. plane
          iq(iqnesl_npl(currsl)) = inesl_npl(currsl) + 1             ! # of planes

          iq(iqnede_cmp_l())=lgesl_wch  ! detector component
          iq(iqnede_lay_l())=istereo    ! layer number within the superlayer

          q(qnede_pit(inede))=pit       ! pitch

          q(qnede_cos_l())= 1.  ! cos of the wire angle with respect to y-axis
          q(qnede_sin_l())= 0.

c copy 3x3 rotation matrix, transposing it
        jrot = lq(jrotm-irot)
        if (jrot.eq.0) call meerro ('OTRCHM: illegal rot.matrix!')
        q(qnede_rot(1,inede)) = q(jrot+1)
        q(qnede_rot(2,inede)) = q(jrot+4)
        q(qnede_rot(3,inede)) = q(jrot+7)
        q(qnede_rot(4,inede)) = q(jrot+2)
        q(qnede_rot(5,inede)) = q(jrot+5)
        q(qnede_rot(6,inede)) = q(jrot+8)
        q(qnede_rot(7,inede)) = q(jrot+3)
        q(qnede_rot(8,inede)) = q(jrot+6)
        q(qnede_rot(9,inede)) = q(jrot+9)

c-- Use some global file for this stuff? (or possibly local files also?)
       !q(qnede_acc_l()) = SIGWT(1)     ! measurement accuracy
        q(qnede_acc_l()) = 0.02         ! measurement accuracy

       !q(qnede_eff_l()) = EFFWT        ! hit efficiency
        q(qnede_eff_l()) = 0.98         ! hit efficiency

       !q(qnede_dod_l()) = 0.5*otdiam(imod) - 0.01 ! max drift distance
        q(qnede_dod_l()) = 0.3*pit                 ! max drift distance

        iq(iqnede_nsl_l())=il2-il1+1    ! number of sublayers in a segment

        xmin_de = 1.e10 ! big positive number
        xmax_de =-xmin_de
        ymin_de = xmin_de
        ymax_de = xmax_de
        zmin_de = xmin_de
        zmax_de = xmax_de

        xmin_des = xmin_de    ! point to sensitive volume only
        xmax_des = xmax_de
        ymin_des = ymin_de
        ymax_des = ymax_de
        zmin_des = zmin_de
        zmax_des = zmax_de

        do ilay=1,4
           iq(iqnede_nwi(ilay,inede))=0
        end do
        ilay = 0

        do il0=il1,il2    ! loop on monolayers
           il = il0-il1+1

c Here il0 = 2..5 - index for Module type arrays,
c      il  = 1..4 - index for NEDE banks.

c These are coordinates of NEDE volume in rotated system

           ymin = yrot + ydivdl(il0,idiv)
           ymax = yrot + ydivul(il0,idiv)

           ymid = 0.5*(ymin + ymax)
           if (ymid.gt.0.) then
              iy=1
           else
              iy=2
           end if

           x1 = ttcefi(il0,iy,imod)
           x2 = ttcela(il0,iy,imod)
c xmin, xmax set the bottom and the upper cell centers of cell row
           xmin = xrot + x1
           xmax = xrot + x2
           dx(il) = x2-x1

           if (xmin.ge.xmax) then
              c78 = 'For idiv='
              call ch78ai(idiv)
              call ch78ac(', il0=')
              call ch78ai(il0)
              call ch78ac(' xmin =')
              call ch78bf(xmin,-3)
              call ch78ac(', xmax =')
              call ch78bf(xmax,-3)
              call me78wa
           end if

c These are exact borders for this monolayer
           zmin = z + 0.5*(il0-1)*otdiam(imod)
           zmax = z + 0.5*(il0+1)*otdiam(imod)

c idiv  - index for ydivul, ydivdl
c idiv0 - index for module type arrays

           idiv0 = min(idiv,ndiv0)
           if (idiv.eq.3 .and. nsec.eq.4 .and. ndiv.eq.3
     @         .and. ttg10p(1,2,imod).eq.0.
     @         .and. ttg10p(3,2,imod).eq.0.) then
              idiv0 = 4
           end if

           if (modtype(:lenocc(modtype)).eq.'mc8-5d24-22'
     @      .and. idiv0.eq.2) then
              idiv0 = 3
           end if

           if (ttwifi(il0,iy,imod).ne.0.
     @         .and. fttsew(il0,idiv0,imod).ne.0) then

c Narrow modules at e-beam pipe place (they are without wires here!)
c e.g. for PC[14] TC[12], module [pt]c-5d24-31*
c      also pc-5d32-51* ?
              if (idiv.eq.ndiv0+1
     @      .and. (nttsew(il0,idiv0,imod).le.24
     @             .or. modtype(:10).eq. 'pc-5d32-51')) then
                 goto 20
              end if

              ilay = ilay + 1
              nwires = 1 + nttsew(il0,idiv0,imod)-fttsew(il0,idiv0,imod)
              iq(iqnede_nwi(ilay,inede)) = nwires

              if (nwires.le.1) then
                 c78 = 'Illegal nwires ='
                 call ch78bi(nwires)
                 call ch78bc('for inede =')
                 call ch78bi(inede)
                 call ch78ac(', ilay =')
                 call ch78bi(ilay)
                 call meerro (c78)
              end if

              q(qnede_xfw(ilay,inede)) = xrot + ttwifi(il0,iy,imod)
     @                               + (fttsew(il0,idiv0,imod)-1)*pit
              q(qnede_zfw(ilay,inede)) = z + 0.5*il0*otdiam(imod)

              q(qnede_y1w(ilay,inede)) = ymin
              q(qnede_y2w(ilay,inede)) = ymax

c########################################################
c              xmin_des = min(xmin, xmin_des)
c              xmax_des = max(xmax, xmax_des)

              if (ttwifi(il0,iy,imod) .gt. ttwila(il0,iy,imod)) then
                 call meerro('OTRCHM: ttwifi > ttwila')
              end if

              xmin_des = min(fnede_xfw(ilay,inede), xmin_des)
              xmax_des = max(fnede_xfw(ilay,inede)+(nwires-1)*pit,
     @                                              xmax_des)
c########################################################

              ymin_des = min(ymin, ymin_des)
              ymax_des = max(ymax, ymax_des)
              zmin_des = min(zmin, zmin_des)
              zmax_des = max(zmax, zmax_des)

           end if
20         continue

           d = abs(ttcela(il0,iy,imod) - ttcefi(il0,iy,imod))
           d = x2 - x1
           ncells = int(d/pit1 + 1.5)
           mcells = max(mcells,ncells)          ! not needed now?
           if (ncells.gt.1 .and. d.gt.0.
     @      .and. abs(pit-d/(ncells-1)).gt.1.e-6) then
              call meerro('Something wrong with pitch')
           end if


c=======================================================================
c The following borders are calculated in rotated (with module) frame:
c
c xmin    - monolayer
c xmin_de - NEDE volume
c sxmn_de - sensitive NEDE volume
c xmin_mo - module (several NEDEs)
c xmin_mo - Geant volume (for common module xmin_mo=xmin_ge)
c
c The following sizes are in laboratory frame:
c
c xmin_all - SL - only modules volumes (used for finding positions of walls)
c xmin_sl  - SL Geant volume - should contain everything including walls
c                 (got from database)
c xmin_box - empty box inside walls
c                 (calculated and used inside wall routines)
c=======================================================================

c Now xmin, xmax set the bottom and the upper conners of cell row
           xmin = xmin - pit/3.
           xmax = xmax + pit/3.

           xmin_de = min(xmin,xmin_de)
           xmax_de = max(xmax,xmax_de)
           ymin_de = min(ymin,ymin_de)
           ymax_de = max(ymax,ymax_de)
           zmin_de = min(zmin,zmin_de)
           zmax_de = max(zmax,zmax_de)

           xmin_mo = min(xmin,xmin_mo)
           xmax_mo = max(xmax,xmax_mo)
           ymin_mo = min(ymin,ymin_mo)
           ymax_mo = max(ymax,ymax_mo)
           zmin_mo = min(zmin,zmin_mo)
           zmax_mo = max(zmax,zmax_mo)

c Now xmin, xmax set the bottom and top corners
c  of GEANT VOLUME (parallelepiped or trapezoid)
           xmin = xmin - 2./3.*pit
           xmax = xmax + 2./3.*pit

c rot --> lab
           xmin_lab =  xmin * cosang + min(ymin * sinang, ymax * sinang)
           xmax_lab =  xmax * cosang + max(ymin * sinang, ymax * sinang)
           ymin_lab = - max(xmin * sinang, xmax * sinang) + ymin*cosang
           ymax_lab = - min(xmin * sinang, xmax * sinang) + ymax*cosang

           xmin_all = min(xmin_lab,xmin_all)
           xmax_all = max(xmax_lab,xmax_all)
           ymin_all = min(ymin_lab,ymin_all)
           ymax_all = max(ymax_lab,ymax_all)
           zmin_all = min(zmin,zmin_all)
           zmax_all = max(zmax,zmax_all)

           if (il0.lt.il2
     @   .and. ttcefi(il0  ,iy,imod) .ne. 0.
     @   .and. ttcefi(il0+1,iy,imod) .ne. 0.) then

              dfio = dfi
              dlao = dla

              dfi =
     @  nint((ttcefi(il0+1,iy,imod) - ttcefi(il0,iy,imod))/(0.5*pit))
              dla =
     @  nint((ttcela(il0+1,iy,imod) - ttcela(il0,iy,imod))/(0.5*pit))

              if (il0 .gt. il1) then
                 if (dfi.ne.dfio .or. dla.ne.dlao) then
                    write (c78,*)'Non-standard geometry:',
     @                      ' module = ',modtype(:lenocc(modtype)),
     @                      ' idiv=',idiv,', il0=',il0,', iy=',iy
                     call meerro(c78)
                 end if
              end if

              if (dfi.eq.dla) then
                 modshape = 'PARA'
                 if (dfi.lt.0.) then
                    angpar = -60.
                 else
                    angpar = +60.
                 end if
              else if (dfi.eq.-dla) then
                 modshape = 'TRD1'
              else
                 modshape = 'Unknown'
                 c78 = 'Unknown module shape: dfi ='
                 call ch78bi(dfi)
                 call ch78ac(', dla =')
                 call ch78bi(dla)
                 call meerro(c78)
              end if

           end if

        end do                  ! loop on monolayers

c detector shape: 1-box, 2-TRD1, 10-parallelepiped
c 42 - another parallelepiped,  34 - another TRD1
        if (modshape.eq.'PARA') then
           iq(iqnede_shp_l()) = 42
        else if (modshape.eq.'TRD1') then
           iq(iqnede_shp_l()) = 2
        else
           c78 = 'Unknown module shape for inede ='
           call ch78bi(inede)
           call meerro(c78)
        end if

        iq(iqnede_nsl_l()) = ilay

        if (ilay.gt.0) then
c--- Book a new OTMO table - only for GEDEs with sense wires.
           call mmbook(jotmo,1)
        end if

c Rotate coordinates
        xp_ = 0.5*(xmin_de+xmax_de)
        yp_ = 0.5*(ymin_de+ymax_de)
        ynew = -sinang * xp_ + cosang * yp_  ! rot --> lab (only for y)
        if (ilay.ne.0) then
           isec = otrsec(xp_,ynew,nsec)
        else
           isec = 0
        end if

        iq(iqnede_sec_l()) = isec       ! sector number

        if (isec.ne.0) then
             secnam(:9) = modnam // '-'             ! secnam  = '-t2-3-20-12'
             write (secnam(10:11),'(i2.2)') isec
             hwcname = secnam//' '

             if (ndiv.ne.ndiv0 .and. idiv.ge.ndiv0) then
                hwcname(12:12) = char(ichar('a')+idiv-ndiv0)
             end if

        else
           hwcname = 'none'
        end if
        call uctoh(hwcname, iq(hqnede_hwc_l(1)), 12,12)

        q(qnede_xmin_l()) = xmin_de - 2./3.*pit
        q(qnede_xmax_l()) = xmax_de + 2./3.*pit

        q(qnede_ymin_l()) = ymin_de
        q(qnede_ymax_l()) = ymax_de
        q(qnede_zmin_l()) = zmin_de
        q(qnede_zmax_l()) = zmax_de

c Fill sensitive volume borders only on the volume with sense wires
        sxmn_de = xmin_des - pit/3.
        sxmx_de = xmax_des + pit/3.
        symn_de = ymin_des + 0.5*(ydg10+dyg10)
        symx_de = ymax_des - 0.5*(ydg10+dyg10)

c Uncomment this if you want to fill borders on the volume of all cells
c (even without wires)
c        sxmn_de = xmin_de
c        sxmx_de = xmax_de
c        symn_de = ymin_de + 0.5*(ydg10+dyg10)
c        symx_de = ymax_de - 0.5*(ydg10+dyg10)

c If there are no sense wires in this GEDE, leave borders zero
        if (abs(sxmn_de).lt.100000.) then
           q(qnede_sxmn_l()) = sxmn_de ! x of the left edge of sensitive area
           q(qnede_sxmx_l()) = sxmx_de ! right
           q(qnede_symn_l()) = symn_de ! y left
           q(qnede_symx_l()) = symx_de ! y right
        end if

           if (symn_de.ge.symx_de
     @  .and. abs(symn_de).lt.100000.) then
              c78 = 'Wrong sensitive volume borders on Y:'
              call me78sp('T')
              c78 = 'symn_de ='
              call ch78bf(symn_de,-4)
              call ch78ac(', symx_de = ')
              call ch78af(symx_de,-4)
              call meerro(c78)
           end if

c------------- Put reference for material
        call uhtoc(wtdt(ityp),4,nam,4)
        ivo = iucomp (nam, iq(jvolum+1), iq(jvolum-1))
        if (ivo.eq.0)  call meerro('Nonvalid volume'//nam)
        jvo = lq(jvolum-ivo)
        if (jvo.eq.0) then
           c78 = 'jvo = 0 for wtdt = '//nam//', ivo = '
           call ch78bi(ivo)
           call me78er
        endif

c According to proposal of S.Nowak, GVOL is filled always. 16.07.99.
c        if (inede.eq.inede1 .or. idiv.gt.idiv0) then
           iq(hqnede_gvol_l()) = wtdt(ityp)
c        else
c           call uctoh('    ', iq(hqnede_gvol_l()), 4,4)
c        end if

        iq(iqnede_gcop_l()) = inede1
        if (idiv .gt. ndiv0) iq(iqnede_gcop_l()) = inede

        numed = q(jvo+4)                ! numed  The same as tracking medium?
        jtm = iq(jtmed-numed-8)         ! jtm = lq(jtmed-numed)
        if (jtm.eq.0) then
           c78 = 'Illegal jvo ='
           call ch78bi(jtm)
           call me78er
        endif

        nmat = q(jtm+6)                 ! material # in Geant
        call uhtoc(q(iq(jmate-nmat-8)+1),4,matnam,20)

        imat = matnum(matnam(1:lenocc(matnam))) ! material # in Arte
        call mmbrel(jgmnd,imat,inede)

c Multiple scattering angle for 1 GeV particles
        xms_tmp = fgmat_radl(imat)
        if (xms_tmp.eq.0.) CALL MEERRO('OTRCHM: Wrong XMS')
        xmsc = (zmax_de-zmin_de)/xms_tmp
        if (xmsc.le.0.) CALL MEERRO('OTRCHM: Wrong XMSC')
        q(qnede_ms_l()) = xmsc*(0.0136*(1.+0.038*log(xmsc)))**2

c Fill angle of parallelepiped (fnede_xmad) in degrees
       if (modshape .eq. 'PARA') then
          q(qnede_xmad_l())= tan(degrad*angpar)   ! angle of PARA: +-60 degrees
       else if (modshape .eq. 'TRD1') then
          q(qnede_xmad_l())= 0.
       end if

c Fill angle of NEDE bank borders: upper (fnede_ymad) and lower (fnede_zmad).
c Unit is degrees.
       q(qnede_ymad_l()) = 0.
       q(qnede_zmad_l()) = 0.
       if (fltmod(imod).eq.2) then
          if (idiv.gt.1 .and. idiv.le.ndiv0)
     @       q(qnede_ymad_l()) = tan(degrad*angle)
          if (idiv.lt.ndiv0)
     @       q(qnede_zmad_l()) = tan(degrad*angle)
       end if


c---------- Now decide where this vertical section is read from: top or bottom
             if (ymid.ge.0.) then
                readdir = 1
             else
                readdir = -1
             end if

             if (nttcht(imod).ne.0 .and. nttchb(imod).eq.0) then
                readdir = 1
             else if (nttcht(imod).eq.0 .and. nttchb(imod).ne.0) then
                readdir = -1

c===== This was introduced for modules where sector C is read from top!!!
c i.e. for PC and TC, modules [pt]c-5d24-31* and pc-5s24-61*
             else if (nttcht(imod).ne.0 .and. nttchb(imod).ne.0
     @               .and. idiv.eq.3 .and. ndiv.eq.4
     @               ) then

                ldummy = .true.
                do il0=il1,il2
                   if (nttsew(il0,3,imod) .eq. 0) ldummy = .false.
                   if (fttsew(il0,3,imod) .eq. 0) ldummy = .false.
                   if (nttsew(il0,4,imod) .eq. 0) ldummy = .false.
                   if (fttsew(il0,4,imod) .eq. 0) ldummy = .false.
                   if (nttsew(il0,3,imod) .ne. nttsew(il0,4,imod))
     @                                        ldummy = .false.
                end do

                if (ldummy) then
                   readdir = 1
                end if
             end if

c This is correct only if e-beam cutout really divides sense wires!
c (wrong for modules pc-5s24-61*)
             if (ndiv.ne.ndiv0 .and. idiv.eq.ndiv0) then
                readdir = 1
             end if

c------- OTMO table should be filled from ARTE-03-01.
c------- Direction of signal propagation on wire determined.
             iq(iqotmo_ydir_l()) = readdir

c-------------- Other OTMO stuff to fill:
c            q(qotmo_yt0_l()) = 0.5*(ymax_de + ymin_de) ! mean y-coordinate for what t_zero was defined
c            iq(iqotmo_ydir_l()) = iottz ! first word in table OTTZ(OTTE) related to module
c            iq(iqotmo_idts_l()) = iotts ! identifier of time-space relations stored in OTTS

        end do          ! division on y


c========================================= End of NEDE volume declaration


c========================================= Geant volume declaration
c---- Create Geant volume containing the whole module (several NEDE volumes)

        do idiv=ndiv0,ndiv      ! loop on vertical Geant volumes
                                ! above e-beam, near e-beam, under e-beam
           ymin_ge = ymin_mo
           ymax_ge = ymax_mo

           if (ndiv.ne.ndiv0) then
              if (idiv.eq.ndiv0) then
                 ymin_ge = +1000.
                 do ilay=1,notlay(imod)
                    if (otbeam(ilay,1,imod).ne.0.)
     @                 ymin_ge = min(yrot+otbeam(ilay,1,imod), ymin_ge)
                 end do
              else if (idiv.eq.ndiv0+1) then
                 ymin = -1000.
                 ymax = +1000.
                 do ilay=1,notlay(imod)
                    if (otbeam(ilay,1,imod).ne.0.)
     @                 ymax_ge = min(yrot+otbeam(ilay,1,imod), ymax_ge)
                    if (otbeam(ilay,2,imod).ne.0.)
     @                 ymin_ge = max(yrot+otbeam(ilay,2,imod), ymin_ge)
                 end do
              else if (idiv.eq.ndiv0+2) then
                 ymax_ge = -1000.
                 do ilay=1,notlay(imod)
                    if (otbeam(ilay,2,imod).ne.0.)
     @                 ymax_ge = max(yrot+otbeam(ilay,2,imod), ymax_ge)
                 end do
              else
                 call meerro('Something wrong with ndiv0')
              end if
           end if

           do iz=1,3    ! loop on horizontal (along Z) Geant volume:
                        ! wall, sensitive volume, wall

              if (iz.eq.1 .and. il1.eq.1) goto 200
              if (iz.eq.3 .and. il2.eq.notlay(imod)) goto 200

              mcells_ge = 0
              if (idiv.eq.ndiv0+1 .and. mcells .le. 24) goto 200

              x1_ = 1.e10
              x2_ = -1.e10
              if (iz.eq.1) then
                 ilay1=1
                 ilay2=il1-1
              else if (iz.eq.2) then
                 ilay1=il1
                 ilay2=il2
              else if (iz.eq.3) then
                 ilay1=il2+1
                 ilay2=notlay(imod)
              end if

              if (ilay1.gt.ilay2) then
                 c78 = 'Illegal ilay1='
                 call ch78ai(ilay1)
                 call ch78ac(', ilay2=')
                 call ch78ai(ilay2)
                 call meerro(c78)
              end if

              do il0=ilay1,ilay2
                 if (ymax_ge .ge. 0.) then
                    iy1 = 1
                 else
                    iy1 = 2
                 end if
                 if (ymin_ge .le. 0.) then
                    iy2 = 2
                 else
                    iy2 = 1
                 end if

                 if (iy1.gt.iy2) then
                    c78 = 'Illegal iy1='
                    call ch78ai(iy1)
                    call ch78ac(', iy2=')
                    call ch78ai(iy2)
                    call meerro(c78)
                 end if

                 x1 = +10000.
                 x2 = -10000.
                 do iy=iy1,iy2
                    if (ttcefi(il0,iy,imod).ne.0.) then
                       x1 = min(ttcefi(il0,iy,imod),x1)
                       if (idiv.eq.ndiv0+1)
     @                    x1 = max(ttcefi(il0,iy,imod)+15.,x1)
                    end if
                    if (ttcela(il0,iy,imod).ne.0.) then
                       x2 = max(ttcela(il0,iy,imod),x2)
                    end if

                    x1_ = min(x1,x1_)
                    x2_ = max(x2,x2_)
                 end do

                 dx(il0) = x2-x1
                 d = x2 - x1
                 ncells = int(d/pit1 + 1.5)
                 mcells_ge = max(mcells_ge,ncells)
              end do

              if (x1_.ge.x2_) then
                 c78 = 'Illegal x1_='
                 call ch78af(x1_,3)
                 call ch78ac(', x2_=')
                 call ch78af(x2_,3)
                 call meerro(c78)
              end if

              if (mcells_ge.le.0) then
                 c78 = 'Illegal mcells_ge='
                 call ch78ai(mcells_ge)
                 call meerro(c78)
              end if

              xmin_ge = xrot + x1_
              xmax_ge = xrot + x2_

              dx1 = dx(ilay1)
              dx2 = dx(ilay2)

              nvol = inede1 + (idiv-ndiv0)
              if (iz.ne.2) nvol = nnwal()+1

              zmin_ge = z + 0.5*(ilay1-1)*otdiam(imod)
              zmax_ge = z + 0.5*(ilay2+1)*otdiam(imod)
              if (iz.eq.1) then
                 zmax_ge = zmax_ge - 0.5*otdiam(imod)
                 if (modshape.eq.'TRD1') then
                    dx2 = dx2 + pit
                 else
                    if (angpar.lt.0.) then
                       xmin_ge = xmin_ge + 0.5*pit
                    else
                       xmax_ge = xmax_ge - 0.5*pit
                    end if
                 end if


              else if (iz.eq.3) then
                 zmin_ge = zmin_ge + 0.5*otdiam(imod)
                 if (modshape.eq.'TRD1') then
                    dx1 = dx1 - pit
                 else
                    if (angpar.gt.0.) then
                       xmin_ge = xmin_ge + 0.5*pit
                    else
                       xmax_ge = xmax_ge - 0.5*pit
                    end if
                 end if
              end if

              xp_rot = 0.5*(xmax_ge + xmin_ge)
              yp_rot = 0.5*(ymax_ge + ymin_ge)

              zp_mo  = 0.5*(zmax_ge + zmin_ge)
              zp = zp_mo - zp_sl

              if (iz.eq.2) then
                 ityp_g = 6*imflag + 3*laytyp + ityp0  ! sensitive: 10 & 5 mm
              else
                 ityp_g = 6*imflag + 3*laytyp + 3      ! nonsensitive: 5 mm
              end if

              if (modshape.eq.'PARA') then !shape = PARA = parallelepiped
                 npar = 6
                 par(1) = 0.5*(dx1 + pit)
                 par(2) = 0.5*(ymax_ge - ymin_ge)
                 par(3) = 0.5*(zmax_ge - zmin_ge)
                 par(4) = 0.
                 par(5) = angpar
                 par(6) = 0.
                 do i=1,3
                    if (par(i).le.0.) then
                       c78 = 'PARA negative par('
                       call ch78ai(i)
                       call ch78ac(') =')
                       call ch78af(par(i),-3)
                       call meerro(c78)
                    end if
                 end do
                 ityp_ge = ityp_g

              else if (modshape.eq.'TRD1') then ! shape = TRD1 = trapezoid 1
                 npar = 4
                 par(1) = 0.5*dx1
                 par(2) = 0.5*dx2
                 if ((par(2)-par(1)) .gt. 0.1*pit) then
                    par(2) = par(2) + pit
                 else
                    par(1) = par(1) + pit
                 end if
                 par(3) = 0.5*(ymax_ge - ymin_ge)
                 par(4) = 0.5*(zmax_ge - zmin_ge)
                 do i=1,4
                    if (par(i).le.0.) then
                       c78 = 'TRD1 negative par('
                       call ch78ai(i)
                       call ch78ac(') =')
                       call ch78af(par(i),-3)
                       call meerro(c78)
                    end if
                 end do

                 ityp_ge = ityp_g + 12
              end if

c rot --> lab
              xp_mo =  cosang * xp_rot + sinang * yp_rot
              yp_mo = -sinang * xp_rot + cosang * yp_rot
              xp = xp_mo - xp_sl
              yp = yp_mo - yp_sl

              call gsposp(wtdt(ityp_ge),nvol,slname,xp,yp,zp,
     @              ir,'ONLY',par,npar)

              if (iz.ne.2) then
                 call crgwal(wtdt(ityp_ge),nnwal()+1)
              end if

200           continue
           end do
        end do

c------------------------------------- Install G10-strips
c        declare_g10 = .true.
        if (declare_g10.ne.0) call otrg10(xrot,yrot,z)

c Put wall for last NEDE bank
        if (inede_fwl(inede1).ne.0) then
           iq(iqnede_nwl(inede1)) = nnwal() - iq(iqnede_fwl(inede1))+1
        end if
        if (inesl_fwl(currsl).ne.0) then
           iq(iqnesl_nwl(currsl)) = nnwal() - inesl_fwl(currsl) + 1
        end if

c========================================= End of Geant volume declaration
 100    continue
        return

 99     call meerro
     @    ('Error reading parameters in command: '//buf(:lenocc(buf)))
        return

        end
