
      SUBROUTINE PHEVNT

************************************************************************
* Author :    Siegmund Nowak   07/96
* Description: generate one phase space particle
*
* Called from: QNEXT
*
* External references: LUND
*
* Arguments: none
*
************************************************************************

c      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"
#include "auto/EV.fi"
#include "auto/TOPP.fi"
#include "auto/GEO.fi"
#include "jets/LUJETS.fi"
#include "jets/LUDAT1.fi"
#include "jets/LUDAT2.fi"
#include "jets/LUDAT3.fi"

      INTEGER IP,TPNAME,IPLUND,NWI,IWIRE,IMED, CRWIRE
      REAL PA,TH,PHI,RX(3),EDKY
      REAL PMIN,PMAX,THMIN,THMAX,PHIMIN,PHIMAX
      CHARACTER*12 CPART
      CHARACTER*4 MATNAM
      COMMON /PHASPA/ CPART,PMIN,PMAX,THMIN,THMAX,PHIMIN,PHIMAX

#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/TOPP.ff"
#include "auto/GEO.ff"

C event header bank EVHD

      CALL ATEVHD

C issue warning if event input file is given

c removed. H.A.

C set seed

      IF (LUNDSEED(1) .EQ. 0 .OR. LUNDSEED(2) .EQ. 0)  CALL ALRINI
      CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'S')

      IF (JMCIN .EQ. 0)  CALL MMBOOK (JMCIN, 1)
c set version numbers   
      Q (QMCIN_VGEA_L()) = GEANVERS
      Q (QMCIN_VGEO_L()) = GEOMVERS
c set short/long detector configuration
      CALL CRLOSH(IQ(BQMCIN_FMCL(1)),IQ(BQMCIN_FMCS(1)))

      CALL MMBOOK (JMCME, 1)
      IQ(IQMCME_EVT_L()) = NUMEVT
      IQ(IQMCME_RUN_L()) = NUMRUN
      IQ(IQMCME_EXP_L()) = NUMEXP

C further specification necessary in future:
      IQ(IQMCME_PHY_L()) = 0
      Q(QMCME_VLUN_L()) = 0

      

c Lund random seed for this event

      IQ(IQMCME_RLUN_L(1)) = LUNDSEED(1)
      IQ(IQMCME_RLUN_L(2)) = LUNDSEED(2)

      CALL RANECU(RX,3,1)
      PA  = RX(1)*(  PMAX -  PMIN) +  PMIN
      TH = RX(2)*( THMAX - THMIN) + THMIN
      PHI= RX(3)*(PHIMAX -PHIMIN) +PHIMIN

      IP = TPNAME(CPART)
      EDKY = SQRT(PA*PA + FTOPP_MASS(IP)**2)
      IPLUND = ITOPP_LUND(IP)
      
      IF(ITOPP_DECA(IP).EQ.0) THEN
         CALL LU1ENT(1,IPLUND,EDKY,TH,PHI)
      ELSE
         CALL LU1ENT(0,IPLUND,EDKY,TH,PHI)
      ENDIF

      CALL ALFSTO

      NWI = 1
      IWIRE = CRWIRE(NWI)
      IQ(IQMCME_WIRE_L()) = IWIRE
      IMED = IGTAR_CMP(IWIRE)
      CALL UHTOC(IQ(HQGMAT_NAME(1,IMED)),4,MATNAM,4)
      IF (MATNAM.EQ.'ALUM') THEN 
         CALL CHCTOH('AL  ',IQ(HQMCME_MAT_L()),1)
      ELSE IF(MATNAM .EQ. 'CARB') THEN
         CALL CHCTOH('C   ',IQ(HQMCME_MAT_L()),1)  
      ELSE IF(MATNAM .EQ. 'COPP') THEN
         CALL CHCTOH('CU  ',IQ(HQMCME_MAT_L()),1)
      ELSE IF(MATNAM .EQ. 'TUNG') THEN
         CALL CHCTOH('W   ',IQ(HQMCME_MAT_L()),1)
      ELSE IF(MATNAM .EQ. 'TITA') THEN
         CALL CHCTOH('TI  ',IQ(HQMCME_MAT_L()),1)
      ELSE IF(MATNAM .EQ. 'BERY') THEN
         CALL CHCTOH('BE  ',IQ(HQMCME_MAT_L()),1)
      ENDIF

C random seed for GEANT

 10   CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'R')
      IQ(IQMCIN_RGEA(1,1)) = LUNDSEED(1)
      IQ(IQMCIN_RGEA(2,1)) = LUNDSEED(2)

      END

************************************************************************
* End of PHEVNT
************************************************************************
