
      SUBROUTINE PTLLST( IFIRST , ILAST , CNAMI   , COBJ  ,
     &                   CSUPL  , CMOT  ,  COPT   , CTPL  ) 
************************************************************************
*                                                                      *
* PPPPPPPPP   TTTTTTTTTT  LL        LL         SSSSSSSSSS   TTTTTTTTTT *
* PPPPPPPPPP  TTTTTTTTTT  LL        LL        SSSSSSSSSSSS  TTTTTTTTTT *
* PP      PP      TT      LL        LL        SS        SS      TT     *
* PP      PP      TT      LL        LL        SS                TT     *
* PP      PP      TT      LL        LL        SSS               TT     *
* PPPPPPPPPP      TT      LL        LL         SSSSSSSSS        TT     *
* PPPPPPPPP       TT      LL        LL          SSSSSSSSS       TT     *
* PP              TT      LL        LL                 SSS      TT     *
* PP              TT      LL        LL                  SS      TT     *
* PP              TT      LL        LL        SS        SS      TT     *
* PP              TT      LLLLLLLL  LLLLLLLL  SSSSSSSSSSSS      TT     *
* PP              TT      LLLLLLLL  LLLLLLLL   SSSSSSSSSS       TT     *
*                                                                      *
************************************************************************
*                                                                      *
* Revision: 1.1.1.1 $                                                  *
* Author: I.Belyaev                                                    *
* Date: 1997/11/06 09:52:46 $                                          *
*                                                                      *
* Created: Apr 10, 1997 by I.Belyaev                                   *
*                                                                      *
* Description:                                                         *
* This routine prints the contents of Arte table PTGE on               *
* terminal,printer-file,log-file (controlled by CTPL)                  *
* either in TABLE form or in ASCII form                                *
*                                                                      *
* Uses GEANT routine GFANG !                                           *
*                                                                      *
* Arguments:                                                           *
* name       in/out/update Argument description                        *
* IFIRST     in               First chamber to be listed               *
* ILAST      in               Last  chamber to be listed               *
* CSUPL      in               Superlayer to which the object belongs to* 
* CMOT       in               Mother to which the object belongs to    *
* COPT       in               CHARACTER*(*)                            *
* CTPL       in               CHARACTER*(*)                            *
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/PTGE.fi"

      CHARACTER*(*)   COPT   , CTPL , CSUPL , COBJ , CMOT , CNAMI 
      INTEGER         IFIRST , ILAST , L 
      LOGICAL         LTABLE , LFILE , LCHAMBER 
      LOGICAL         LWALL  , LALL  , LMOT     , LSUP , LNAM   

      CHARACTER*78    CNAM   , CNAME1 , CNAME2

      INTEGER         idWall , idChamber 
      PARAMETER      (idWall=-1,idChamber=1)
       
      INTEGER         iPTGE , i , j  , NLIST
      CHARACTER*4     CSUP , CNAME , CMOTH , CSHAP , CMAON
      CHARACTER*80    COMMENT
      CHARACTER*12    CMATE , CTMP
      CHARACTER*3     C3 
      CHARACTER*4     C4 
      CHARACTER*5     C5 
      REAL            AMATR(3,3),ROW(3),SINTH,COSTH,SINPH,COSPH
      REAL            THETA,PHI,SX,SY 
      LOGICAL         ROTATE

      INTEGER         LENOCC 
      EXTERNAL        LENOCC

C*********************************************************************
C     * Be sure that the next 9 lines are the same in PTLDAT and PTLGEO  ** 
C*********************************************************************
      INTEGER     QPTGE_ORAD   ,  QPTGE_THIK 
      INTEGER     QPTGE_XLEN   ,  QPTGE_YLEN   ,  QPTGE_ZLEN
      INTEGER     QPTGE_XPOS   ,  QPTGE_YPOS   ,  QPTGE_ZPOS
      INTEGER     QPTGE_ORAD_L ,  QPTGE_THIK_L 
      INTEGER     QPTGE_XLEN_L ,  QPTGE_YLEN_L ,  QPTGE_ZLEN_L
      INTEGER     QPTGE_XPOS_L ,  QPTGE_YPOS_L ,  QPTGE_ZPOS_L
      REAL        FPTGE_ORAD   ,  FPTGE_THIK          
      REAL        FPTGE_XLEN   ,  FPTGE_YLEN   ,  FPTGE_ZLEN
      REAL        FPTGE_XPOS   ,  FPTGE_YPOS   ,  FPTGE_ZPOS
C*********************************************************************
C*********************************************************************
      
      
      
#include "arte/Arte.ff"
#include "auto/PTGE.ff"
      
      
C*********************************************************************
C     * Be sure that the next 24 lines are the same in PTLDAT and PTLGEO  * 
C*********************************************************************
      QPTGE_ORAD(I_W) = QPTGE_XMIN(I_W) ! TUBE only
      QPTGE_THIK(I_W) = QPTGE_XMAX(I_W) ! TUBE only 
      QPTGE_XLEN(I_W) = QPTGE_XMIN(I_W) ! TRD2 only
      QPTGE_YLEN(I_W) = QPTGE_XMAX(I_W) ! TRD2 only 
      QPTGE_ZLEN(I_W) = QPTGE_YMIN(I_W) ! TUBE and TRD2 
      QPTGE_XPOS(I_W) = QPTGE_YMAX(I_W) ! TUBE and TRD2 
      QPTGE_YPOS(I_W) = QPTGE_ZMIN(I_W) ! TUBE and TRD2 
      QPTGE_ZPOS(I_W) = QPTGE_ZMAX(I_W) ! TUBE and TRD2 
      
      QPTGE_ORAD_L()  = QPTGE_XMIN_L() ! TUBE only
      QPTGE_THIK_L()  = QPTGE_XMAX_L() ! TUBE only 
      QPTGE_XLEN_L()  = QPTGE_XMIN_L() ! TRD2 only
      QPTGE_YLEN_L()  = QPTGE_XMAX_L() ! TRD2 only 
      QPTGE_ZLEN_L()  = QPTGE_YMIN_L() ! TUBE and TRD2 
      QPTGE_XPOS_L()  = QPTGE_YMAX_L() ! TUBE and TRD2 
      QPTGE_YPOS_L()  = QPTGE_ZMIN_L() ! TUBE and TRD2 
      QPTGE_ZPOS_L()  = QPTGE_ZMAX_L() ! TUBE and TRD2 
      
      FPTGE_ORAD(I_W) = FPTGE_XMIN(I_W) ! TUBE only
      FPTGE_THIK(I_W) = FPTGE_XMAX(I_W) ! TUBE only 
      FPTGE_XLEN(I_W) = FPTGE_XMIN(I_W) ! TRD2 only
      FPTGE_YLEN(I_W) = FPTGE_XMAX(I_W) ! TRD2 only 
      FPTGE_ZLEN(I_W) = FPTGE_YMIN(I_W) ! TUBE and TRD2 
      FPTGE_XPOS(I_W) = FPTGE_YMAX(I_W) ! TUBE and TRD2 
      FPTGE_YPOS(I_W) = FPTGE_ZMIN(I_W) ! TUBE and TRD2 
      FPTGE_ZPOS(I_W) = FPTGE_ZMAX(I_W) ! TUBE and TRD2 
C*********************************************************************
C*********************************************************************
      
      IF( COPT(1:LENOCC(COPT)) .EQ. 'TABLE' )THEN
         LTABLE = .TRUE. 
         LFILE  = .FALSE. 
      ELSE
         LFILE  = .TRUE. 
         LTABLE = .FALSE.
      ENDIF 
      
      LMOT    = .FALSE. 
      IF( LENOCC(CMOT) .GE. 3 )THEN
         IF( CMOT(1:3) .NE. 'ALL' )THEN
            LMOT = .TRUE. 
         ENDIF 
      ENDIF
      

            
      IF( LENOCC(CNAMI) .LE. 0 )CNAMI='ALL'
      IF(CNAMI(1:LENOCC(CNAMI)).EQ.'*')CNAM='ALL'     
      CNAM  = CNAMI  
      CNAME1=' '
      CNAME2=' '
      L = LENOCC(CNAM) 
      IF( CNAM(L:L).EQ.'*')THEN
         IF( CNAM(1:1).EQ.'*')THEN
            CNAME2=CNAM(2:LENOCC(CNAM)-1)
         ENDIF 
         CNAM(L:L)=' '
      ENDIF  
      
      LNAM = .FALSE. 
      IF( CNAM(1:1).EQ.'*' )THEN
         CNAM(1:1)=' '
         CNAME1=CNAM(2:LENOCC(CNAM))
      ENDIF 
      IF( CNAM(1:LENOCC(CNAM)) .NE. 'ALL' )THEN
         LNAM = .TRUE. 
      ENDIF  
      
      LSUP    = .FALSE. 
      IF( LENOCC(CSUPL) .GE. 3 )THEN
         IF( CSUPL(1:3) .NE. 'ALL' )THEN
            LSUP = .TRUE. 
         ENDIF 
      ENDIF 
      
      IF( COBJ(1:1) .EQ. 'A' )THEN
         LALL     = .TRUE. 
         LWALL    = .TRUE.
         LCHAMBER = .TRUE.
      ELSEIF( COBJ(1:1) .EQ. 'C' )THEN
         LALL     = .FALSE. 
         LCHAMBER = .TRUE. 
         LWALL    = .FALSE. 
      ELSEIF( COBJ(1:1) .EQ. 'W' )THEN
         LALL     = .FALSE. 
         LCHAMBER = .FALSE. 
         LWALL    = .TRUE. 
      ELSE 
         C78='PTLLST error! Unknown OBJECT-type='
         CALL CH78AC( COBJ(1:LENOCC(COBJ)))
         CALL ME78WC( 2198347 ) ! in BATCH mode STOP 
         RETURN 
      ENDIF 
      
      IF(     JPTGE .LE. 0 )THEN
         C78='PTLLST error! table PTGE does not exist!' 
         CALL ME78WC( 9318274 ) ! in BATCH mode STOP 
         RETURN 
      ELSEIF( NPTGE() .LE. 0 )THEN 
         C78='PTLLST error! table PTGE is empty!' 
         CALL ME78WC( 98372   ) ! in BATCH mode STOP 
         RETURN       
      ENDIF 
      
      IF( IFIRST .LE. 0 )IFIRST = 1 
      IF( ILAST  .LE. 0 )ILAST  = ILARGEST 
      
      IFIRST = MIN( MAX(      1 , IFIRST ) , NPTGE() )
      ILAST  = MIN( MAX( IFIRST , ILAST  ) , NPTGE() )
      
      NLIST = 0 
      DO iPTGE = IFIRST , ILAST 
         
         IF( iPTGE .EQ. IFIRST ) THEN
            C78=' ' 
            CALL ME78SP( CTPL ) 
            DO i=1,78
               C78(i:i)='-'
            ENDDO 
            C78(1:2)='C*'
            C78(77:78)='*C'
            CALL ME78SP( CTPL ) 
            C78='List ('
            CALL CH78AI(IFIRST                   )
            CALL CH78AC('-'                      )
            CALL CH78AI(ILAST                    )
            CALL CH78AC(')'                      )
            CALL CH78BC('with Name='             )
            CALL CH78AC( CNAMI(1:LENOCC(CNAMI))  )
            CALL CH78CC( 'Object(s)='            )
            CALL CH78AC( COBJ(1:LENOCC(COBJ))    ) 
            CALL CH78CC( 'Superlayer='           )
            CALL CH78AC( CSUPL(1:LENOCC(CSUPL))  ) 
            CALL CH78CC( 'Mother='               )
            CALL CH78AC( CMOT(1:LENOCC(CMOT))    ) 
            CALL CHCENT(C78) 
            C78(1:2)='C*' 
            C78(77:78)='*C' 
            CALL ME78SP( CTPL ) 
            DO i=1,78
               C78(i:i)='-'
            ENDDO 
            C78(1:2)='C*'
            C78(77:78)='*C'
            CALL ME78SP( CTPL ) 
            C78=' ' 
            CALL ME78SP( CTPL  ) 
         ENDIF    
         
         IF( IPTGE_FLAG(iPTGE) .NE. idChamber .AND. 
     &        IPTGE_FLAG(iPTGE) .NE. idWall ) GO TO 900 
         IF( IPTGE_FLAG(iPTGE) .EQ. idChamber 
     &        .AND. .NOT. LCHAMBER ) GO TO 900
         IF( IPTGE_FLAG(iPTGE) .EQ. idWall  
     &        .AND. .NOT. LWALL    ) GO TO 900
         
         CALL CHHTOC( IQ(HQPTGE_SUPL(iPTGE)) , CSUP ) 
         IF( LSUP .AND. CSUP .NE. CSUPL(1:4) )GO TO 900 ! skip other superlayers 
         
         CALL CHHTOC( IQ(HQPTGE_MOTH(iPTGE)) , CMOTH )
         IF( LMOT .AND. CMOTH .NE. CMOT(1:4) )GO TO 900 ! skip other mothers 
         
         CALL CHHTOC( IQ(HQPTGE_NAME(iPTGE)) , CNAME )
         
         IF( LNAM )THEN         ! select by NAME 
            IF(     LENOCC(CNAME2) .NE. 0  )THEN ! select by MATCH 
               IF( LENOCC(CNAME) .LT. LENOCC(CNAME2))GO TO 900 
               DO i = 1 , LENOCC(CNAME)-LENOCC(CNAME2)+1 
                  IF( CNAME(i:i+LENOCC(CNAME2)-1)
     &                 .EQ.CNAME2(1:LENOCC(CNAME2)))THEN
                     GO TO 10
                  ENDIF 
               ENDDO  
               GO TO 900 
 10            CONTINUE 
            ELSEIF( CNAM(1:1)     .NE. ' ')THEN 
C     * select by First Letters
               IF( LENOCC(CNAME) .LT. LENOCC(CNAM) )GO TO 900  
               IF( CNAME(1:LENOCC(CNAM)) .NE. 
     &              CNAM(1:LENOCC(CNAM)))GO TO 900
            ELSE                
C     * select by last letters 
               IF( LENOCC(CNAME) .LT. LENOCC(CNAME1) )GO TO 900
               L = LENOCC(CNAME) - LENOCC(CNAME1) + 1   
               IF( CNAME(L:LENOCC(CNAME)) .NE.
     &              CNAME1(1:LENOCC(CNAME1)))GO TO 900 
            ENDIF 
         ENDIF 
         
         IF( LFILE )THEN 
            IF( iPTGE .EQ. IFIRST )THEN
               C78=' ' 
               CALL ME78SP( CTPL ) 
               DO i=1,78
                  C78(i:i)='-'
               ENDDO 
               C78(1:2)='C*'
               C78(77:78)='*C'
               CALL ME78SP( CTPL ) 
            ENDIF  
            C78=' ' 
            CALL ME78SP( CTPL  ) 
            C78='-------------------- PT Object #'
            CALL CH78AI( iPTGE          ) 
            CALL CH78BC( '(List #'      ) 
            CALL CH78AI( NLIST + 1      ) 
            CALL CH78AC( ') --------------------' )
            CALL CHCENT( C78            ) 
            C78(1:2)='C*'
            C78(77:78)='*C'
            CALL ME78SP ( CTPL ) 
            IF(     IPTGE_FLAG( iPTGE ) .EQ. idChamber )THEN
               C78=' BEGIN_OF_PTCHAMBER'
            ELSEIF( IPTGE_FLAG( iPTGE ) .EQ. idWall    )THEN
               C78=' BEGIN_OF_PTWALL   '
            ELSE
               C78=' PTLLST error! IPTGE_FLAG(iPTGE='
               CALL CH78AI( iPTGE             ) 
               CALL CH78AC( ')='              )
               CALL CH78AI( IPTGE_FLAG(iPTGE) ) 
               CALL ME78EC( 3924587  ) ! in BATCH mode stop
               GO TO 900 
            ENDIF 
            CALL ME78SP ( CTPL ) 
            
            CALL CHHTOC( IQ(HQPTGE_NAME(iPTGE)) , CNAME ) 
            CALL CHHTOC( IQ(HQPTGE_SUPL(iPTGE)) , CSUP  ) 
            CALL CHHTOC( IQ(HQPTGE_MOTH(iPTGE)) , CMOTH ) 
            
            C78='         Name='
            CALL CH78AC( CNAME         ) 
            CALL CH78BC( 'Superlayer=' ) 
            CALL CH78AC( CSUP          )
            CALL CH78BC( 'Mother='     ) 
            CALL CH78AC( CMOTH         ) 
            CALL ME78SP ( CTPL         ) 
            
            CALL CHHTOC( IQ(HQPTGE_SHAP(  iPTGE)) , CSHAP ) 
            CALL CHHTOC( IQ(HQPTGE_MATE(1,iPTGE)) , CMATE ) 
            CALL CHHTOC( IQ(HQPTGE_MAON(  iPTGE)) , CMAON )
            
            C78='         Shape='
            CALL CH78AC( CSHAP        ) 
            CALL CH78BC( 'Matherial=' ) 
            CALL CH78AC( CMATE        )
            CALL CH78BC( 'Many/Only=' ) 
            CALL CH78AC( CMAON        ) 
            CALL ME78SP( CTPL         ) 
            
            CALL CHHTOC( IQ(HQPTGE_COMM(1,iPTGE)) , COMMENT )
            C78='         Comment="'   
            CALL CH78AC( COMMENT(1:LENOCC(COMMENT))) 
            CALL CH78AC( '"'          ) 
            IF( LENOCC(C78) .GE. 78   )C78(78:78)='"' 
            CALL ME78SP( CTPL ) 
            
            IF(     CSHAP(1:LENOCC(CSHAP)) .EQ. 'BOX' )THEN 
               C78='         Xmin=' 
               CALL CH78AF( FPTGE_XMIN( iPTGE ) , -3 )
               CALL CH78CC( 'Xmax=' ) 
               CALL CH78AF( FPTGE_XMAX( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
               C78='         Ymin=' 
               CALL CH78AF( FPTGE_YMIN( iPTGE ) , -3 )
               CALL CH78CC( 'Ymax=' ) 
               CALL CH78AF( FPTGE_YMAX( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
               C78='         Zmin=' 
               CALL CH78AF( FPTGE_ZMIN( iPTGE ) , -3 )
               CALL CH78CC( 'Zmax=' ) 
               CALL CH78AF( FPTGE_ZMAX( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
            ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TRD2')THEN
               C78='         Xposition=' 
               CALL CH78AF( FPTGE_XPOS( iPTGE ) , -3 )
               CALL CH78CC( 'Yposition=' ) 
               CALL CH78AF( FPTGE_YPOS( iPTGE ) , -3 )
               CALL CH78CC( 'Zposition=' ) 
               CALL CH78AF( FPTGE_ZPOS( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
               C78='         Xlength=' 
               CALL CH78AF( FPTGE_XLEN( iPTGE ) , -3 )
               CALL CH78CC( 'Ylength=' ) 
               CALL CH78AF( FPTGE_YLEN( iPTGE ) , -3 )
               CALL CH78CC( 'Zlength=' ) 
               CALL CH78AF( FPTGE_ZLEN( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
               C78='         DX=' 
               CALL CH78AF( FPTGE_DX  ( iPTGE ) , -3 )
               CALL CH78CC( 'DY=' ) 
               CALL CH78AF( FPTGE_DY  ( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
            ELSEIF( CSHAP(1:LENOCC(CSHAP)) .EQ. 'TUBE')THEN
               C78='         Xposition=' 
               CALL CH78AF( FPTGE_XPOS( iPTGE ) , -3 )
               CALL CH78CC( 'Yposition=' ) 
               CALL CH78AF( FPTGE_YPOS( iPTGE ) , -3 )
               CALL CH78CC( 'Zposition=' ) 
               CALL CH78AF( FPTGE_ZPOS( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
               C78='         OuterRadius=' 
               CALL CH78AF( FPTGE_ORAD( iPTGE ) , -3 )
               CALL CH78CC( 'Thickness=' ) 
               CALL CH78AF( FPTGE_THIK( iPTGE ) , -3 )
               CALL CH78CC( 'Length=' ) 
               CALL CH78AF( FPTGE_ZLEN( iPTGE ) , -3 )
               CALL ME78SP( CTPL ) 
            ELSE
               C78='PTLLST error! HPTGE_SHAP(iPTGE=' 
               CALL CH78AI( iPTGE ) 
               CALL CH78AC( ')='   ) 
               CALL CH78AI( CSHAP  ) 
               CALL ME78EC( 9281437 ) ! in BATCH mode STOP 
               GO TO 900 
            ENDIF  
            
            IF( IPTGE_FLAG( iPTGE ) .EQ. idChamber )THEN
               C78='         NX='
               CALL CH78AI( IPTGE_NX  ( iPTGE ) ) 
               CALL CH78CC( 'NY='               ) 
               CALL CH78AI( IPTGE_NY  ( iPTGE ) ) 
               CALL ME78SP( CTPL ) 
            ENDIF 
            
            IF( IPTGE_IROT( iPTGE ) .EQ. 0 )THEN
               C78='         Rotate=No'
               CALL ME78SP( CTPL ) 
            ELSE
               C78='         Rotate=Yes'
               CALL ME78SP( CTPL ) 
               C78='         Angles=('
               DO i=1,3
                  DO j=1,3 
                     AMATR( j , i ) = 
     &                    FPTGE_ROTM(((i-1)*3+j),iPTGE)
                  ENDDO 
               ENDDO  
               DO i=1,3
                  ROW( 1 ) = AMATR( i , 1 )  
                  ROW( 2 ) = AMATR( i , 2 )  
                  ROW( 3 ) = AMATR( i , 3 )  
                  CALL GFANG(ROW,COSTH,SINTH,COSPH,SINPH,ROTATE)
                  THETA    = ATAN2( SINTH , COSTH ) * RADDEG   
                  PHI      = ATAN2( SINPH , COSPH ) * RADDEG
                  CALL CH78AF( THETA  , -3 ) 
                  CALL CH78AC( ';'         ) 
                  CALL CH78AF( PHI    , -3 ) 
                  IF( i.NE. 3 ) CALL CH78AC( ';' )
               ENDDO 
               CALL CH78AC( ')'  )
               CALL ME78SP( CTPL ) 
            ENDIF 
            
            C78='         Color='
            CALL CH78AI( IPTGE_COLO( iPTGE ) ) 
            CALL CH78BC( 'Fill=' ) 
            CALL CH78AI( IPTGE_FILL( iPTGE ) ) 
            CALL CH78BC( 'Seen=' ) 
            CALL CH78AI( IPTGE_SEEN( iPTGE ) ) 
            CALL ME78SP( CTPL ) 
            
            IF(     IPTGE_FLAG( iPTGE ) .EQ. idChamber )THEN
               C78=' END_OF_PTCHAMBER'
            ELSEIF( IPTGE_FLAG( iPTGE ) .EQ. idWall    )THEN
               C78=' END_OF_PTWALL   '
            ELSE
               C78=' PTLLST error! IPTGE_FLAG(iPTGE='
               CALL CH78AI( iPTGE             ) 
               CALL CH78AC( ')='              )
               CALL CH78AI( IPTGE_FLAG(iPTGE) ) 
               CALL ME78EC( 3325587  ) ! in BATCH mode stop
               GO TO 900 
            ENDIF
            CALL ME78SP( CTPL )  
            NLIST = NLIST + 1 
         ENDIF 
         
         IF( LTABLE )THEN 
            IF( NLIST .EQ. 0 )THEN 
               DO i=1,78
                  C78(i:i)='-'
               ENDDO 
               C78(1:2)='C*'
               C78(77:78)='*C'
               CALL ME78SP( CTPL ) 
               C78=
     &              'C*  # Name T SupL Moth M Shap   Material'//
     &              '   Rot   C S F  Sx    Sy   Comment '
               C78(77:78)='*C'
               CALL ME78SP( CTPL ) 
               DO i=1,78
                  C78(i:i)='-'
               ENDDO 
               C78(1:2)='C*'
               C78(77:78)='*C'
               CALL ME78SP( CTPL ) 
            ENDIF     
            CALL CHHTOC( IQ( HQPTGE_NAME(     iPTGE ) ) , CNAME ) 
            CALL CHHTOC( IQ( HQPTGE_SUPL(     iPTGE ) ) , CSUP  ) 
            CALL CHHTOC( IQ( HQPTGE_MOTH(     iPTGE ) ) , CMOTH ) 
            CALL CHHTOC( IQ( HQPTGE_MAON(     iPTGE ) ) , CMAON ) 
            CALL CHHTOC( IQ( HQPTGE_SHAP(     iPTGE ) ) , CSHAP ) 
            CALL CHHTOC( IQ( HQPTGE_MATE( 1 , iPTGE ) ) , CMATE ) 
            C78='  ' 
            CALL CH78AI(iPTGE)
            IF( LENOCC(C78) .GT. 3 )C78=C78(2:4)
            IF( LENOCC(C78) .EQ. 2 )C78=' '//C78(1:2)
            IF( LENOCC(C78) .EQ. 1 )C78='  '//C78(1:1)
            CALL CH78BC(CNAME)
            IF(     IPTGE_FLAG(iPTGE).EQ. idWall )THEN
               CALL CH78BC( 'W' ) 
            ELSEIF( IPTGE_FLAG( iPTGE ) .EQ. idChamber )THEN 
               CALL CH78BC( 'C' ) 
            ELSE 
               C78='PTLLST error! Unknown IPTGE_FLAG(iPTGE='
               CALL CH78AI( iPTGE     ) 
               CALL CH78AC( ')='      ) 
               CALL CH78AI( IPTGE_FLAG(iPTGE))
               CALL ME78EC( 2398547 ) ! in BATCH mode STOP !
               GO TO 900
            ENDIF  
            CALL CH78BC(CSUP )
            CALL CH78BC(CMOTH)
            IF( CMAON(1:1) .EQ. 'O' .OR. CMAON(1:1).EQ. 'o' )THEN
               CALL CH78BC( 'O' ) 
            ELSEIF( CMAON(1:1).EQ.'M'.OR.CMAON(1:1).EQ.'m')THEN
               CALL CH78BC( 'M' ) 
            ELSE 
               C78='PTLLST error! Unknown HPTGE_MAON(iPTGE='
               CALL CH78AI( iPTGE     ) 
               CALL CH78AC( ')='      ) 
               CALL CH78AC( CMAON )
               CALL ME78EC( 22354547 ) ! in BATCH mode STOP !
               GO TO 900
            ENDIF 
            
            IF( LENOCC(CSHAP) .EQ. 3)CSHAP=' '//CSHAP(1:3)
            CALL CH78BC( CSHAP ) 
            IF( LENOCC(CMATE) .LT. 12 )THEN
               CTMP='                                                ' 
               CMATE=CTMP(1:12-LENOCC(CMATE))//CMATE(1:LENOCC(CMATE))
            ENDIF 
            CALL CH78BC( CMATE ) 
            IF( IPTGE_IROT( iPTGE ) .EQ. 0 )THEN
               CALL CH78BC( ' No' ) 
            ELSE 
               Call CH78BC( 'Yes' )
            ENDIF 
            
            WRITE(C3,'(I3)',ERR=500)IPTGE_COLO(iPTGE)         
            CALL CH78BC( C3 ) 
            GO TO 501
 500        CONTINUE
            CALL CH78BI( IPTGE_COLO(iPTGE)) 
 501        CONTINUE 
            
            CALL CH78BI( IPTGE_SEEN(iPTGE))
            CALL CH78BI( IPTGE_FILL(iPTGE))
            
            IF( IPTGE_FLAG(iPTGE) .EQ. idChamber )THEN
               SX =(FPTGE_XMAX(iPTGE)-FPTGE_XMIN(iPTGE))/
     &              FLOAT(IPTGE_NX  (iPTGE))
               C4=' ' 
               WRITE(C4,'(F4.2)',ERR=600)SX
               CALL CH78BC(C4)
               GO TO 601 
 600           CONTINUE 
               CALL CH78BF(SX,-2)        
 601           CONTINUE 
               SY =(FPTGE_YMAX(iPTGE)-FPTGE_YMIN(iPTGE))/
     &              FLOAT(IPTGE_NY  (iPTGE))
               C5=' ' 
               WRITE(C5,'(F5.2)',ERR=700)SY
               CALL CH78BC(C5)
               GO TO 701 
 700           CONTINUE 
               CALL CH78BF(SY,-2)        
 701           CONTINUE 
            ELSE 
               CALL CH78BC( '   -'  )  
               CALL CH78BC( '    -' )  
            ENDIF          
            
            CALL CHHTOC(IQ(HQPTGE_COMM(1,iPTGE)),COMMENT)
            CALL CH78BC(COMMENT(1:LENOCC(COMMENT))) 
            C78='C*'//C78(1:MIN(76,LENOCC(C78)))
            C78(76:78)=' *C' 
            CALL ME78SP( CTPL )   
            NLIST = NLIST + 1 
         ENDIF 
         
 900     CONTINUE
         
         IF( iPTGE .EQ. ILAST ) THEN
            DO i=1,78
               C78(i:i)='-'
            ENDDO 
            C78(1:2)='C*'
            C78(77:78)='*C'
            CALL ME78SP( CTPL ) 
            C78=' ------------------- Total'
            CALL CH78BI( NLIST ) 
            CALL CH78BC( 'Object(s) listed -------------------' ) 
            CALL CHCENT( C78 ) 
            C78(1:2)   = 'C*' 
            C78(77:78) = '*C'
            CALL ME78SP( CTPL ) 
            DO i=1,78
               C78(i:i)='-'
            ENDDO 
            C78(1:2)='C*'
            C78(77:78)='*C'
            CALL ME78SP( CTPL ) 
            C78=' ' 
            CALL ME78SP( CTPL ) 
         ENDIF 
      ENDDO 
      
      RETURN 
      END 



