
      SUBROUTINE SZ0G96

************************************************************************
* written by Siegmund Nowak, 05/03/96 17.54.07
*
* This routine implements the ring counter Szintillator hodoscope 
*
* called from GEOM97
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
*    ISL      in          superlayer number in NESL table 
************************************************************************
      IMPLICIT NONE

      INTEGER IVOL,IVOLC,IROTM(16),I,ISET,IDET,MEDNUM,ISL
      REAL PAR(5),PARA(8),WM,WMROT(4),RSZ,RLG,RPM,XFL,YFL,ZFL,XMS
      REAL XPSZ,XPLG,XPPM,YPSZ,YPLG,YPPM,ZPSZ,ZPPM,ZSZH0
      CHARACTER*4 CSL
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGMAGN.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      DATA WMROT/ 30., -30., 120., -120./
#include "arte/Arte.ff"
#include "auto/GEO.ff"

c     define rotation matrices
      DO I=1,12
      WM = FLOAT(12-I)*30. + 15.
      CALL CRROTM( IROTM(I),90.,WM, 180.,0.,90.,AMOD(WM+90.,360.))
      ENDDO
      DO  I=1,4
      WM = WMROT(I)
      CALL CRROTM(IROTM(12+I),90.,WM, 180.,0.,90.,AMOD(WM+90.,360.))
      ENDDO

c     install superlayer volume for the ring counter
      DO ISL=1,NNESL()
       IF(INESL_CMP(ISL).EQ.LGESL_HOD1) GO TO 1
      ENDDO 
      RETURN
 1    CURRSL = ISL
      CALL UHTOC(HNESL_NAME(ISL),4,CSL,4)
      IF(INESL_MFL(ISL).EQ.0) THEN
         CALL CGGESL(CSL,'MOTH',0)
      ELSE
         CALL CGGESL(CSL,'MAGN',0)
      ENDIF
      ZSZH0 = 0.5*(FNESL_Z1(ISL)+FNESL_Z2(ISL))
 
c     Counter
      PAR(1) = 1.5
      PAR(2) = 3.9
      PAR(3) = 0.55
      PAR(4) = 4.5
      RSZ = PAR(4) + 6.
      CALL GSVOLU('SZ0C', 'TRD1', MEDNUM(4,'LUCITE'),PAR,4,IVOLC)
      CALL GSATT('SZ0C','COLO',4)

c     light guide
      RLG = RSZ + PAR(4)
      PAR(1) = 3.9
      PAR(2) = 2.85
      PAR(3) = 0.55
      PAR(4) = 0.75
      PAR(5) = 7.
      RLG = RLG + PAR(5)
      CALL GSVOLU('SZ0G', 'TRD2', MEDNUM(2,'LUCITE'),PAR,5,IVOL)
      CALL GSATT('SZ0G','COLO',110)
      RPM = RLG + PAR(5)

c     photomultiplier
      PAR(1) = 0.
      PAR(2) = 2.85
      PAR(3) = 10.
      RPM = RPM + PAR(3)
      CALL GSVOLU('SZ0P', 'TUBE', MEDNUM(2,'ALUMINIUM'),PAR,3,IVOL)

      ZPSZ = .9
      ZPPM =  4.15

c     posit all elements
      DO I = 1,12

      WM   = AMOD((31./12. - FLOAT(I)/6.)* PI,2*PI)
      XPSZ = RSZ*COS(WM)
      YPSZ = RSZ*SIN(WM)
      CALL GSPOS
     +     ('SZ0C',NNCAL()+1,CSL,XPSZ,YPSZ,-ZPSZ,IROTM(I),'ONLY')

      PARA(1) = 6.
      PARA(2) = 15.
      PARA(3) = WM - PI/12.  ! since xmin ..xmax is meaningless, 
      PARA(4) = WM + PI/12.  !  max and min angles will be given
      PARA(5) = ZSZH0 - ZPSZ - .55
      PARA(6) = ZSZH0 - ZPSZ + .55
      PARA(7) = COS(WM)
      PARA(8) = SIN(WM)
      CALL CRGCAL(1,IVOLC,PARA)
      IQ(IQNCAL_NCL_L())  = 1
      IQ(IQNCAL_SEC_L()) = I
      CALL GRADLN(IVOLC,XMS)
      XMS = 2.*.55/XMS
      Q(QNCAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

      CALL GSPOS
     +     ('SZ0C',NNCAL()+1,CSL,XPSZ,YPSZ, ZPSZ,IROTM(I),'ONLY')
      PARA(1) =  RSZ
      PARA(2) =  WM
      PARA(3) = 6.
      PARA(4) = 15.
      PARA(5) = ZSZH0 + ZPSZ - .55
      PARA(6) = ZSZH0 + ZPSZ + .55
      CALL CRGCAL(2,IVOLC,PARA)
      IQ(IQNCAL_NCL_L())  = 2
      IQ(IQNCAL_SEC_L()) = I
      CALL GRADLN(IVOLC,XMS)
      XMS = 2.*.55/XMS
      Q(QNCAL_MS_L())= XMS*(.0136*(1.+.038*ALOG(XMS)))**2

      XPLG = RLG*COS(WM)
      YPLG = RLG*SIN(WM)

      CALL GSPOS('SZ0G',I   ,CSL,XPLG,YPLG,-ZPSZ,IROTM(I),'ONLY')
      CALL GSPOS('SZ0G',I+12,CSL,XPLG,YPLG, ZPSZ,IROTM(I),'ONLY')


      XPPM = RPM*COS(WM)
      YPPM = RPM*SIN(WM)

      CALL GSPOS('SZ0P',I   ,CSL,XPPM,YPPM,-ZPPM,IROTM(I),'ONLY')
      CALL GSPOS('SZ0P',I+12,CSL,XPPM,YPPM, ZPPM,IROTM(I),'ONLY')

      ENDDO

c     posit ring for fastening ring for PMs
      PAR(1) = 40.
      PAR(2) = 45.
      PAR(3) = 3.5
      CALL GSVOLU('SZ0R', 'TUBE', MEDNUM(2,'ALUMINIUM'),PAR,3,IVOL)
      CALL GSATT('SZ0R','COLO',50)
      CALL GSPOS('SZ0R',1,CSL,0.,0.,0.,0,'ONLY')

c     posit upper flanges
      PAR(1) = 5.5
      PAR(2) = 0.5
      PAR(3) = 17.
      XFL = 57.* .5
      YFL = 57.* .866
      ZFL = 223.5 - .5*(FNESL_Z1(MAGNSL)+FNESL_Z2(MAGNSL))
      CALL GSVOLU('SZ0U', 'BOX ', MEDNUM(2,'ALUMINIUM'),PAR,3,IVOL)
      CALL GSATT('SZ0U','COLO',31)
      CALL GSPOS('SZ0U',1,'MAGN',-XFL,YFL,ZFL,IROTM(13),'ONLY')
      CALL GSPOS('SZ0U',2,'MAGN', XFL,YFL,ZFL,IROTM(14),'ONLY')

c     posit lower flanges
      PAR(1) = 5.5
      PAR(2) = 0.25
      PAR(3) = 28.
      XFL = 68.* .866
      YFL = 68.* .5
      ZFL = 223.25 - .5*(FNESL_Z1(MAGNSL)+FNESL_Z2(MAGNSL))
      CALL GSVOLU('SZ0F', 'BOX ', MEDNUM(2,'IRON'),PAR,3,IVOL)
      CALL GSATT('SZ0F','COLO',31)
      CALL GSPOS('SZ0F',1,'MAGN',-XFL,-YFL,ZFL,IROTM(15),'ONLY')
      CALL GSPOS('SZ0F',2,'MAGN', XFL,-YFL,ZFL,IROTM(16),'ONLY')

c     hits will be written out
      CALL GSDET(CSL,'SZ0C',1,'SZ0C',5,LGESL_HOD1,50,20,ISET,IDET)

      END

