*CMZ :          10/05/96  19.47.01  by  Fedor Ratnikov
*CMZ :  1.01/00 07/12/95  15.05.34  by  Fedor Ratnikov
*CMZ :  1.00/00 29/11/94  14.28.20  by  Dominik Ressing
*-- Author :    Dominik Ressing   14/10/94
************************************************************************
*
* L1CETRA
* written by Dominik Ressing, 14/10/94 11.12.31
*
* This routines action:
* translates a FLT cell number into a HBGEAN cell number
* If FLT cell number is invalid: return 0
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iDetInfo     in         detector information for detector of cell
* iFLTce       in         FLT detector cell number
* iHBceF      out         first HBGEAN and RECO cell number
* iHBceL      out         last HBGEAN and RECO cell number
* iHBplaA     out         HBGEAN plate number
* iHBplaB     out         HBGEAN plate B number (=0 if only one valid)
*
************************************************************************
c
      SUBROUTINE L1CETRA(iDetInfo,iFLTceI,iHBceF,iHBceL,
     &                                    iHBla,iHBplaA,iHBplaB)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1detuse.fi"
#include "l1si/rclink.fi"
#include "gean/gcbank.fi"
#include "l1si/l1banks.fi"
c
      INTEGER iDetInfo(L1DETINFlen),iFLTceI,iHBceF,iHBceL,iHBla,
     &        iHBplaA,iHBplaB
      INTEGER iType,iFLTce,link,iFLTceL
      INTEGER JBYT
      EXTERNAL JBYT
c
         WRITE(L1LUNprn,*)
     &        'L1CETRA ==> This routine seems to be not used'
         WRITE(L1LUNprn,*)
     &        'L1CETRA ==> If not, please implement it correctly...'
         GO TO 999
c
 999  CONTINUE
      iHBceF  = 0
      iHBceL  = 0
      iHBla   = 0
      iHBplaA = 0
      iHBplaB = 0
      RETURN
c
      END
