*CMZ :  1.00/07 30/10/95  14.44.04  by  Fedor Ratnikov
*CMZ :  1.00/01 04/04/95  22.11.27  by  Fedor Ratnikov
*CMZ :  1.00/00 10/01/95  18.52.49  by  Dominik Ressing
*-- Author :    Fedor Ratnikov   08/12/94
************************************************************************
*
* L1COG
* written by Fedor Ratnikov, 08/12/94 20.56.35
*
* This routines action:
* Culculates (improve...?) tthe ECAL geometry resolution by some
*   (CenterOfGravity) algorithm
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* GeoIn        in           Cell geometry
* E0           in           Central cell energy
* nBorder      in           Number of neighbous (must be 8)
* Eney(nBorder)in           Energy for neighbous (<0. if neigh not exist)
* GeoCOG       out          (improved) cluster geometry
* Ecorr        out          (improved) cluster total energy
*
************************************************************************
c
      SUBROUTINE L1COG(iCalType,GeoIn,E0,nBorder,Enei,GeoCOG,Ecorr)
c
      IMPLICIT NONE
#include "l1si/l1geodf.fi"
#include "l1si/l1param.fi"
c
      INTEGER iCalType,nBorder
      REAL GeoIn(L1GEOINFlen),GeoCOG(L1GEOINFlen),dlim,
     &     E0,Enei(*),Ecorr,Enorm(3,3),Efit,
     &     Xcorr,Ycorr,dXcorr,dYcorr,
     &     ExPlus,ExMinus,EyPlus,EyMinus,cog,dcog
      INTEGER i
c
c     Implement the clear COG method
c
      IF(nBorder.NE.8)    THEN  ! It should never be
         PRINT *, 'L1COG==> nBorder should be 8!!!', nBorder
         GOTO 999
      ENDIF
c ----     Use "crosses"
      IF(Enei(4).GE.0..AND.Enei(8).GE.0.)  THEN   ! full cluster in X
       ExPlus = Enei(4)
       ExMinus = Enei(8)
       cog = GeoIn(L1GEOINFsx)*(ExPlus-ExMinus)/(E0+ExPlus+ExMinus) ! X-COG
       cog = T1DEF1cogcor(iCalType)*ATAN(T1DEF2cogcor(iCalType)*cog)
                                ! X-corrected COG
       dlim = 0.5*GeoIn(L1GEOINFsx)
       cog = MAX(-1.*dlim,MIN(dlim,cog))
       dcog = T1DEFcogfra*GeoIn(L1GEOINFsx)
       GeoCOG(L1GEOINFx0) = GeoIn(L1GEOINFx0)+
     &      0.5*(GeoIn(L1GEOINFsx)-dcog)+cog
       GeoCOG(L1GEOINFsx) = dcog
      ELSE          ! original cell
       GeoCOG(L1GEOINFx0) = GeoIn(L1GEOINFx0)
       GeoCOG(L1GEOINFsx) = GeoIn(L1GEOINFsx)
      ENDIF
c
c ----     Use "crosses"
      IF(Enei(2).GE.0..AND.Enei(6).GE.0.)  THEN   ! full cluster in Y
       EyPlus = Enei(2)
       EyMinus = Enei(6)
       cog = GeoIn(L1GEOINFsy)*(EyPlus-EyMinus)/(E0+EyPlus+EyMinus) ! Y-COG
       cog = T1DEF1cogcor(iCalType)*ATAN(T1DEF2cogcor(iCalType)*cog)
                                ! Y-corrected COG
       dlim = 0.5*GeoIn(L1GEOINFsy)
       cog = MAX(-1.*dlim,MIN(dlim,cog))
       dcog = T1DEFcogfra*GeoIn(L1GEOINFsy)
       GeoCOG(L1GEOINFy0) = GeoIn(L1GEOINFy0)+
     &      0.5*(GeoIn(L1GEOINFsy)-dcog)+cog
       GeoCOG(L1GEOINFsy) = dcog
      ELSE
       GeoCOG(L1GEOINFy0) = GeoIn(L1GEOINFy0)
       GeoCOG(L1GEOINFsy) = GeoIn(L1GEOINFsy)
      ENDIF
c
      GeoCOG(L1GEOINFz) = GeoIn(L1GEOINFz)
      Ecorr = E0
      DO i=1,nBorder    ! original cluster energy
         IF(Enei(i).GT.0.) Ecorr = Ecorr+Enei(i)
      ENDDO
c
 999  RETURN
c
      END










