*CMZ :          31/05/96  11.02.10  by  Fedor Ratnikov
*CMZ :  1.01/00 04/12/95  19.28.01  by  Fedor Ratnikov
*CMZ :  1.00/03 29/08/95  13.40.48  by  S.B.
*CMZ :  1.00/01 09/08/95  12.53.23  by  S.B.
*-- Author :    Dominik Ressing   27/10/94
************************************************************************
*
* L1DETOV
* written by Dominik Ressing, 27/10/94 11.20.00
*
* This routines action:
* Scans specified detectors/layers/sections and fills the wire number information
* needed to overlap with neighbnouring sections for stereo layers.
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* nSLlist     in          number of entries in detector list
* iSLlist(*)  in          list of valid superlayer (detector) numbers
* ierr        update      set to nonzero on error (else conserved)
*
************************************************************************
c
      SUBROUTINE L1DETOV(nSLlist,iSLlist,ierr)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1param.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/l1detuse.fi"
c
      INTEGER iSLlist(*),nSLlist
c
      INTEGER ierr,iSEQdet,iDetSpe(L1DETSPElen),jDetGeo,
     &        jDetInf,jCellGeo,isec,nsec,ilay,nlay,kDetGeo,
     &        kDetInf,kCellGeo,iDetGeo,iDetInf,iCellGeo,
     &        kSec,kSecU,kSecL,iorS,nDif,
     &        kLower,kUpper,iBD,iFiNei,iLaNei,lsec,lDetGeo,luntab,
     &        lDetInf,lCellGeo,iLaUp,iFiUp,iHBceF,iHBceL,iT,iN,iD,
     &        iHBla,iHBplaA,iHBplaB,iFLTceF,iFLTceL,jlay,
     &        MinHit1,MaxHit1,MinHit2,MaxHit2,link,isave,iType,iTyp2,
     +        iDiff,inei
      REAL    xDif,xNom,xAct,xAdd,sDif,rDif,BoundN,BoundT,aDif,yDif,
     &        wDif,x0Nom,sxNom,xDRigh,xDLeft,tol,rPo(L1POINTlen),dx,
     &        HitT(L1GEOINFlen),HitN(L1GEOINFlen),DifUp,DifLo,
     &        slomi,sloma,dz

      CHARACTER*4 CQ(100)
      EQUIVALENCE(Q(1),CQ(1))

      LOGICAL fierr
c
      fierr = .true.
      luntab = L1LUNprn
c      luntab = 87
      IF ( L1PARprnlev.ge.1 ) THEN
         WRITE(L1LUNprn,'(1x,''L1DETOV==> '',45(''#''))')
      END IF
c
c     --- first loop: determine size of ``FLT planes''
c
      DO iSEQdet = 1,nSLlist
         iDetSpe(L1DETSPEdet)     = iSLlist(iSEQdet)
         iDetSpe(L1DETSPEsection) = 1
         iDetSpe(L1DETSPElayer)   = 1
         CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo) ! obtain detector information
         IF ( jDetGeo.le.0 ) THEN ! valid detector ??
            WRITE (L1LUNprn,*)
     &           'L1DETOV ==> invalid detector found ',
     &           iSLlist(iSEQdet)
            ierr = 1
            RETURN
         END IF
         nSec = IQ(jDetInf+L1DETINFnsec)
         nlay = IQ(jDetInf+L1DETINFnlay)
c
      DO ilay=1,nlay
      DO isec=1,nsec
         iDetSpe(L1DETSPEsection) = isec
         DO jlay=1,nlay      ! find zero layer in detector
            iDetSpe(L1DETSPElayer) = jlay
            CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo) ! obtain detector information
            IF ( jDetGeo.le.0 ) THEN ! valid detector ??
               WRITE (L1LUNprn,*)
     &              'L1DETOV ==> invalid detector found ',
     &              iSLlist(iSEQdet),isec,ilay
               ierr = 1
               RETURN
            END IF
            IF ( ABS(Q(jDetGeo+L1GEOINFsin_al)).lt.0.0001) THEN
               x0Nom = Q(jDetGeo+L1GEOINFx0)
               sxNom = Q(jDetGeo+L1GEOINFsx)
               GO TO 789 ! we only need the first one ...
            END IF
         END DO
         WRITE (L1LUNprn,*)
     &        'L1DETOV ==> no nominal width found',
     &        iSLlist(iSEQdet),isec,ilay
         ierr = 1
         RETURN
c
 789     CONTINUE
         iDetSpe(L1DETSPElayer)   = ilay
         CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo) ! obtain detector information
         IF ( jDetGeo.le.0 ) THEN ! valid detector ??
            WRITE (L1LUNprn,*)
     &           'L1DETOV ==> invalid detctor found ',
     &           iSLlist(iSEQdet),isec,ilay
            ierr = 1
            RETURN
         END IF
c
c        --- preset output fields for all detector/layer/section
         IQ(jDetInf+L1DETINFfltFi)  = 1
         IQ(jDetInf+L1DETINFfltLa)  = IQ(jDetInf+L1DETINFlast)
         IQ(jDetInf+L1DETINForNei)  = 0
         IQ(jDetInf+L1DETINForNeiS) = 0
         IQ(jDetInf+L1DETINFfltFiEXa)= 0
         IQ(jDetInf+L1DETINFfltFiEXb)= 0
         IQ(jDetInf+L1DETINFfltLaEXa)= 0
         IQ(jDetInf+L1DETINFfltLaEXb)= 0
         IQ(jDetInf+L1DETINFsecA) = 0
         IQ(jDetInf+L1DETINFsecB) = 0
c
c        --- enlarge only for chambers
         iType = IQ(jDetInf+L1DETINFhbtype)        ! Type of detector
         IF (iType.ne.L1DETtypeTT.and.iType.ne.L1DETtypeMS.and.
     &        iType.ne.L1DETtypeMu) GO TO 496
c         IF (iType.ne.L1DETtypeTT) GO TO 496
c        --- enlarge only for stereo layers
         IF ( ABS(Q(jDetGeo+L1GEOINFsin_al)).le.0.001 ) GO TO 496
c
         xAdd = Q(jDetGeo+L1GEOINFsy)*     ! required overlap for stereo coverage ...
     &          Q(jDetGeo+L1GEOINFsin_al)/
     &          Q(jDetGeo+L1GEOINFcos_al)
c         if(itype.eq.L1DETtypeMu)  THEN
c          print *,' L1DETOV processes MUON chambers '
c          print *,'idet/ilay/isec',iSLlist(iSEQdet),ilay,isec,
c     &         Q(jDetGeo+L1GEOINFsin_al), Q(jDetGeo+L1GEOINFcos_al),
c     &         xAdd
c          endif
c
         IF ( Q(jDetGeo+L1GEOINFsin_al).gt.0. ) THEN
            xDLeft = Q(jDetGeo+L1GEOINFx0) - (x0Nom-ABS(xAdd))
            xDRigh = x0Nom+sxNom-
     &           Q(jDetGeo+L1GEOINFx0)-Q(jDetGeo+L1GEOINFsx)
         ELSE
            xDLeft = Q(jDetGeo+L1GEOINFx0) - x0Nom
            xDRigh = x0Nom + sxNom + ABS(xAdd)-
     &           Q(jDetGeo+L1GEOINFx0)-Q(jDetGeo+L1GEOINFsx)
         END IF
         tol = Q(jDetInf+L1DETINFxlap)/4. ! tolerance for width comparison
c
c        --- find correct side for enlargement
         xDif = -1.
         IF ( ( IQ(jDetInf+L1DETINFrightU).gt.0 .or.
     &          IQ(jDetInf+L1DETINFrightL).gt.0 ) .and.
     &        xDRigh.gt.tol ) THEN
            xDif = xDRigh
         ELSE
            xDRigh = -1.  ! no enlargement to right side
         END IF
         IF ( ( IQ(jDetInf+L1DETINFleftU).gt.0 .or.
     &          IQ(jDetInf+L1DETINFleftL).gt.0 ) .and.
     &        xDLeft.gt.tol ) THEN
            IF ( xDif.ge.0. ) THEN ! if both sides needed -> take larger
               IF ( xDLeft.gt.xDRigh ) THEN
                IF ( L1PARprnlev.eq.5 ) 
     &               WRITE(L1LUNprn,*)
     &                 'L1DETOV==> need both neighbours -> took left',
     &                 iSLlist(iSEQdet),ilay,isec,x0Nom,xDLeft,xDRigh,
     &                 Q(jDetGeo+L1GEOINFsin_al)
                  xDif = xDLeft
                  xDRigh = -1.  ! no enlargement to right side
               ELSE
                IF ( L1PARprnlev.eq.5 ) 
     &               WRITE(L1LUNprn,*)
     &                 'L1DETOV==> need both neighbours -> took right',
     &                 iSLlist(iSEQdet),ilay,isec,x0Nom,xDLeft,xDRigh,
     &                 Q(jDetGeo+L1GEOINFsin_al)
                  xDLeft = -1.  ! no enlargement to left side
               END IF
            ELSE
               xDif = xDLeft
            END IF
         ELSE
            xDLeft = -1.  ! no enlargement to left side
         END IF
         IF ( xdif.le.0.000001 ) GO TO 496    ! any enlargement ???
c
         rDif  = (xDif)/Q(jDetInf+L1DETINFxspace)
         nDif  = INT(rDif)
         IF ( MOD(rdif,1.)*Q(jDetInf+L1DETINFxspace).gt.
     &        Q(jDetInf+L1DETINFxlap)) ! round up to next cell
     &        nDif = nDif + 1
         xDif = FLOAT(nDif)*Q(jDetInf+L1DETINFxspace)
c
         IF ( xDLeft.gt.xDRigh ) THEN
            IQ(jDetInf+L1DETINFfltFi) = nDif+1
            IQ(jDetInf+L1DETINFnRow)  =
     &           IQ(jDetInf+L1DETINFnRow) + nDif
            IQ(jDetInf+L1DETINFfltLa) = IQ(jDetInf+L1DETINFnRow)
            Q(jDetGeo+L1GEOINFx0)     = Q(jDetGeo+L1GEOINFx0) -
     &           ABS(xDif)
         ELSE
            IQ(jDetInf+L1DETINFfltFi) = 1
            IQ(jDetInf+L1DETINFfltLa) = IQ(jDetInf+L1DETINFnRow)
            IQ(jDetInf+L1DETINFnRow)  =
     &           IQ(jDetInf+L1DETINFnRow) + nDif
         END IF
         Q(jDetGeo+L1GEOINFsx) = Q(jDetGeo+L1GEOINFsx) +
     &        ABS(xDif)
         IQ(jDetInf+L1DETINFlast) =
     &        IQ(jDetInf+L1DETINFnRow)*IQ(jDetInf+L1DETINFnCol)
c
 496     CONTINUE
      END DO
      END DO
      END DO
c
c     --- next loop to determine ``export parameters''
c
      DO iSEQdet = 1,nSLlist
         IF ( L1PARprnlev.eq.5 ) WRITE (luntab,989)
         iDetSpe(L1DETSPEdet)     = iSLlist(iSEQdet)
         iDetSpe(L1DETSPEsection) = 1
         iDetSpe(L1DETSPElayer)   = 1
         CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo) ! obtain detector information
         IF ( jDetGeo.le.0 ) THEN ! valid detector ??
            WRITE (L1LUNprn,*)
     &           'L1DETOV ==> invalid detector found ',
     &           iSLlist(iSEQdet)
            ierr = 1
            RETURN
         END IF
c
         nSec = IQ(jDetInf+L1DETINFnsec)
         nlay = IQ(jDetInf+L1DETINFnlay)
c
      DO ilay=1,nlay
      DO isec=1,nsec
         iDetSpe(L1DETSPEsection) = isec
         iDetSpe(L1DETSPElayer)   = ilay
         CALL l1detif(iDetSpe,jDetGeo,jDetInf,jCellGeo) ! obtain detector information
         IF ( jDetGeo.le.0 ) THEN ! valid detector ??
            WRITE (L1LUNprn,*)
     &           'L1DETOV ==> invalid detector found ',
     &           iSLlist(iSEQdet),isec,ilay
            ierr = 1
            RETURN
         END IF
c
         xdif = Q(jDetGeo+L1GEOINFsx)-Q(jDetInf+L1DETINFsxNomin)
         IF ( ABS(xdif).lt.0.0001 ) GO TO 345  ! if no enlargement -> next
         rDif  = (xDif)/Q(jDetInf+L1DETINFxspace)
         nDif  = INT(rDif)
c
         IF ( Q(jDetGeo+L1GEOINFx0).lt.
     &        Q(jDetInf+L1DETINFx0Nomin) ) THEN  ! left neighbour ??
            xDRigh = 0.
            xDLeft = xdif
         ELSE
            xDRigh = xdif
            xDLeft = 0.
         END IF
c
         IF ( xDRigh.gt.xDLeft ) THEN  ! take right or left neighbour
            kUpper = IQ(jDetInf+L1DETINFrightU)
            kLower = IQ(jDetInf+L1DETINFrightL)
         ELSE
            kUpper = IQ(jDetInf+L1DETINFleftU)
            kLower = IQ(jDetInf+L1DETINFleftL)
         END IF
         kSec = kLower  ! preferenz is the lower (smaller Y) neighbour !!
         IF ( ksec.eq.0 ) ksec = kUpper
         IF ( ksec.eq.0 ) GO TO 345             ! -> next detector
c
         iDetSpe(L1DETSPEsection) = ksec
         CALL l1detif(iDetSpe,kDetGeo,kDetInf,kCellGeo) ! obtain detector information
         IF ( jDetGeo.le.0 ) THEN ! valid detector ??
            WRITE (L1LUNprn,*)
     &           'L1DETOV ==> invalid detctor found ',
     &           iSLlist(iSEQdet),ksec,ilay
            ierr = 1
            RETURN
         END IF
c
c        --- get also geometry for upper neighbour if both are present
         IF (kUpper.gt.0.and.kLower.gt.0.and.kUpper.ne.kLower) THEN
            lsec = kUpper
            iDetSpe(L1DETSPEsection) = lsec
            CALL l1detif(iDetSpe,lDetGeo,lDetInf,lCellGeo) ! obtain detector inf.
            IF ( jDetGeo.le.0 ) THEN ! valid detector ??
               WRITE (L1LUNprn,*)
     &              'L1DETOV ==> invalid detctor found ',
     &              iSLlist(iSEQdet),ksec,ilay
               ierr = 1
               RETURN
            END IF
            IF ( Q(lDetGeo+L1GEOINFsy).gt. ! take the neighbour with larger height
     &           Q(kDetGeo+L1GEOINFsy) ) THEN
               isave    = kDetGeo
               kDetGeo  = lDetGeo
               kDetInf  = lDetInf
               kCellGeo = lCellGeo
               lDetGeo  = isave
               isave = ksec
               ksec = lsec
               lsec = isave
               iDetSpe(L1DETSPEsection) = ksec
            END IF
         ELSE
            lsec = 0
           END IF
c



         DO inei=1,2    ! over sections A and B
          IF(inei.EQ.1)  THEN   ! section A
           iDetSpe(L1DETSPEsection) = ksec
          ELSE                 ! section B
           iDetSpe(L1DETSPEsection) = lsec
          ENDIF
          IF(iDetSpe(L1DETSPEsection).LE.0)   GOTO 100   ! section not inited
          CALL l1detif(iDetSpe,iDetGeo,iDetInf,iCellGeo) ! obtain detector inf.
c          CALL l1slope(Q(jDetGeo+L1GEOINFx0),
c     &         Q(jDetGeo+L1GEOINFy0)+Q(jDetGeo+L1GEOINFsy)/2.,
c     &         Q(jDetGeo+L1GEOINFz),
c     &         T1DEFmommin,
c     &         slomi,sloma)     ! max and min allowed track slopes

         dz = Q(iDetGeo+L1GEOINFz)-Q(jDetGeo+L1GEOINFz)
c
c        --- find size of overlap between nighbouring sectors in tilded system
         IF ( xDLeft.gt.xDRigh ) THEN ! left neighbour ??
c           --- point at lower left corner of target detector
          CALL l1slope(Q(jDetGeo+L1GEOINFx0),
     &         Q(jDetGeo+L1GEOINFy0)+Q(jDetGeo+L1GEOINFsy)/2.,
     &         Q(jDetGeo+L1GEOINFz),
     &         T1DEFmommin,
     &         slomi,sloma)     ! max and min allowed track slopes
            rPo(L1POINTz0) = Q(jDetGeo+L1GEOINFz)
            rPo(L1POINTx0) = Q(jDetGeo+L1GEOINFx0)+
     &                       Q(jDetInf+L1DETINFxlap)/2.+
     &                       MIN(dz*slomi,dz*sloma)    ! add minimal track slope shift
            rPo(L1POINTy0) = Q(jDetGeo+L1GEOINFy0)
            rPo(L1POINTdx) = 0.
            rPo(L1POINTdy) = 0.
            dx = Q(jDetInf+L1DETINFxspace)+ABS(dz*(sloma-slomi))
         ELSE
c           --- point at lower left corner of target detector
          CALL l1slope(Q(jDetGeo+L1GEOINFx0)+
     &         0.5*Q(jDetInf+L1DETINFxspace)*IQ(jDetInf+L1DETINFnRow),
     &         Q(jDetGeo+L1GEOINFy0)+Q(jDetGeo+L1GEOINFsy)/2.,
     &         Q(jDetGeo+L1GEOINFz),
     &         T1DEFmommin,
     &         slomi,sloma)     ! max and min allowed track slopes
            rPo(L1POINTz0) = Q(jDetGeo+L1GEOINFz)
            rPo(L1POINTx0) = Q(jDetGeo+L1GEOINFx0) +
     &                       Q(jDetInf+L1DETINFxlap)/2. +
     &                       Q(jDetInf+L1DETINFxspace) *
     &                       FLOAT(IQ(jDetInf+L1DETINFnRow))+
     &                       MAX(dz*slomi,dz*sloma)    ! add maximal track slope shift
            rPo(L1POINTy0) = Q(jDetGeo+L1GEOINFy0)
            rPo(L1POINTdx) = 0.
            rPo(L1POINTdy) = 0.
            dx = -1.*Q(jDetInf+L1DETINFxspace)-ABS(dz*(sloma-slomi))
         END IF

c         print '(4f10.2)',
c     &   rPo(L1POINTx0), rPo(L1POINTy0), rPo(L1POINTz0),dx   

         rPo(L1POINTx0) = rPo(L1POINTx0)+ ! shift to proper y position
     &        (Q(iDetGeo+L1GEOINFy0)-Q(jDetGeo+L1GEOINFy0))*
     &        Q(iDetGeo+L1GEOINFsin_al)/
     &        Q(iDetGeo+L1GEOINFcos_al)
         rPo(L1POINTy0) = Q(iDetGeo+L1GEOINFy0)
c
c        --- get cell numbers of target corner cell's borders in neighbour cell #'s
         CALL L1POHIT(iDetSpe,rPo,MinHit1,MaxHit1)  ! get outer
                                                    ! targ. cell borders
                                                    ! cell

c         print '(3f10.2,2i5)',
c     &     rPo(L1POINTx0),rPo(L1POINTy0),rPo(L1POINTz0),MinHit1,MaxHit1
         
 
c
c        --- remove overlap ....
         IF ( dx.lt.0. ) THEN
            CALL L1HITIF(iDetSpe,MaxHit1,HitN)

c            print '(i5,5f10.2)',
c     &        MaxHit1,HitN(L1GEOINFx0),HitN(L1GEOINFsx),   
c     &        HitN(L1GEOINFy0),HitN(L1GEOINFsy),   
c     &        HitN(L1GEOINFz)

            IF ( HitN(L1GEOINFx0).gt.rPo(L1POINTx0)) THEN
               MaxHit1 = MaxHit1 -1
               IF ( MinHit1.gt.MaxHit1 ) THEN
                  WRITE (L1LUNprn,960) 1,
     &                 IQ(jDetInf+L1DETINFplate),ilay,isec,
     &                 IQ(iDetInf+L1DETINFplate),ksec,
     &                 MinHit1,MaxHit1
                  MinHit1 = MaxHit1
               END IF
            END IF
         ELSE
            CALL L1HITIF(iDetSpe,MinHit1,HitN)

c            print '(i5,5f10.2)',
c     &        MinHit1,HitN(L1GEOINFx0),HitN(L1GEOINFsx),   
c     &        HitN(L1GEOINFy0),HitN(L1GEOINFsy),   
c     &        HitN(L1GEOINFz)

            IF ( HitN(L1GEOINFx0)+Q(iDetInf+L1DETINFxspace)
     &           .lt.rPo(L1POINTx0)) THEN
               MinHit1 = MinHit1 +1
               IF ( MinHit1.gt.MaxHit1 ) THEN
                  WRITE (L1LUNprn,960) 2,
     &                 IQ(jDetInf+L1DETINFplate),ilay,isec,
     &                 IQ(iDetInf+L1DETINFplate),ksec,
     &                 MinHit1,MaxHit1
                  MaxHit1 = MinHit1
               END IF
            END IF
         END IF
c
 960     FORMAT(' L1DETOV==> Err -',i1,
     &          '-:PlaT,la,se,PlaN,se,Min,Max:',
     &          I5,2I3,I5,I3,2I4)
c
         rPo(L1POINTx0) = rPo(L1POINTx0)+dx         ! advance to other cell boundary
         CALL L1POHIT(iDetSpe,rPo,MinHit2,MaxHit2)  ! get inner cell borders cell #

c         print '(3f10.2,2i5)',
c     &     rPo(L1POINTx0),rPo(L1POINTy0),rPo(L1POINTz0),MinHit2,MaxHit2
         
         IF ( MinHit1.gt.0 ) THEN                   ! find total hit range
            IF ( MinHit2.gt.0 ) THEN
               IF ( dx.lt.0. ) THEN
                  MinHit1 = MIN(MinHit1,MinHit2)
               ELSE
                  MaxHit1 = MAX(MaxHit1,MaxHit2)
               END IF
            END IF
         ELSE
            MinHit1 = MinHit2
            MaxHit1 = MaxHit2
         END IF

         IF ( MinHit1.le.0 ) GO TO 345  ! -> next detector
c
         link = MaxHit1-MinHit1+1 ! number of cells in neigh. needed for targ. cell
c
c        --- limit to maximal number allowed!
         IF ( link.gt.L1DEFNeiOrMax ) THEN
            iDiff  = (link - L1DEFNeiOrMax)/2
            MaxHit1 = MaxHit1 - iDiff
            MinHit1 = MinHit1 + iDiff
            link   = MaxHit1-MinHit1+1
         END IF
c
         IF ( xDLeft.gt.0. ) THEN
            iFiNei = MinHit1
            iLaNei = IQ(iDetInf+L1DETINFfltLa)
         ELSE
            iFiNei = IQ(iDetInf+L1DETINFfltFi)
            iLaNei = MaxHit1
         END IF
         iFiNei = MAX(iFiNei,IQ(iDetInf+L1DETINFfltFi))  ! limit to ``on-target'' cells
         iLaNei = MIN(iLaNei,IQ(iDetInf+L1DETINFfltLa))
         iFiNei = iFiNei - IQ(iDetInf+L1DETINFfltFi) + 1 ! in ``on-target'' counting
         iLaNei = iLaNei - IQ(iDetInf+L1DETINFfltFi) + 1 ! in ``on-target'' counting
c
c        --- is the cell-spaceing the same or a multiple of the one or other ?
c               * find the factor
c               * correct for small (size of overlap) deviations
c
         rDif = Q(jDetInf+L1DETINFxspace)/Q(iDetInf+L1DETINFxspace)
         IF ( rDif.gt.0.75 ) THEN ! target cells >~ neighbour ?
            aDif = (MOD(rDif+0.5,1.)-0.5)*FLOAT(nDif)
         ELSE
            aDif = (MOD(1./rDif+0.5,1.)-0.5)*FLOAT(nDif)
            rDif = -1./rDif
         END IF
         IF ( aDif.gt.0.5 ) aDif = aDif - 1.
         IF ( ABS(aDif).gt.Q(jDetInf+L1DETINFxlap)/2. ) THEN
            WRITE (L1LUNprn,*)
     &       'L1DETOV ==> can''t combine sections det/lay/sec1/sec2:',
     &       iSLlist(iSEQdet),ilay,isec,ksec,
     &       Q(jDetInf+L1DETINFxspace),
     &       Q(iDetInf+L1DETINFxspace)
            ierr = 1
            RETURN
         END IF
c
         wDif = Q(iDetInf+L1DETINFxspace)/100.
c
         IF(inei.EQ.1)  THEN
          IQ(jDetInf+L1DETINForNei)  = INT(rDif+SIGN(0.5,rDif))
          IQ(jDetInf+L1DETINForNeiS) = link
c
c         --- fill information in neighbours detector information fields
c
          IQ(jDetInf+L1DETINFfltFiEXa) = iFiNei
          IQ(jDetInf+L1DETINFfltLaEXa) = iLaNei
          IQ(jDetInf+L1DETINFsecA ) = ksec
         ELSE
          IQ(jDetInf+L1DETINFfltFiEXb) = iFiNei
          IQ(jDetInf+L1DETINFfltLaEXb) = iLaNei
          IQ(jDetInf+L1DETINFsecB) = lsec
         ENDIF
        ENDDO
 100    CONTINUE
        iFiNei = IQ(jDetInf+L1DETINFfltFiEXa)        ! refer to a-section
        iLaNei = IQ(jDetInf+L1DETINFfltLaEXa)
        iDetSpe(L1DETSPEsection) = IQ(jDetInf+L1DETINFsecA)







c
c        --- check result:
         IF ( xDLeft.gt.xDRigh ) THEN ! left neighbour ??
            iN = iLaNei
            IF ( IQ(jDetInf+L1DETINForNei).gt.0 ) THEN
               iT = (iN-iFiNei)/IQ(jDetInf+L1DETINForNei)
            ELSE
               iT = (-1)*(iN-iFiNei)*IQ(jDetInf+L1DETINForNei)
            END IF
            iT = iT + 1
            iD = 1
         ELSE
            iN = iFiNei
            IF ( IQ(jDetInf+L1DETINForNei).gt.0 ) THEN
               iT = (iLaNei-iN)/IQ(jDetInf+L1DETINForNei)
            ELSE
               iT = (-1)*(iLaNei-iN)*IQ(jDetInf+L1DETINForNei)
            END IF
            iT = IQ(jDetInf+L1DETINFlast) - iT
            iD = -1
         END IF
         iN = iN + IQ(kDetInf+L1DETINFfltFi) - 1
         CALL L1HITIF(iDetSpe,iN,HitN) ! hit on neighbour
         iDetSpe(L1DETSPEsection) = isec
         CALL L1HITIF(iDetSpe,iT,HitT) ! hit on Target
         HitT(L1GEOINFx0) = HitT(L1GEOINFx0) +       ! the overlap has not to be covered
     &                         Q(jDetInf+L1DETINFxlap)/2.
         HitT(L1GEOINFsx) = HitT(L1GEOINFsx) -
     &                         Q(jDetInf+L1DETINFxlap)
         yDif = HitN(L1GEOINFy0)-HitT(L1GEOINFy0)
         yDif = yDif * HitT(L1GEOINFsin_al)/HitT(L1GEOINFcos_al)
         IF ( iD.lt.0 ) THEN
            DifUp = HitN(L1GEOINFx0)+HitN(L1GEOINFsx)-
     &              (HitT(L1GEOINFx0)+yDif+HitT(L1GEOINFsx))
            DifLo = HitT(L1GEOINFx0)+yDif-
     &              (HitN(L1GEOINFx0)-
     &              FLOAT(IQ(jDetInf+L1DETINForNeiS)-1)*
     &               Q(kDetInf+L1DETINFxspace))
         ELSE
            DifLo = HitT(L1GEOINFx0)+yDif-
     &              HitN(L1GEOINFx0)
            DifUp = HitN(L1GEOINFx0)+
     &              FLOAT(IQ(jDetInf+L1DETINForNeiS))*
     &              Q(kDetInf+L1DETINFxspace) -
     &              (HitT(L1GEOINFx0)+yDif+HitT(L1GEOINFsx))
         END IF
         IF ( DifLo.lt.0. .or. DifUp.lt.0. ) THEN
          IF(L1PARprnlev.eq.5 )
     &         WRITE (L1LUNprn,970) IQ(jDetInf+L1DETINFplate),isec,
     &        iT,HitT(L1GEOINFx0)+yDif,
     &        HitT(L1GEOINFx0)+yDif+HitT(L1GEOINFsx),
     &        IQ(jDetInf+L1DETINFsecA),ksec,
     &        iN,HitN(L1GEOINFx0),
     &        HitN(L1GEOINFx0)+HitN(L1GEOINFsx),
     &        iD*IQ(jDetInf+L1DETINForNeiS),DifUp,DifLo
         END IF
c
 970     FORMAT(/1x,'L1DETOV==> section connections error listing'/
     &        1x,'PlaT Se Cel   xMinT   xMaxT',
     &           ' PlaN Se Cel   xMinN   xMaxN Lnk DifU DifL'/
     &           1x,i4,i3,i4,2f8.2,i5,i3,i4,2f8.2,i4,2f5.2)
c
 345     CONTINUE
         IF ( ABS(Q(jDetGeo+L1GEOINFsin_al)).gt.0.001
     &            .and. L1PARprnlev.eq.5 ) THEN
            WRITE (luntab,990) iSLlist(iSEQdet),ilay,isec,
     &        IQ(jDetInf+L1DETINFplate),
     &        Q(jDetInf+L1DETINFx0Nomin),
     &        Q(jDetInf+L1DETINFx0Nomin)+Q(jDetInf+L1DETINFsxNomin),
     &        Q(jDetGeo+L1GEOINFsin_al)/Q(jDetGeo+L1GEOINFcos_al),
     &        Q(jDetGeo+L1GEOINFx0),
     &        Q(jDetGeo+L1GEOINFx0)+Q(jDetGeo+L1GEOINFsx),
     &        IQ(jDetInf+L1DETINFfirst),
     &        IQ(jDetInf+L1DETINFfltFi),
     &        IQ(jDetInf+L1DETINFfltLa),
     &        IQ(jDetInf+L1DETINFlast),
     &        IQ(jDetInf+L1DETINFsecA),IQ(jDetInf+L1DETINFfltFiEXa),
     &        IQ(jDetInf+L1DETINFfltLaEXa),
     &        IQ(jDetInf+L1DETINFsecB),IQ(jDetInf+L1DETINFfltFiEXb),
     &        IQ(jDetInf+L1DETINFfltLaEXb),
     &        IQ(jDetInf+L1DETINForNei),
     &        IQ(jDetInf+L1DETINForNeiS)
 989        FORMAT('  de la se plat xMiNo xMaNo',
     &           ' talp  xMin  xMax',
     &           ' Min  Fi  La Max SecA FiA LaA SecB FiB LaB O S')
 990        FORMAT(1x,3i3,i5,2f6.1,f5.2,2f6.1,4i4,2(i5,2i4),2i2)
           END IF
      END DO
      END DO

 888  CONTINUE

      END DO
c
      RETURN
c
      END
