*CMZ :          04/09/96  19.58.09  by  Fedor Ratnikov
*CMZ :  1.01/02 05/02/96  23.27.46  by  Fedor Ratnikov
*CMZ :  1.01/00 19/12/95  14.50.17  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   28/10/95
************************************************************************
*
* L1PRXMF
* written by Fedor Ratnikov, 28/10/95 19.47.45
*
* This routines action:
* simulates outer muon pad chambers pretrigger
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iP         in           pointer to pretrigger processor
* iErr       out          #0 when error
*
************************************************************************
c
      SUBROUTINE L1PREMF(iP,iErr)
c
      IMPLICIT NONE
c
      INTEGER iP,iErr
c
#include "gean/gcbank.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1detmu.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "l1si/rcfdef.fi"

c
      INTEGER MaxPadNumber,MaxHit4Number
      PARAMETER (MaxPadNumber=2500)
      PARAMETER (MaxHit4Number=3)
      INTEGER iHit3(L1hitlen,MaxPadNumber),
     &     iHit4(L1hitlen,MaxHit4Number)
      LOGICAL inited
      CHARACTER*10 NameProg
      CHARACTER*4 MUName(2)
      INTEGER iDetMU3,iDetMU4
      INTEGER isec
      INTEGER ncell,icell3,icell4,iy4,minCell4,maxCell4,
     &     iTime,MessPo,iPRE,iPoPo,JobPo
      INTEGER jMuGeo,jMuInf,jCellGeo,
     &     iDetSpe3(L1DETSPElen),iDetSpe4(L1DETSPElen)
      REAL  pad3(L1GEOINFlen),pad4(L1GEOINFlen),pad40(L1GEOINFlen),
     &     point3(L1POINTlen)
      INTEGER l1detsl
      EXTERNAL l1detsl
c
      DATA inited /.FALSE./
      DATA NameProg /'L1PREMF==>'/
      DATA MUName /'MUP3','MUP4'/
c
#include "l1si/l1mesdf.ff"
c
      iErr = 0  ! no errors so far
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,'(A11,'' START '',58(''#''))') NameProg
      END IF
      IF(.NOT.inited)  THEN     ! initialization
        iDetMU3 = l1detsl(MUName(1))
        IF(iDetMU3.LE.0)  THEN ! not found
         WRITE (L1LUNprn,*) NameProg,
     &        ' Superlayer ',MUName(1),' not found'
         GOTO 777
        ENDIF
        iDetMU4 = l1detsl(MUName(2))
        IF(iDetMU4.LE.0)  THEN ! not found
         WRITE (L1LUNprn,*) NameProg,
     &        ' Superlayer ',MUName(2),' not found'
         GOTO 777
        ENDIF
       inited = .TRUE.
      ENDIF
c
c       Pretrigger itself
c
        iDetSpe3(L1DETSPEdet) = iDetMU3
        iDetSpe3(L1DETSPElayer) = 1
        iDetSpe3(L1DETSPEsection) = 1
        CALL l1detif(iDetSpe3,jMuGeo,jMuInf,jCellGeo)
        IF(jMuGeo.EQ.0)    THEN
         WRITE (L1LUNprn,*) NameProg,
     &        'Detector not found',MUName(1)
         GOTO 777
        ENDIF
        DO isec=1,IQ(jMuInf+L1DETINFnsec) ! number of sections in SLnsec
         iDetSpe3(L1DETSPEsection) = isec
         CALL l1detif(iDetSpe3,jMuGeo,jMuInf,jCellGeo)
         IF(jMuGeo.EQ.0)    THEN
          WRITE (L1LUNprn,*) NameProg,
     &         'Section not found',MUName(1),isec
          GOTO 777
         ENDIF
         ncell = IQ(jMuInf+L1DETINFnRow)*IQ(jMuInf+L1DETINFnCol)
         IF(ncell.GT.MaxPadNumber)  THEN ! dimensions exceeded
          WRITE (L1LUNprn,*) NameProg,
     &         'Dimensions exceeded:',ncell,MaxPadNumber
          STOP
         ENDIF
         CALL l1higet(iP,isec,iDetMU3,L1RUNcuBX,1,
     &       ncell,iHit3)       ! read all hits for MU3
         DO icell3=1,ncell
          IF(iHit3(L1HITpos,icell3).GT.0) THEN ! PAD is hitted
           CALL L1HITIF(iDetSpe3,icell3,pad3) ! PAD geometry
           IF (L1PARprnlev.ge.1) THEN
            WRITE (L1LUNprn,'(A11,''  >>> Next MU pretrigger <<<'')')
     &           NameProg
            WRITE (L1LUNprn,'(11X,''MU3 x/sx/y/sy/z:'',5f9.3)')
     &           pad3(L1GEOINFx0),pad3(L1GEOINFsx),
     &           pad3(L1GEOINFy0),pad3(L1GEOINFsy),
     &           pad3(L1GEOINFz)
           ENDIF
           point3(L1POINTz0) = pad3(L1GEOINFz)
           point3(L1POINTx0) = pad3(L1GEOINFx0)+0.5*pad3(L1GEOINFsx)
           point3(L1POINTdx) = point3(L1POINTx0)/point3(L1POINTz0) ! projectivity
           DO iy4=0,1           ! 1->2 coincedence in Y
            point3(L1POINTy0) = pad3(L1GEOINFy0)+
     &           iy4*pad3(L1GEOINFsy)
            point3(L1POINTdy) = point3(L1POINTy0)/point3(L1POINTz0) ! projectivity
            iDetSpe4(L1DETSPEdet) = iDetMU4
            iDetSpe4(L1DETSPElayer) = 1
            iDetSpe4(L1DETSPEsection) = isec ! look for coincidence in
                                ! the same section
            CALL L1POHIT(iDetSpe4,point3,minCell4,maxCell4) ! get pad
                                ! in MU4
            IF(minCell4.GT.0)  THEN ! cell exists
             IF(minCell4.NE.maxCell4.AND.point3(L1POINTx0).GT.0.)
     &            minCell4 = maxCell4 ! prefer outer region if both
             CALL L1HITIF(iDetSpe4,minCell4,pad40) ! central PAD
                                                    ! geometry
             CALL l1higet(iP,isec,iDetMU4,L1RUNcuBX,
     &            minCell4-(MaxHit4Number-1)/2,
     &            MaxHit4Number,iHit4) ! read hits for MU4
             DO icell4=-(MaxHit4Number-1)/2,
     &            (MaxHit4Number-1)/2                     !1->(3) coincidence in X
              CALL L1HITIF(iDetSpe4,minCell4+icell4,pad4) !PAD geometry
c              print *, 'check pad4:',
c     &               pad4(L1GEOINFx0),pad4(L1GEOINFsx),
c     &               pad4(L1GEOINFy0),pad4(L1GEOINFsy),
c     &               pad4(L1GEOINFz),minCell4+icell4

              IF(pad4(L1GEOINFsx).GT.0..AND.                ! cell exists
     &             ABS(pad4(L1GEOINFy0)-pad40(L1GEOINFy0)).LT.
     &             0.5*pad4(L1GEOINFsy).AND.               ! cell in the same row
     &             iHit4(L1HITpos,icell4+2).GT.0.)  THEN   ! cell is hitted
c
c              Pretrigger found: fill message
c
               IF (L1PARprnlev.ge.1) THEN
                WRITE (L1LUNprn,'(11X,''MU4 x/sx/y/sy/z:'',5f9.3)')
     &               pad4(L1GEOINFx0),pad4(L1GEOINFsx),
     &               pad4(L1GEOINFy0),pad4(L1GEOINFsy),
     &               pad4(L1GEOINFz)
               ENDIF
c
               CALL l1mesne(L1RUNcuBX,MessPo) ! get new message
               IF ( MessPo.le.0 ) THEN ! message storage exceeded
                GOTO 777
               END IF
c
               iTime = L1RUNcutime+L1DEFmuotim ! time after Pretrigger
c              --- set flags
               L1MEstor(MessPo+L1MElast)    = 0 ! last point was pretrigger
               L1MEstor(MessPo+L1MEcreated) = 0 ! first point was pretrigger
               L1MEstor(MessPo+L1MEnextPC)  = iP ! set active proc.
               L1MEstor(MessPo+L1MEactive)  = L1MEacPRE ! last processed

c              --- fill soft message
               L1MEstor(MessPo+L1MEprid) = L1PREmuon ! muon pretrigger
c
               L1MEstor(MessPo+L1MEprbx) = L1RUNcuBX
               T1MEstor(MessPo+L1MEpren) = 100. ! Some
               T1MEstor(MessPo+L1MEprth) = 2. !reasonable
               T1MEstor(MessPo+L1MEpreth)= 1. ! values (for safety...)
c
c              Now we get detector information concerning MU3 and MU4
c              superlayers
c
c              MU4 part
c
               iPRE = L1PCstor(iP+L1PCnum) ! pretrigger number
               iPoPo = L1MEpoint(0)+MessPo
               L1MEstor(iPoPo+L1POpcpo) = iP
               L1MEstor(iPoPo+L1POtrkn) = 0
               L1MEstor(iPoPo+L1POtrk0) = iHit4(L1HITpos,icell4+2) ! MC track reference
               L1MEstor(iPoPo+L1POtrkp) = 0
               L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)
               L1MEstor(iPoPo+L1POtime) = iTime
               iPoPo = iPoPo+L1POreg
c
               T1MEstor(iPoPo+L1GEOINFsx) = pad4(L1GEOINFsx)*0.99
               T1MEstor(iPoPo+L1GEOINFx0) = pad4(L1GEOINFx0)+
     &              0.5*(pad4(L1GEOINFsx)-T1MEstor(iPoPo+L1GEOINFsx))
               T1MEstor(iPoPo+L1GEOINFsy) = pad4(L1GEOINFsy)*0.99
               T1MEstor(iPoPo+L1GEOINFy0) = pad4(L1GEOINFy0)+
     &              0.5*(pad4(L1GEOINFsy)-T1MEstor(iPoPo+L1GEOINFsy))
               T1MEstor(iPoPo+L1GEOINFz) = pad4(L1GEOINFz)
c
c              MU3 part
c
               L1MEstor(MessPo+L1MElast) = L1MEstor(MessPo+L1MElast)+1 ! last point was pretrigger
               iPRE = L1PCstor(iP+L1PCnum) ! pretrigger number
               iPoPo = L1MEpoint(1)+MessPo
c
               L1MEstor(iPoPo+L1POpcpo) = iP
               L1MEstor(iPoPo+L1POtrkn) = 0
               L1MEstor(iPoPo+L1POtrk0) = iHit3(L1HITpos,icell3) ! MC track reference
               L1MEstor(iPoPo+L1POtrkp) = 0
               L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)-1
               L1MEstor(iPoPo+L1POtime) = iTime
c
               iPoPo = iPoPo+L1POreg
               T1MEstor(iPoPo+L1GEOINFsx) = pad3(L1GEOINFsx)*0.99
               T1MEstor(iPoPo+L1GEOINFx0) = pad3(L1GEOINFx0)+
     &              0.5*(pad3(L1GEOINFsx)-T1MEstor(iPoPo+L1GEOINFsx))
               T1MEstor(iPoPo+L1GEOINFsy) = pad3(L1GEOINFsy)*0.99
               T1MEstor(iPoPo+L1GEOINFy0) = pad3(L1GEOINFy0)+
     &              0.5*(pad3(L1GEOINFsy)-T1MEstor(iPoPo+L1GEOINFsy))
               T1MEstor(iPoPo+L1GEOINFz) = pad3(L1GEOINFz)
c              --- fill hard message
               L1MEstor(MessPo+L1HAprbx)  = L1RUNcuBX
               L1MEstor(MessPo+L1HAprid)  = L1PREmuon
c              T1MEstor(MessPo+L1HApren)  = 100. ! some reasonable value...
               T1MEstor(MessPo+L1HAtxi)  =
     &              T1MEstor(iPoPo+L1GEOINFx0)+
     &              0.5*T1MEstor(iPoPo+L1GEOINFsx)
               T1MEstor(MessPo+L1HAteta)  =
     &              T1MEstor(iPoPo+L1GEOINFy0)+
     &              0.5*T1MEstor(iPoPo+L1GEOINFsy)
c
               CALL l1mesup(MessPo,iTime,ierr) ! update message (get ROI(s))
               IF ( ierr.ge.2 ) RETURN ! fatal error
               IF ( ierr.eq.1 ) THEN
                IF ( L1PARprnlev.gt.0 )
     &               WRITE(L1LUNprn,*) NameProg,'Connection error'
                CALL l1mesde(MessPO,L1MEDEnoscr) ! delete message, do not drop data...
                ierr = 0
               ELSE
                CALL l1jobsb(MessPo,iTime,JobPo) ! submitt job
                IF ( JobPo.le.0 ) THEN
                 CALL l1mesde(MessPo,L1MEDEnoscr)
                ELSE
                 CALL l1usrpr(MessPo,0.,0.,0.,0.,0.)
                ENDIF
               ENDIF
              ENDIF             ! pretrigger found
             ENDDO              ! over 3 celles in row
            ENDIF               ! projective pad found in MU4
           ENDDO                ! over 2 celles in Y
          ENDIF                 ! hitted pad in MU3
         ENDDO                  ! over pads in MU3
        ENDDO                   ! over sections in MU3
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,'(A11,'' END '',58(''#''))') NameProg
      END IF
      RETURN
 777  CONTINUE   ! error exit
      iErr = 1
      RETURN
c
      END




















