*CMZ :          30/05/96  15.58.10  by  Fedor Ratnikov
*CMZ :  1.01/01 14/01/96  13.34.59  by  Fedor Ratnikov
*CMZ :  1.01/00 26/12/95  22.35.25  by  Fedor Ratnikov
*CMZ :  1.00/01 08/08/95  14.14.38  by  S.B.
*CMZ :  1.00/00 15/12/94  21.20.10  by  Dominik Ressing
*-- Author :    Dominik Ressing   14/10/94
************************************************************************
*
* L1TRACE
* written by Dominik Ressing, 14/10/94 11.12.31
*
* This routines action:
* translates a HBGEAN cell number into a FLT cell number
* if HBGEAN cell description is invalid: return 0
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iDet         in         detector information for detector of cell
* iHBid        in         HBGEAN and RECO cell ID
* iFLTceF     out         first FLT cell number
* iFLTceL     out         last FLT cell number
*
************************************************************************
c
      SUBROUTINE L1TRACE(iDet,iHBid,iFLTceF,iFLTceL)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1detuse.fi"
#include "l1si/rclink.fi"
#include "gean/gcbank.fi"
#include "l1si/l1banks.fi"
c
      INTEGER iDet(*),iFLTceF,iFLTceL,iHBce0,iHBce,iHBla,iHBpla,
     &        jDetInf,jDetGeo,jCellGeo,kDetInf,
     &        kDet(L1DETSPElen),iplateA,iplateB,
     &        iPlateUF,iPlateUL,iPlateLF,iPlateLL,
     &        iLeftPlate,icase,idiff,iFiEX,iLaEX,
     &        iHBceX,iHBceY,inCol,inRow

      INTEGER iType,iFLTce,link,iHBid,iFLTce1,iFLTce2
      INTEGER JBYT
      EXTERNAL JBYT
c
c     For muon purposes
c
c      INTEGER nWires,iWire,nSeqPlate,iPlateUF,iPlateUL,iPlateAUF
c     $     ,iPlateAUL,iPlateBUF,iPlateBUL,iPlateLF,iPlateLL,iPlateALF
c     $     ,iPlateALL,iPlateBLF,iPlateBLL,iPlateSord,iPlateASord
c     $     ,iPlateBSord,iPlateS,iPlateAS,iPlateBS,iSublayer,iCount
c     $     ,iCountA,iCountB,ierr,iHBceX,iHBceY,inCol,inRow,iCell
c     $     ,lDetGeo,kDetGeo,kDetInf,kRow
       INTEGER iPreMU3det,iPreMU4det,iPreMX3det,iPreMX4det,
     &     iMU1det,iMU2det,iMU3det,iMU4det
       INTEGER L1DETSL,MUor
       LOGICAL first,secondMSGC
       DATA first /.TRUE./
c
       IF(first)  THEN  ! initialization
        iPreMU3det = L1DETSL('MUP3')
        iPreMU4det = L1DETSL('MUP4')
        iPreMX3det = L1DETSL('MXP3')
        iPreMX4det = L1DETSL('MXP4')
        iMU1det = L1DETSL('MUD1')
        iMU2det = L1DETSL('MUD2')
        iMU3det = L1DETSL('MUD3')
        iMU4det = L1DETSL('MUD4')
        first = .FALSE.
       ENDIF
c
       secondMSGC = .FALSE.
      CALL UCOPY(iDet(1),kDet(1),L1DETSPElen) ! save det information
      CALL l1detif(iDet,jDetGeo,jDetInf,jCellGeo)
      iType = IQ(jDetInf+L1DETINFhbtype)    ! Type of detector
c
      iHBce0  = ABS(iHBid)/10000
      iHBce = iHBce0
      iHBpla = MOD(ABS(iHBid),10000)
c
      IF ( iType.eq.L1DETtypeTT ) THEN
       iFLTce = (iHBce+1)/2
      ELSE IF ( iType.eq.L1DETtypeMS ) THEN
       IF(MOD(ABS(iHBpla-IQ(jDetInf+L1DETINFplate)),2).NE.0)  THEN
        secondMSGC = .TRUE.              ! second section of chamber
        iHBce = iHBce0+IQ(jDetInf+L1DETINFnw1) ! add first section
        iHBpla = iHBpla-1                     ! refer to first section
       ENDIF
       iFLTce = (iHBce-1)/L1DETmsgOR + 1
      ELSE IF ( iType.eq.L1DETtypeEC ) THEN
       iFLTce = iHBce
      ELSE IF ( iType.eq.L1DETtypeMX ) THEN

c
c      HB hit identifier for pixel chamber will be processed
c      later (see below)

       iFLTce = iHBce


      ELSE IF ( iType.eq.L1DETtypeMU ) THEN
       iFLTce = iHBce
       IF(iDet(L1DETSPEdet).EQ.iMU1det)  THEN
        MUor = L1DETmuOR(1)
       ELSEIF(iDet(L1DETSPEdet).EQ.iMU2det)  THEN
        MUor = L1DETmuOR(2)
       ELSEIF(iDet(L1DETSPEdet).EQ.iMU3det)  THEN
        MUor = L1DETmuOR(3)
       ELSEIF(iDet(L1DETSPEdet).EQ.iMU4det)  THEN
        MUor = L1DETmuOR(4)
       ELSE
        MUOR = 1  ! Pretrigger
       ENDIF
      ELSE
       WRITE(L1LUNprn,1000) 1
       GOTO 777
      END IF
c


      IF ( ITYPE.NE.L1DETtypeMu.and.
     &     ITYPE.NE.L1DETtypeMX) THEN ! if it is not outer muon chamber

       IF ( iHBpla.ne.IQ(jDetInf+L1DETINFplate) ) THEN
        IF(IQ(jDetInf+L1DETINFsecA).NE.0)  THEN ! export section A
         kDet(L1DETSPEsection) = IQ(jDetInf+L1DETINFsecA)
         CALL l1detif(kDet,jDetGeo,kDetInf,jCellGeo)
         IF(jDetGeo.NE.0)  THEN
          IF(IQ(kDetInf+L1DETINFplate).EQ.iHBpla) THEN           ! plate found
           IF(secondMSGC) THEN
            iHBce = iHBce0+IQ(kDetInf+L1DETINFnw1)
            iFLTce = (iHBce-1)/L1DETmsgOR + 1
           ENDIF
           iFiEX = IQ(jDetInf+L1DETINFfltFiEXa)
           iLaEX = IQ(jDetInf+L1DETINFfltLaEXa)
           GOTO 100             ! Plane found
          ENDIF
         ELSE
          WRITE(L1LUNprn,1000) 2
         ENDIF
        ENDIF
        IF(IQ(jDetInf+L1DETINFsecB).NE.0)  THEN ! export section B
         kDet(L1DETSPEsection) = IQ(jDetInf+L1DETINFsecB)
         CALL l1detif(kDet,jDetGeo,kDetInf,jCellGeo)
         IF(jDetGeo.NE.0)  THEN
          IF(IQ(kDetInf+L1DETINFplate).EQ.iHBpla) THEN ! plate found
           IF(secondMSGC) THEN
            iHBce = iHBce0+IQ(kDetInf+L1DETINFnw1)
            iFLTce = (iHBce-1)/L1DETmsgOR + 1
           ENDIF
           iFiEX = IQ(jDetInf+L1DETINFfltFiEXb)
           iLaEX = IQ(jDetInf+L1DETINFfltLaEXb)
           GOTO 100             ! Plane found
          ENDIF
         ELSE
          WRITE(L1LUNprn,1000) 3
          GOTO 777
         ENDIF
        ENDIF
        GOTO 777      ! nothing found
c
 100    CONTINUE
        IF (iFLTce.ge.iFiEX.and.iFLTce.le.iLaEX) THEN
c
         link = IQ(jDetInf+L1DETINForNeiS) - 1
         IF (IQ(jDetInf+L1DETINFfltLa).lt. ! right neighbour
     &        IQ(jDetInf+L1DETINFlast)) THEN
          iFLTce1 = iLaEX-iFLTce + 1
          iFLTce2 = iFLTce1-link
         ELSE
          iFLTce2 = iFLTce-iFiEX+1
          iFLTce1 = iFLTce2 - link
         END IF
         IF ( IQ(jDetInf+L1DETINForNei).gt.0 ) THEN
          iFLTce1 = (iFLTce1-1) / IQ(jDetInf+L1DETINForNei) + 1
          iFLTce2 = (iFLTce2-1) / IQ(jDetInf+L1DETINForNei) + 1
         ELSE
          iFLTce1 = INT((iFLTce1-1)*IQ(jDetInf+L1DETINForNei)*(-1))+1
          iFLTce2 = INT((iFLTce2-1)*IQ(jDetInf+L1DETINForNei)*(-1))+1
         END IF
         IF (IQ(jDetInf+L1DETINFfltLa).lt. ! right neighbour
     &        IQ(jDetInf+L1DETINFlast)) THEN
          iFLTce1 = IQ(jDetInf+L1DETINFlast)-iFLTce1+1
          iFLTce2 = IQ(jDetInf+L1DETINFlast)-iFLTce2+1
          iFLTce1 = MIN(iFLTce1,IQ(jDetInf+L1DETINFlast))
          iFLTce2 = MIN(iFLTce2,IQ(jDetInf+L1DETINFlast))
         ELSE
          iFLTce1 = MAX(iFLTce1,1)
          iFLTce2 = MAX(iFLTce2,1)
         END IF
         iFLTce = MIN(iFLTce1,iFLTce2)
         link   = MAX(iFLTce1,iFLTce2) - iFLTce
        ELSE
         GOTO 777
        END IF
       ELSE
        iFLTce = iFLTce + IQ(jDetInf+L1DETINFfltFi) - 1
        link = 0
       END IF
c

      ELSE IF(ITYPE.eq.L1DETtypeMU)THEN ! if this is outer muon chamber
C
       iLeftPlate = 0           ! no ref. plate yet
       iPlateUF = IQ(jDetInf+L1DETINFMuPlateUF)
       iPlateUL = IQ(jDetInf+L1DETINFMuPlateUL)+1 ! back section
                                                  ! considered as well
       iPlateLF = IQ(jDetInf+L1DETINFMuPlateLF)
       iPlateLL = IQ(jDetInf+L1DETINFMuPlateLL)+1
 200   CONTINUE
       IF(iHBpla.GE.MIN(iPlateUF,iPlateUL).AND.
     &    iHBpla.LE.MAX(iPlateUF,iPlateUL)) THEN ! belong to upper
                                                   ! part
        iLeftPlate = IQ(jDetInf+L1DETINFMuPlateUF)
       ELSEIF(iHBpla.GE.MIN(iPlateLF,iPlateLL).AND.
     &    iHBpla.LE.MAX(iPlateLF,iPlateLL)) THEN ! belong to low
                                                   ! part
        iLeftPlate = IQ(jDetInf+L1DETINFMuPlateLF)
       ELSEIF(iHBpla.EQ.
     &       IQ(jDetInf+L1DETINFMuImport1)/10000) THEN ! extra chamber
        iHBpla = MOD(IQ(jDetInf+L1DETINFMuImport1),10000) ! refer to
        GOTO 200    ! try again
       ELSEIF(iHBpla.EQ.
     &       IQ(jDetInf+L1DETINFMuImport1)/10000+1) THEN ! extra chamber
        iHBpla = MOD(IQ(jDetInf+L1DETINFMuImport1),10000)+1 ! refer to
        GOTO 200    ! try again
       ELSEIF(iHBpla.EQ.
     &       IQ(jDetInf+L1DETINFMuImport2)/10000) THEN ! extra chamber
        iHBpla = MOD(IQ(jDetInf+L1DETINFMuImport2),10000) ! refer to
        GOTO 200    ! try again
       ELSEIF(iHBpla.EQ.
     &       IQ(jDetInf+L1DETINFMuImport2)/10000+1) THEN ! extra chamber
        iHBpla = MOD(IQ(jDetInf+L1DETINFMuImport2),10000)+1 ! refer to
        GOTO 200    ! try again
       ELSE       ! try neighbous in upper parts only
        DO icase=1,2  ! loop over neighbous A&B
         kDet(L1DETSPEsection) = 0
         IF(icase.EQ.1.AND.
     &        IQ(jDetInf+L1DETINFsecA).GT.0)  THEN ! try A
          kDet(L1DETSPEsection) = IQ(jDetInf+L1DETINFsecA)
         ELSEIF(icase.EQ.2.AND.
     &         IQ(jDetInf+L1DETINFsecB).GT.0)  THEN ! try B
          kDet(L1DETSPEsection) = IQ(jDetInf+L1DETINFsecB)
         ENDIF
         IF(kDet(L1DETSPEsection).NE.0)  THEN
          CALL l1detif(kDet,jDetGeo,kDetInf,jCellGeo)
          IF(jDetGeo.NE.0)  THEN
           iPlateUF = IQ(kDetInf+L1DETINFMuPlateUF)
           iPlateUL = IQ(kDetInf+L1DETINFMuPlateUL)+1
           IF(iHBpla.GE.MIN(iPlateUF,iPlateUL).AND.
     &          iHBpla.LE.MAX(iPlateUF,iPlateUL)) THEN ! found
            iLeftPlate = IQ(jDetInf+L1DETINFMuPlateUF)
           ENDIF
          ELSE
           WRITE(L1LUNprn,1000) 4
           GOTO 777             ! exit
          ENDIF
         ENDIF
        ENDDO
       ENDIF
       IF(iLeftPlate.LE.0)    GOTO 777 ! nothing found: exit
c
c      plane found: calculate FLT cell number
c
       idiff = iHBpla-iLeftPlate
       iFLTce = IQ(jDetInf+L1DETINFfltFi) ! first cell in ref. section
       IF(iPlateUF.GT.iPlateUL) idiff = -idiff ! inverse numeration
       IF(iHBid.GT.0) THEN  ! wire chamber
        IF(MOD(idiff,2).EQ.0)  THEN ! front section
         iFLTce = iFLTce+idiff/MUor*IQ(jDetInf+L1DETINFMuNW1) ! first wire for this section
         IF(IQ(jDetInf+L1DETINFMuCount).LT.0.AND.MUor.EQ.1)
     &        iFLTce = iFLTce+1 ! first cell is in back section
        ELSE                    ! back section
         iFLTce = iFLTce+(idiff-1)/MUor*IQ(jDetInf+L1DETINFMuNW1)
         IF(IQ(jDetInf+L1DETINFMuCount).GT.0.AND.MUor.EQ.1)
     &        iFLTce = iFLTce+1 ! first cell is in front section
        ENDIF
        iFLTce = iFLTce+2/MUor*(iHBce-1) ! shift inside section
       ELSE   ! pads
        IF(MOD(idiff,2).EQ.0)  THEN ! front section
        iFLTce = iFLTce+idiff       ! double chambers, 2pad per chamber
       ELSE
        iFLTce = iFLTce+(idiff-1)   ! back section
       ENDIF
        iFLTce = (MOD(iHBce,100)-1)*IQ(jDetInf+L1DETINFnRow)+ ! shift in Y
     &       iFLTce+iHBce/100-1       !        X position
       ENDIF
       link = 0
C
C      If this is inner (pixel) muon  chamber
C
      ELSE IF(ITYPE.eq.L1DETtypeMX) THEN
       IF ( iHBpla.EQ.IQ(jDetInf+L1DETINFplate) ) THEN
c
c       iFLTce contains separate numbers for x and y
c
        iHBceY=MOD(iHBce,100)   ! extraction of x and y values
        iHBceX=iHBce/100        !
        inRow=IQ(jDetInf+L1DETINFnRow) ! number of cells in row
        IF(iDet(L1DETSPEdet).NE.iPreMX3det.AND.
     &       iDet(L1DETSPEdet).NE.iPreMX4det)  THEN            ! muon pixels
         iFLTce = (iHBceY-1)*inRow+iHBceX
        ELSE   ! muon pretrigger: ored in X
c        L1DETINFfltFiEX: # of firs pixel formed the first pad
          iFLTce = (iHBceY-1)*inRow+
     &        (iHBceX-IQ(jDetInf+L1DETINFfltFiEXa))/L1DETmupxor+1
        ENDIF
        link = 0
       ELSE
        GOTO 777
       ENDIF
      ENDIF                     ! end of if on detector type



      IF ( iFLTce.LE.IQ(jDetInf+L1DETINFlast).AND.iFLTce.GT.0) THEN
       iFLTceF = MAX(0,iFLTce)
       iFLTceL = MIN(iFLTce+link,IQ(jDetInf+L1DETINFlast))
       iFLTceL = MAX(0,iFLTceL,iFLTceF)
      ELSE
       GOTO 777
      END IF
      RETURN
c
 777  CONTINUE    ! nothing found
      iFLTceF = 0
      iFLTceL = 0
      RETURN
 1000 FORMAT('L1TRACE ==> invalid detector found. Case=',I2)
c
      END


