
//    Boris Fominykh 3.08.99
//  the code to mask the muon detector hot channels  

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

typedef unsigned short Word;

extern "C" int MuHotListPut(char*,Word*);
extern "C" int MuHotListItl(char*,int);

struct MuHots {
  int Nhots;
  int Length;
  const int NhotGet = 200;
  char* CableName;
  Word* Status;
};

static MuHots  MHL;

extern "C" 
{

void MuHotListRead() 
{
  MHL.Nhots = 0;
// open the file
  FILE *hl = fopen(getenv("MUON_BADFILE"), "r");
  if(!hl) {
    arteMsg << "NO muon list of hot channels" << endl;
    arteMsg.error();
    return;
  }

// loops over lines: max 5000 lines
  int nline=0;
  char line[81];
  for(int il=0; il<5000; il++) {
// read the line
    if(fgets(line,sizeof(line),hl) == NULL) {
      fclose(hl);
      if(feof(hl)) return;
      else { 
        arteMsg << "MuHotList: error in reading Muon Hot List";
        arteMsg.error();
      }
    }
    ++nline;
    char *card = &line[0];

// read the first word from the line
    char cablname[10];
    Word status;
    int nitem=sscanf(card,"%s",cablname);

// pass  blank lines and commented cards
    if(nitem == -1) continue;
    if(cablname[0]=='#' || cablname[0]=='*' || cablname[0]=='/') continue;
    card+=MuHotListItl(card,nitem);

// end of file
    if(!strcmp(cablname,"END")) {
      fclose(hl);

// print the collection
//      cout << "structure MuHots, Nhots = " << dec << MHL.Nhots;
//      cout << " length " << MHL.Length << endl;
//      if(MHL.Nhots > 0) {
//        for(int i=0;i<MHL.Nhots;i++) {  
//          strncpy(cablname,MHL.CableName+10*i,10);
//          status = *(MHL.Status+2*i);
//          cout << dec << i << ": " << cablname << " status " << hex << status << endl;
//        }
//      }

      return;
    }

// read the status and make the mask
    status = 0xffff;
    for(int i=0;i<16;i++) {
      int st = 0; 
      Word one    = 0x1;
      nitem=sscanf(card,"%d",&st);
      if(nitem != 1) break;
      card+=MuHotListItl(card,nitem);
      status = status ^ (one << st);
    }

// print the card
//    cout << dec << nline << ": " << line << endl;
//    cout << dec << nline << ":  cablname " << cablname << " status " << hex << status << endl;

// add the line to the structure
    int check = MuHotListPut(cablname,&status);
    if(check != 0) {
      arteMsg << "MuHotList: can not write the list";
      arteMsg.error();
      return;
    }
  }
  return;
}

int MuHotListItl(char *s,int nitem) {
  int i;
  char* s0=s;
  for (i=0;i<nitem;i++) {
    while (*s==' ') s++;
    while (*s!=' ' && *s != '\n' ) s++;
  }
  return s-s0;
}

Word MuHotListCheck(char* name) {
  char nm[10];
  strncpy(nm,name,9);
  nm[9]='\0';
  char* cht = "t";
  char* chp = "p";
  char* chA = "A";
  char* chB = "B";
  char* chC = "C";
  char* chD = "D";
  char chi = nm[1];
  char ch = nm[8];
// the case of wires
  if(chi == *cht) {
    if(ch == *chA) nm[8] = *chB;
    if(ch == *chB) nm[8] = *chA;
  }
// pads
  if(chi == *chp) {
    if(ch == *chA) nm[8] = *chB;
    if(ch == *chB) nm[8] = *chA;
    if(ch == *chC) nm[8] = *chD;
    if(ch == *chD) nm[8] = *chC;
  }

  if(MHL.Nhots > 0) {
    for(int i=0;i<MHL.Length;i++) {
      char* cablname = MHL.CableName+10*i;
      if(!strcmp(cablname,nm)) return *(MHL.Status+2*i);
    }
  }
  return 0xffff;
}

int MuHotListPut(char* name,Word* stat) {
  begin:  
  if(MHL.Length > 0 && MHL.Nhots < MHL.Length) {
    char* cablname = MHL.CableName + 10*MHL.Nhots;
    strncpy(cablname,name,10);
    cablname[9]='\0';
    Word* status = MHL.Status + 2*MHL.Nhots;
    *status = *stat;
    MHL.Nhots += 1;
//    cout << "MuHotListPut: added Nhot= " << dec << MHL.Nhots << endl;
    return 0;
  }  
  else {
    if(MHL.Length <= 0) {
      char* cablname = new char[10*MHL.NhotGet];
      if(cablname == NULL) return 1;
      Word* status = new Word[2*MHL.NhotGet];
      if(status == NULL) return 1;
      MHL.CableName = cablname;
      MHL.Status = status;
      MHL.Length = MHL.NhotGet;
      MHL.Nhots  = 0;
//      cout << "MuHotListPut: length= " << dec << MHL.Length;
//      cout << " Nhots= " << MHL.Nhots << endl;
      goto begin;      
    }    
    else {
      int length = MHL.Length+MHL.NhotGet;
      char* cablname = new char[10*length];
      if(cablname == NULL) return 1;
      Word* status = new Word[2*length];
      if(status == NULL) return 1;
// copy the old arrays into the new ones
      strncpy(cablname,MHL.CableName,10*MHL.Nhots);
      for(int i=0;i<MHL.Nhots;i++) 
      *(status+2*i)=*(MHL.Status+2*i);
      delete []MHL.CableName;
      delete []MHL.Status;
      MHL.CableName = cablname;
      MHL.Status = status;
      MHL.Length = length;
//      cout << "MuHotListPut: length= " << dec << MHL.Length;
//      cout << " Nhots= " << MHL.Nhots << endl;
      goto begin;      
    }    
  }
}

void MuHotListIni() {
  MHL.Nhots = 0;
  MHL.Length= 0;
  MHL.CableName = NULL;
  MHL.Status = NULL;
  return;
}

void MuHotListFree() {
  delete []MHL.CableName;
  delete []MHL.Status;
  return;
}

}




