
* B.Fominykh  14.06.98
* a program of MUREC-B package
* book the temporary working tables for the muon reconstruction
C
      SUBROUTINE MURBWTB
C-    ==================
      IMPLICIT NONE
*
#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"

#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* TMP6 - working table for seeds
*  1 I - JLSTR  - link to tree table MUTR
*  2 I - SDSTAT - seed status (-1 - no linked hits, +1 - accepted) 
*  3 I - NRC - reconstructed track number (table RTRA)
*  4 F - PM  - measured momentum GeV/c
*  5 F - Z0  - parameter of track (not fitted)
*  6 F - CX  - parameter 1 of track fit x=tx*(z-z0)+cx
*  7 F - CY  - parameter 2 of track fit x=tx*(z-z0)+cx
*  8 F - TX  - parameter 3 of track fit y=ty*(z-z0)+cy
*  9 F - TY  - parameter 4 of track fit y=ty*(z-z0)+cy
* 10 F - COV11 - covariance
* 11 F - COV12 - covariance
* 12 F - COV13 - covariance
* 13 F - COV14 - covariance
* 14 F - COV21 - covariance
* 15 F - COV22 - covariance
* 16 F - COV23 - covariance
* 17 F - COV24 - covariance
* 18 F - COV31 - covariance
* 19 F - COV32 - covariance
* 20 F - COV33 - covariance
* 21 F - COV34 - covariance
* 22 F - COV41 - covariance
* 23 F - COV42 - covariance
* 24 F - COV43 - covariance
* 25 F - COV44 - covariance
* 26 F - MSE (multiple scattering error) in 1st superlayer
* 27 F - MSE in 2nd superlayer
* 28 F - MSE between 1st and 2nd superlayers
* 29 F - MSE in 3d superlayer
* 30 F - MSE between 2nd and 3d superlayers
* 31 F - MSE in 4th superlayer
* 32 F - MSE between 3d and 4th superlayers
* 32 F - MSE between 3d and 4th superlayers
* 33 F - momentum of seed inside 1st superlayer
* 34 F - momentum of seed inside 2nd superlayer
* 35 F - momentum of seed inside 3d superlayer
* 36 F - momentum of seed inside 4th superlayer
* 37 I - NMC - MC track number (table MTRA)
* 38 I - ID  - ID of MC track
* 39 F - P   - MC momentum GeV/c
* 40 F - PX  - px of MC track
* 41 F - PY  - py of MC track
* 42 F - PZ  - pz of MC track
* 43 I - NUM - queue number for processing
* 44 F - ZST - start Z coordinate of track
* 45 I - MAP11 - hit map: number of hits in superlayer 1 layer 1
* 46 I - MAP12 - hit map: number of hits in superlayer 1 layer 2
* 47 I - MAP13 - hit map: number of hits in superlayer 1 layer 3
* 48 I - MAP14 - hit map: number of hits in superlayer 1 layer 4
* 49 I - MAP21 - hit map: number of hits in superlayer 2 layer 1
* 50 I - MAP22 - hit map: number of hits in superlayer 2 layer 2
* 51 I - MAP23 - hit map: number of hits in superlayer 2 layer 3
* 52 I - MAP24 - hit map: number of hits in superlayer 2 layer 4
* 53 I - MAP31 - hit map: number of hits in superlayer 3 layer 1
* 54 I - MAP32 - hit map: number of hits in superlayer 3 layer 2
* 55 I - MAP41 - hit map: number of hits in superlayer 4 layer 1
* 56 I - MAP42 - hit map: number of hits in superlayer 4 layer 2
* 57 F - Z1    - middle Z coordinate of MU1.
* 58 F - Xext1 - X coordinate of track extrapolation to MU1
* 59 F - Yext1 - Y coordinate of track extrapolation to MU1
* 60 F - SX1   - X coordinate error in MU1
* 61 F - SY1   - Y coordinate error in MU1
* 62 F - SW1   - sloped wire coordinate error in MU1
* 63 F - Z2    - middle Z coordinate of MU2.
* 64 F - Xext2 - X coordinate of track extrapolation to MU2
* 65 F - Yext2 - Y coordinate of track extrapolation to MU2
* 66 F - SX2   - X coordinate error in MU2
* 67 F - SY2   - Y coordinate error in MU2
* 68 F - SW2   - sloped wire coordinate error in MU2
* 69 F - Z3    - middle Z coordinate of MU3.
* 70 F - Xext3 - X coordinate of track extrapolation to MU3
* 71 F - Yext3 - Y coordinate of track extrapolation to MU3
* 72 F - SX3   - X coordinate error in MU3
* 73 F - SY3   - Y coordinate error in MU3
* 74 F - Z4    - middle Z coordinate of MU4.
* 75 F - Xext4 - X coordinate of track extrapolation to MU4
* 76 F - Yext4 - Y coordinate of track extrapolation to MU4
* 77 F - SX4   - X coordinate error in MU4
* 78 F - SY4   - Y coordinate error in MU4
*
      NSEEDMX=NSDMXP
      CALL MMBWRK(JTMP6,0,78,100)
*
* temporary working table for tree structure - MUTR
*  1 I -  ITRST - branch status (1-active or 0-dead)
*  2 I -  JLMBR - link to mother branch
*  3 I -  JMLCH - last common hit in mother branch
*  4 I -  JLTSD - link to seed table MUSD
*  5 I -  JLTFS - link to final tree status table MUFS
*  6 I -  NHIM  - collected number of hits in mu-superlayer
*  7 I -  NCOPY - number of copies
*  8 I -  NHIT  - accumulated number of hits for the branch
*  9 I -  MAP11 - hit map: number of hits in superlayer 1 layer 1
* 10 I -  MAP12 - hit map: number of hits in superlayer 1 layer 2
* 11 I -  MAP13 - hit map: number of hits in superlayer 1 layer 3
* 12 I -  MAP14 - hit map: number of hits in superlayer 1 layer 4
* 13 I -  MAP21 - hit map: number of hits in superlayer 2 layer 1
* 14 I -  MAP22 - hit map: number of hits in superlayer 2 layer 2
* 15 I -  MAP23 - hit map: number of hits in superlayer 2 layer 3
* 16 I -  MAP24 - hit map: number of hits in superlayer 2 layer 4
* 17 I -  MAP31 - hit map: number of hits in superlayer 3 layer 1
* 18 I -  MAP32 - hit map: number of hits in superlayer 3 layer 2
* 19 I -  MAP41 - hit map: number of hits in superlayer 4 layer 1
* 20 I -  MAP42 - hit map: number of hits in superlayer 4 layer 2
* 21 F -  SDDH  - sum of wire residuals squared
* 22 F -  SCHI  - sum of hit chi**2
* 23 F - Z0  - parameter of track (not fitted)
* 24 F - par1 =CX- parameter of line fit x=tx*(z-z0)+cx
* 25 F - par2 =CY- parameter of line fit y=ty*(z-z0)+cy
* 26 F - par3 =TX- parameter of line fit x=tx*(z-z0)+cx
* 27 F - par4 =TY- parameter of line fit y=ty*(z-z0)+cy
* 28 F -  COV11 - covariance
* 29 F -  COV12 - covariance
* 30 F -  COV13 - covariance
* 31 F -  COV14 - covariance
* 32 F -  COV21 - covariance
* 33 F -  COV22 - covariance
* 33 F -  COV22 - covariance
* 34 F -  COV23 - covariance
* 35 F -  COV24 - covariance
* 36 F -  COV31 - covariance
* 37 F -  COV32 - covariance
* 38 F -  COV33 - covariance
* 39 F -  COV34 - covariance
* 40 F -  COV41 - covariance
* 41 F -  COV42 - covariance
* 42 F -  COV43 - covariance
* 43 F -  COV44 - covariance
* 44 I -  IFST2 - result of final choice (1-branch was accepted, 0-rejected)
* 45 F -  CHISB - chi**2 for relation seed-branch
* 46 F -  EST1  - estimator 1
* 47 F -  EST2  - estimator 2
* 48 I -   IHBP - hit 1  ; pointer to cluster table MUCL
* .....................................
* 97 I -   IHBP - hit 50; pointer to cluster table MUCL
* 98 F -   DHT  - hit 1  ; distance from cluster to track
* .....................................
*147 F -   DHT  - hit 50; distance from cluster to track
*148 F -   CHIH - hit 1  ; chi**2 of cluster
* ....................................
*197 F -   CHIH - hit 50; chi**2 of cluster
*
* length of constant part
      LCMUTR=47
* max number of clusters per branch
      NHMUTR=50
* max number of branchs in the tree
      NBMUTR=NBMTRP
*
      CALL MMBWRK(JTMP7,0,197,200)
*
* table of muon hits - MUHT
*  1 I - JLMHH - link to table HITB
*  2 I - RLAY  - reconstruction layer
*  3 I - MUSL  - muon superlayer
*  4 I - LAY   - muon layer inside superlayer
*  5 I - IHTP  - hit type (1-wire,2-pad,3-pixel)
*  6 R - Z     - z-coordinate
*  7 R - SINR  - sin_rotation
*  8 R -  D,X  - d for wires and x for pads and pixels
*  9 R - Y1,Y  - Y_min for wires and y for pads and pixels
* 10 R - Y2,0. - Y_max for wires and 0. for pads and pixels
* 11 R - SIG1  - sigma_d for wires and sigma_x for pads and pixels
* 12 R - SIG2  - 0. for wires and sigma_y for pads and pixels
* 13 I - NCLUS - cluster number
* 14 I - NMCTR - number of MC-tracks produced this hit
* 15 I - MCT1  - 1st MC track number
* 16 I - MCT2  - 2nd MC track number
* 17 I - MCT3  - 3rd MC track number
* 18 I - MCT4  - 4th MC track number
* 19 I - MCT5  - 5th MC track number
*
* max number of muon hits
      NMUHMX=NMHMXP
      CALL MMBWRK(JTMP9,0,19,500)
*
*
* table of muon clusters - MUCL
*  1 I - JSCL  - status of cluster (0-dead,1-active)
*  2 I - LATR  - inner layer number for grouth of tree
*  3 I - MUSL  - muon superlayer
*  4 I - LAY   - muon layer inside superlayer
*  5 I - ICTP  - cluster type (1-wire,2-pad,3-pixel)
*  6 R - Z     - z-coordinate
*  7 R - SINR  - sin_rotation
*  8 R -  D,X  - d for wires and x for pads and pixels
*  9 R - Y1,Y  - Y_min for wires and y for pads and pixels
* 10 R - Y2,0. - Y_max for wires and 0. for pads and pixels
* 11 R - SIG1  - sigma_d for wires and sigma_x for pads and pixels
* 12 R - SIG2  - 0. for wires and sigma_y for pads and pixels
* 13 I - NHTCL - number of hits in cluster
* 14 I - NCLUS - number of cluster in the reco layer
* 15 I - JLHST - link to 1st hit of cluster
* 16 I - JLHLS - link to last hit of cluster
* 17 I - ISEED - seed number
*
* max number of muon clusters
      NMUCMX=NMHMXP
      CALL MMBWRK(JTMP8,0,17,500)
*
*
 200  CONTINUE
      RETURN
      END




