*
*  B.Fominykh  21.06.98
*  the program of MUREC-B package
*  estimates the seed-branch coupling quality -> cuts and estimator
*  input:  IBRS - start branch number
*          IBRF - final branch number
*
      SUBROUTINE MURTRQU(IBRS,IBRF)
C-    =============================
      IMPLICIT NONE
#include "murec/MUCBTAB.fi"
#include "murec/MUCBPAR.fi"
      INTEGER IBR,IBRS,IBRF,JBR,ISD,JSD,IH,JH,IHT,JHT,MUSL,JSDM
      INTEGER I,NHMD,NHIS,IHTR,NML,IND(4,3),J
      INTEGER JSDHM,JBRHM,NHWS,NHPS
      REAL CHIS,CHIKF,SINR,COSR,DSD,SIG2,SIGX2,SIGY2,EST1,ERMS,RHWP
      REAL DIST
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      DO 100 IBR=IBRS,IBRF
        JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2

* kill the branches with chi**2/Nhit > CHITRM
        IF(IQ(JBR+8).LT.4) GOTO 99
        CHIKF=Q(JBR+22)/REAL(IQ(JBR+8))
        IF(CHIKF.GT.CHITRM) GOTO 99

* pointer to hit-map
        JBRHM=JBR+8
        ISD=IQ(JBR+4)
        JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
        JSDHM=JSD+44
* calculate the number of holes in the hit-map
        NML=0
* MU1
        IF(IQ(JBRHM+4).GT.0) GOTO 21
        IF(IQ(JBRHM+1).LE.0) NML=NML+1
        IF(IQ(JBRHM+2).LE.0) NML=NML+1
        IF(IQ(JBRHM+3).LE.0) NML=NML+1
  21    CONTINUE        
* MU2
        IF(IQ(JBRHM+8).GT.0) GOTO 22
        IF(IQ(JBRHM+5).LE.0) NML=NML+1
        IF(IQ(JBRHM+6).LE.0) NML=NML+1
        IF(IQ(JBRHM+7).LE.0) NML=NML+1
  22    CONTINUE        
* MU3
        IF(IQ(JBRHM+10).GT.0) GOTO 23
        IF(IQ(JBRHM+9).LE.1) NML=NML+1
  23    CONTINUE        
* MU4
        IF(IQ(JBRHM+12).GT.0) GOTO 24
        IF(IQ(JBRHM+11).LE.1) NML=NML+1
  24    CONTINUE        
        Q(JBR+47)=REAL(NML)

* kill the tracks with number of holes more NHOLCUT
        IF(NML.GT.NHOLCUT) GOTO 99
*
* hit-map difference between seed and branch
        NHMD=0
        DO I=1,12
          IF(IQ(JSDHM+I).GE.IQ(JBRHM+I)) THEN
            NHMD=NHMD+IQ(JSDHM+I)-IQ(JBRHM+I)
          ELSE
            NHMD=NHMD+IQ(JBRHM+I)-IQ(JSDHM+I)
          ENDIF
        ENDDO
        IF(NHMD.LT.0) NHMD=-NHMD

***        IF(NHMD.GT.5) GOTO 99

* pixel,wire and pad indicators for MU3,MU4
        DO I=1,4
          DO J=1,3
            IND(I,J)=0
          ENDDO
        ENDDO
* estimation of the seed-branch coupling chi^2
        Q(JBR+45)=1.E+8
        CHIS=0.
        DIST=0.
        NHIS=0
* loops over collected hits
        DO 50 IH=1,IQ(JBR+8)
          JH=JBR+LCMUTR+IH
          IHT=IQ(JH)
          JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
          MUSL=IQ(JHT+3)
          IF(MUSL.LE.2) THEN
            JSDM=JSD+6*MUSL+51
            ERMS=Q(JSD+25+MUSL)
          ELSE
            JSDM=JSD+5*MUSL+54
            ERMS=Q(JSD+23+2*MUSL)
          ENDIF
          IHTR=IQ(JHT+5)
          IND(MUSL,IHTR)=IND(MUSL,IHTR)+1
* the case of wire
          IF(IHTR.EQ.1) THEN
            SINR=Q(JHT+7)
            COSR=SQRT(1.-SINR*SINR)
* seed extrapolation in the detector system 
            DSD=Q(JSDM+1)*COSR-Q(JSDM+2)*SINR
* error of multiple scattering
            SIG2=ERMS**2
* error of extrapolation
            SIG2=SIG2+((Q(JSDM+3)*COSR)**2+(Q(JSDM+4)*SINR)**2)
* measument error
            SIG2=SIG2+Q(JHT+11)**2
*
            DIST=DIST+(Q(JHT+8)-DSD)**2
            CHIS=CHIS+(Q(JHT+8)-DSD)**2/SIG2
            NHIS=NHIS+1
* the case of pad or pixel                    
          ELSE
* error of multiple scattering
            SIGX2=ERMS**2
            SIGY2=ERMS**2
* error of extrapolation
            SIGX2=SIGX2+Q(JSDM+3)**2
            SIGY2=SIGY2+Q(JSDM+4)**2
* measument error
            SIGX2=SIGX2+Q(JHT+11)**2
            SIGY2=SIGY2+Q(JHT+12)**2
*
            DIST=DIST+(Q(JHT+8)-Q(JSDM+1))**2
            DIST=DIST+(Q(JHT+9)-Q(JSDM+2))**2
            CHIS=CHIS+(Q(JHT+8)-Q(JSDM+1))**2/SIGX2
            CHIS=CHIS+(Q(JHT+9)-Q(JSDM+2))**2/SIGY2
            NHIS=NHIS+2
          ENDIF
  50    CONTINUE

*        print*,' '
*        DO I=1,4
*          print 1001,I,IBR,IND(I,1),IND(I,2),IND(I,3)
* 1001   FORMAT(2X,'MuSl ',I2,' Br ',I3,' hits(w,pd,px): ',3I3)
*        ENDDO

* kill the cases when the pads are not acompanied by wires
        DO I=3,4
          IF(IND(I,3).EQ.0) THEN
            IF(IND(I,1)*IND(I,2).EQ.0) GOTO 99
          ENDIF
        ENDDO

* chi^2 of relation seed-branch
        Q(JBR+45)=CHIS/REAL(NHIS)

* kill the branch with chi**2/Nhit > CHISTM
        IF(Q(JBR+45).GT.CHISTM) GOTO 99

* estimator 1 = (seed-branch hit diff)/NhitSeed + chi**2/Nhit
***        EST1=CHIKF+REAL(NHMD-IQ(JBR+8))
***        EST1=REAL(NHMD)/REAL(NHIS)+Q(JBR+45)
        EST1=REAL(NML)+Q(JBR+45)

* the case of correctly connected pixels
        IF(IQ(JBRHM+4).GT.0.AND.IQ(JSDHM+4).GT.0.AND.
     +     IQ(JBRHM+8).GT.0.AND.IQ(JSDHM+8).GT.0.AND.
     +     IQ(JBRHM+10).GT.0.AND.IQ(JSDHM+10).GT.0.AND.
     +     IQ(JBRHM+12).GT.0.AND.IQ(JSDHM+12).GT.0) THEN
          DO I=1,3
            EST1=EST1+3.*REAL(IQ(JBRHM+I))
          ENDDO
          DO I=5,7
            EST1=EST1+3.*REAL(IQ(JBRHM+I))
          ENDDO
          EST1=EST1+3.*REAL(IQ(JBRHM+9))
          EST1=EST1+3.*REAL(IQ(JBRHM+11))
        ENDIF

        Q(JBR+46)=EST1
        IQ(JBR+1) =1
*
        GOTO 100
  99    IQ(JBR+1)=-1
        Q(JBR+46)=0.
 100  CONTINUE
*
 200  CONTINUE
      RETURN
      END




