#ifndef __POIROT_SUPERLAYERRECO_HH__
#define __POIROT_SUPERLAYERRECO_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
class poirotHit ;
class poirotCluster ;
#ifndef __POIROT_SECTORCLUSTER_HH__
#include "poirot/SectorCluster.hh"
#endif

class poirotSuperLayerReco
{
public:
  // typedefs, enumerates
  typedef vector<const poirotHit*> HitContainer ;
  typedef vector<poirotCluster*> ClusterContainer ;
  typedef vector<poirotSectorCluster> SectorClusterContainer ;

  // constructors, destructor, assignment
  poirotSuperLayerReco() ;
  virtual ~poirotSuperLayerReco() ;

  // setters and getters
  const ClusterContainer& GetClusters() const { return fClusters ; }
  //ClusterContainer& GetClusters() { return fClusters ; }
  const SectorClusterContainer& GetZeroClusters() const { return fZeroClusters ; }
  const SectorClusterContainer& GetPlusClusters() const { return fPlusClusters ; }
  const SectorClusterContainer& GetMinusClusters() const { return fMinusClusters ; }

  const HitContainer& GetHits() const { return fHits ; }
  void Add(const poirotHit* hit) { fHits.push_back(hit) ; }

  //HitContainer& GetHits() { return fHits ; }

  // other inlines
  int GetNHits() const { return fHits.size() ; } ;

  // other methods
  void Reset() ;
  int SearchClusters() ;
  void DumpHits(ostream& os=cout) const ;
  void DumpClusters(ostream& os=cout) const ;
  void AppendRSEG() ;  // append clusters to the RSEG bank

private: // private methods
  void SearchSectorClusters() ;
  void SortHits() ; //Still needed ?
private: // data members
  int fSuperLayerId ;                      // id of corresponding superlayer
  HitContainer fHits ;                     // Hits (not owner)
  ClusterContainer fClusters ;             // Reconstructed clusters 
  SectorClusterContainer fZeroClusters ;  // Clusters in zero stereo layer
  SectorClusterContainer fPlusClusters ;  // Clusters in plus stereo layer
  SectorClusterContainer fMinusClusters ; // Clusters in minus stereo layer
};

#endif
