#ifndef __POIROT_TRACK_HH__
#define __POIROT_TRACK_HH__

#ifndef __POIROT_RECONSTRUCTEDTRACKINTERFACE_HH__
#include "ReconstructedTrackInterface.hh"
#endif

class poirotTrackCandidate ;

class poirotTrack : public poirotReconstructedTrackInterface,
		 private poirotTrackDescription4D
{
public:
  // constructors, destructor, assignment
  poirotTrack() {} ;
  poirotTrack(const poirotTrackCandidate*) ; 
  virtual ~poirotTrack() {} ;

  // setters and getters
  using poirotTrackDescription4D::GetQ ;
  using poirotTrackDescription4D::GetCov ;
  using poirotTrackDescription4D::GetTx ;
  using poirotTrackDescription4D::GetTy ;
  using poirotTrackDescription4D::GetX ;
  using poirotTrackDescription4D::GetY ;
  virtual float GetMinChi2Probability() const { return fgMinChi2Probability ; }

  // other methods
  bool Fit(int) ;
  bool SearchHitsAndFit() ;
  bool Valid() ;

private:
  // methods
  bool ValidNHits(const poirotReconstructedHit* doNotTakeThisHit=0) const ;
  // data members
  static unsigned int fgMinNHits ;
  static int fgMaxNSteps ;
  static int fgMaxNStepsForEtaConvergence ;
  static int fgMaxNStepsForChi2Convergence ;
  static float fgMinChi2Probability  ;
};

#endif
