#include "poirot/SectorCluster.hh"


bool
poirotSectorCluster::SameSectorCluster(const poirotHit* lhs, const poirotHit* rhs)
{ 
  //   bool sameA = (lhs->GetGede()->GetEStereoAngle() == rhs->GetGede()->GetEStereoAngle()) &&
  //     (lhs->GetGede()->GetSectorId()==rhs->GetGede()->GetSectorId()) &&
  //     (abs(rhs->GetXColumn()-lhs->GetXColumn()) <=1 ) ;
  //   bool sameB = (lhs->GetGede()->GetEStereoAngle() == rhs->GetGede()->GetEStereoAngle()) &&
  //     (lhs->GetGede()->GetSectorId()==rhs->GetGede()->GetSectorId()) &&
  //     (fabs(rhs->GetRawX()-lhs->GetRawX()) <= 0.6*rhs->GetGede()->GetWirePitch() ) ;
  //   if(sameA != sameB) {
  //     cout << "SameSectorCluster" <<sameA << " " << sameB <<  endl
  // 	 << rhs->GetHITB() << " " << rhs->GetHITB()->gede << " "
  // 	 << rhs->GetXColumn() << " " << rhs->GetRawX() << " " 
  // 	 << rhs->GetGedeIndex() << " " << rhs->GetGede()->GetRawX() << endl
  // 	 << lhs->GetHITB() << " " << lhs->GetHITB()->gede << " "
  // 	 << lhs->GetXColumn() << " " << lhs->GetRawX() << " " 
  // 	 << lhs->GetGedeIndex() << " " << lhs->GetGede()->GetRawX() << endl ;
  //   }
  
  return (lhs->GetGede()->GetEStereoAngle() == rhs->GetGede()->GetEStereoAngle()) &&
    (lhs->GetGede()->GetSectorId()==rhs->GetGede()->GetSectorId()) &&
    (abs(rhs->GetXColumn()-lhs->GetXColumn()) <=1 ) ;
}

void 
poirotSectorCluster::Dump() const
{
  for(HitIterator hitIt = begin() ; hitIt!= end() ; hitIt++)
    cout << (*hitIt)->GetXColumn() << "(" 
	 << (*hitIt)->GetRawX() << "," 
	 << (*hitIt)->GetRawZ() << ") " ;
  cout << endl ;
}

bool
poirotSectorCluster::ValidNHits() const
{
  //   static const int fgMaxNHitsPerMonolayer=2;
  //   int monolayerOcc[4] = {0,0,0,0} ;
  //   for(HitIterator hitIt = begin() ; hitIt!= end() ; hitIt++) 
  //     monolayerOcc[(*hitIt)->GetMonoLayer()]++ ;
  //   return monolayerOcc[0]<=fgMaxNHitsPerMonolayer && monolayerOcc[1]<=fgMaxNHitsPerMonolayer &&
  //     monolayerOcc[2]<=fgMaxNHitsPerMonolayer && monolayerOcc[3]<=fgMaxNHitsPerMonolayer ;

  // Here too, it is important that the wires are ordered !!
  static const int fgMaxClusterWidth = 2 ; 
  return !fHits.empty() && 
    (fHits.size()==1 || (abs(fHits.front()->GetXColumn()-
			     fHits.back()->GetXColumn())<fgMaxClusterWidth)) ;
  //SameSectorCluster(fHits.front(),fHits.back())) ;
} 

signed char
poirotSectorCluster::GetLRSign(const poirotHit* hitIt) const {
  signed char sign(0) ;
  if(back()->GetXColumn()-front()->GetXColumn()>0) {
    int prWireIndex=hitIt->GetXColumn() ;
    float averageXColumn = 0.5*(front()->GetXColumn()+ 
				back()->GetXColumn()) ;
    // 0.1 just for safety (avwirenr is not int)
    if(prWireIndex > averageXColumn+0.1)  sign=-2 ; 
    else if(prWireIndex < averageXColumn-0.1) sign=+2 ;
  } else if(back()->GetXColumn()-front()->GetXColumn()<0) {
    cout << "Error in poirotSectorCluster::GetLRSign(...) " << endl ;
  }
  return sign;
}
  
