*CMZ :  4.05/03 30/05/96  17.49.08  by  Rainer Mankel
*CMZ :  4.04/01 26/03/96  15.00.19  by  Rainer Mankel
*CMZ :  4.04/00 17/12/95  15.47.26  by  Rainer Mankel
*-- Author :    Rainer Mankel   16/12/95

      subroutine digetw(ih,wc1,wc2)

*     **** deliver start and endpoint of wire/strip for hit ih
      implicit none

      integer ih                ! pointer to hitb table
      real wc1(3),              ! wire start point (WC), output
     +     wc2(3)               ! wire end  point (WC), output

      real w1(3), w2(3), tmin, tmax, txmin, txmax, tt, abase(2),
     +     m(2), tg
      integer pl, shp
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      pl = ihitb_gede(ih)
      shp = igede_shp(pl)
**      print *,' ih, x=', ih, fhitb_x(ih)

      if (shp.ne.1 .and. shp.ne. 2 .and. shp.ne.10
     +             .and. shp.ne.42 .and. shp.ne.34) then
         print *,' () digetw: unsupported shape,', shp
         go to 999
      endif

      if (fgede_sin(pl).eq.0.) then
         w1(1) = fhitb_x(ih)
         w1(2) = fgede_symn(pl)
         w1(3) = fhitb_z(ih)
         w2(1) = fhitb_x(ih)
         w2(2) = fgede_symx(pl)
         w2(3) = fhitb_z(ih)
      elseif (fgede_cos(pl).eq.0.) then
         w1(1) = fgede_sxmn(pl)
         w1(2) = -fhitb_x(ih) * fgede_sin(pl)
         w1(3) = fhitb_z(ih)
         w2(1) = fgede_sxmx(pl)
         w2(2) = -fhitb_x(ih) * fgede_sin(pl)
         w2(3) = fhitb_z(ih)
      else
*        **** describe hit line in plane coordinates
         abase(1) =   fhitb_x(ih) * fgede_cos(pl) ! offset vector
         abase(2) = - fhitb_x(ih) * fgede_sin(pl)

         m(1) = fgede_sin(pl)   ! normalized direction vector
         m(2) = fgede_cos(pl)

         if (shp.eq.10) then    ! convert to border coordinates
            tg = fgede_sin(pl) / fgede_cos(pl)
            abase(1) = abase(1) - tg * abase(2)
            m(1) = m(1) - tg * m(2)
         endif

**         print *,' abase=', abase
**         print *,' m=', m

         if (m(2).ne.0.) then   ! truncate wire in y
            tmin = (fgede_symn(pl) - abase(2)) / m(2)
            tmax = (fgede_symx(pl) - abase(2)) / m(2)
            if (tmin.gt.tmax) then
               tt = tmax
               tmax = tmin
               tmin = tt
            endif
         else
            tmin = -999.
            tmax =  999.
         endif
**         print *,' y limitation=', tmin, tmax

         if (m(1).ne.0.) then   ! truncate wire in x
            txmin = (fgede_sxmn(pl) - abase(1)) / m(1)
            txmax = (fgede_sxmx(pl) - abase(1)) / m(1)
            if (txmin.gt.txmax) then
               tt = txmax
               txmax = txmin
               txmin = tt
            endif
**            print *,' x limitation=', txmin, txmax
            tmin = amax1(tmin,txmin)
            tmax = amin1(tmax,txmax)
         endif

         if (shp.eq.10) then    ! convert back to plane coordinates
            tg = fgede_sin(pl) / fgede_cos(pl)
            abase(1) = abase(1) + tg * abase(2)
            m(1) = m(1) + tg * m(2)
         endif

**         print *,' digetw: tmin, tmax=', tmin, tmax

         w1(1) = abase(1) + m(1) * tmin
         w1(2) = abase(2) + m(2) * tmin
         w1(3) = fhitb_z(ih)
         w2(1) = abase(1) + m(1) * tmax
         w2(2) = abase(2) + m(2) * tmax
         w2(3) = fhitb_z(ih)
      endif

**      print *,' digetw: w1, w2=', w1, w2
*     **** rotation
      if (fgede_rot(2,pl).ne.0.) then
         wc1(1) = w1(1) * fgede_rot(1,pl) + w1(2) * fgede_rot(2,pl)
         wc1(2) =-w1(1) * fgede_rot(2,pl) + w1(2) * fgede_rot(1,pl)
         wc1(3) = w1(3)

         wc2(1) = w2(1) * fgede_rot(1,pl) + w2(2) * fgede_rot(2,pl)
         wc2(2) =-w2(1) * fgede_rot(2,pl) + w2(2) * fgede_rot(1,pl)
         wc2(3) = w2(3)
      else
         wc1(1) = w1(1)
         wc1(2) = w1(2)
         wc1(3) = w1(3)

         wc2(1) = w2(1)
         wc2(2) = w2(2)
         wc2(3) = w2(3)
      endif

**      print *,' digetw: ih, wc1, wc2=', ih, wc1, wc2

 999  end


