/* See skip_range.hh for details */

// Author R.Mizuk (mizuk@mail.desy.de)                       (19.02.99).
// Slightly modified by V.Balagura (balagura@mail.desy.de)   (20.02.99).

#include "ptset/skip_range.hh"

istream& operator>> (istream& is, SkipRange& ir) {
  char c;
  if ( !(is >> c) ) return is;
  if ( c != 's' && c != 'S' ) { is.setstate(ios::failbit); return is; }
  if ( !(is.get(c)) ) return is;
  if ( c != 'k' && c != 'K' ) { is.setstate(ios::failbit); return is; }
  if ( !(is.get(c)) ) return is;
  if ( c != 'i' && c != 'I' ) { is.setstate(ios::failbit); return is; }
  if ( !(is.get(c)) ) return is;
  if ( c != 'p' && c != 'P' ) { is.setstate(ios::failbit); return is; }
  if ( !(is >> ir.n) ) return is;
  return is;
}
ostream& operator<< (ostream& os, const SkipRange& ir) {
  return os << "skip " << ir.n;
}
