// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include "arte/arte.hh"
#include "rang/Geom.hh"
#include "rang/ThinPlane.hh"
#include <math.h>

//-- Constructor
rangerThinPlane::rangerThinPlane() {};

rangerThinPlane::rangerThinPlane(const ArtePointer<GEDE>& ge,
				 rangerNode* n) 
  : rangerThin(n->getState().fitMode()) { // construct from gede
  gede = ge;
  vol = rangerGeom::vol( ge );
  sPath = 1;
  z = vol->zRef();
  state->linExtrapVec( n->getState(), z);
}

rangerThinPlane::rangerThinPlane(const ArtePointer<GEDE>& ge,
				 rangerNode* n,const float path) 
  : rangerThin(n->getState().fitMode()) { // construct from gede
  gede = ge;
  vol = rangerGeom::vol( ge );
  sPath = path;
  z = vol->zRef();
  state->linExtrapVec( n->getState(), z);

}


