// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include "arte/arte.hh"
#include "rang/ThinWall.hh"
#include "rang/Geom.hh"
#include <math.h>

//-- Constructor
rangerThinWall::rangerThinWall() {
  vol = 0;
};

rangerThinWall::rangerThinWall(const ArtePointer<GWAL>& gw,
				 rangerNode* n)
  : rangerThin(n->getState().fitMode()) { // construct from gwal
  gwal = gw;
  vol = rangerGeom::vol( gw );
  sPath = 1;
  z = vol->zRef();
  state->linExtrapVec( n->getState(), z);
}


rangerThinWall::rangerThinWall(const ArtePointer<GWAL>& gw,
				 rangerNode* n,const float path)
  : rangerThin(n->getState().fitMode()) { // construct from gwal
  gwal = gw;
  vol = rangerGeom::vol( gw );
  sPath = path;
  z = vol->zRef();
  state->linExtrapVec( n->getState(), z);
}


