// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include <math.h>
#include "rang/SeedSet.hh"
#include "rang/DomLay.hh"
#include "rang/DomWin.hh"
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"


extern "C" {
  void rgsdlay_(rangerSeedSet*& ss,
		const int& maxLay,
		rangerDomLay* layVec[],
		int& nLay) {

    nLay = 0;

    // loop over domlays
    if (ss) {
      for (vector<rangerDomLay*>::iterator dli=ss->domlays().begin();
	 dli != ss->domlays().end(); ++dli) {
	if (nLay < maxLay) {
	  layVec[nLay] = (*dli);
// 	  (*dli)->win()->dump();
// 	  (*dli)->dump();
	  ++nLay;
	}
	else {
	arteMsg << "rgsdlay: overflowing nLay=" << nLay << endl;
	arteMsg.warn();
	break;
	}
      }
    }
  }
}



    



