// 
//  Author:  Rainer Mankel                     Created:  10-Oct-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// determine CMP bits for rseg. Optionally, OR with given bitmap.
// Result is returned. The rseg itself is not changed.

#include <iostream.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"

int rangerSetCmp(const ArtePointer<RSEG> rseg,const int cmp=0) {

  int CMP = cmp;
  for ( ArteRelationIterator<HITB> hitbIt = rseg->hitb.begin();
	hitbIt != rseg->hitb.end(); ++hitbIt ) {
    ArtePointer<HITB> hitb(*hitbIt);
    ArtePointer<GEDE> ge( hitb->gede );

    float zsl = 0.5 * (((ArtePointer<GESL>) ge->gesl)->z1 
		       +((ArtePointer<GESL>) ge->gesl)->z2);

    if (               zsl <  190) CMP = CMP | Rsegc::vxd;  // set functional bits
    if (zsl >=  190 && zsl <  670) CMP = CMP | Rsegc::magt;
    if (zsl >=  670 && zsl < 1000) CMP = CMP | Rsegc::patt;
    if (zsl >= 1000 && zsl < 1330) CMP = CMP | Rsegc::trit;
    if (zsl >= 1330 && zsl < 1400) CMP = CMP | Rsegc::ecal;
    if (zsl >= 1400              ) CMP = CMP | Rsegc::muon;

    switch (ge->cmp) {
    case 1:
      CMP = CMP | Rsegc::sil;
      break;
    case 2:
      CMP = CMP | Rsegc::wch;
      break;
    case 3:
      CMP = CMP | Rsegc::msg;
      break;
    case 4:
      CMP = CMP | Rsegc::ptc;
      break;
    case 5:
      CMP = CMP | Rsegc::rich;
      break;
    case 6:
      CMP = CMP | Rsegc::trd;
      break;
    case 7:
      CMP = CMP | Rsegc::bit23;
      break;
    case 8:
      CMP = CMP | Rsegc::bit22;
      break;
    default:
      break;
    }
  }
  return CMP;
}
