*-- Author :    Rainer Mankel   10/07/96

      subroutine tfideal(p_min,hit_min,z_min,z_max,elec_corr)

      implicit none
#include "arte/Arte.fi"
#include "rang/zfmode.fi"
#include "pris/zmh.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/MVER.fi"
#include "auto/RTRA.fi"
#include "auto/TOPP.fi"

      real p_min,               ! fit tracks with p>p_min
     +     z_min,               ! select hits with z>z_min
     +     z_max                !              and z<z_max
      integer hit_min,          ! fit tracks with nhit>hit_min
     +        elec_corr         ! electron bremsstrahlung corr flag

      integer nmx
      parameter (nmx=20)
      integer imc, evt_count, nt_old, ii, gcode, fstat, t1, t2, max_mc
      real ptot,zver
      integer message_id
      logical tfcharg
      save message_id
      data evt_count /0/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/MVER.ff"
#include "auto/RTRA.ff"
#include "auto/TOPP.ff"

      call mepric(message_id,0,
     +     'tfideal is obsolete - use rgideal instead')

      if (.not.l_rinit) call tfrinit()

      evt_count = evt_count + 1

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** loop over sensible MC particles

      max_mc = iq(jmtra+2)
      do 10 imc=1,max_mc
*        **** check id
         gcode = itopp_gean(omtra_topp(imc))

         if (.not.tfcharg(imc)) go to 10

*        **** check momentum
         ptot = sqrt( amax1(0.,fmtra_px(imc)**2 + fmtra_py(imc)**2
     +        + fmtra_pz(imc)**2) )
         if (ptot.lt.p_min) go to 10

*        **** number of hits/mimps ?
         if (nmimmh(imc).le.hit_min) go to 10

         if (mc_trap.ne.0.and.mc_trap.eq.imc) then
            print *,' tfideal: trap struck for imc=', imc
            call tfwait()
         endif
         nt_old = nrtra()
         call tfrfiti(imc,p_min,hit_min,z_min,z_max,elec_corr,fstat)

         t1 = nt_old + 1
         t2 = nrtra()
         zver = 999.
         if (omtra_bver(imc).gt.0) zver = fmver_z(omtra_bver(imc))
         if (zver.gt.30.) go to 10
*         call tffhist(imc,t1,t2,18,10,z_min,z_max)
         call tffhist(imc,t1,t2,30,10,z_min,z_max)
*         call tffhist(imc,t1,t2,25,0,z_min,z_max)
*         call tffhist(imc,t1,t2,18,0,z_min,z_max)
*         call tffhist(imc,t1,t2,12,0,z_min,z_max)
*         call tffhist(imc,t1,t2,25,10,z_min,z_max)


 10   continue

 999  end



















