*-- Author :    Rainer Mankel   19/06/97

      subroutine tfresid(ih,rh,mimp,m_mc,m_rc,m_hit,dr)

*     **** calculate MC/RC residuals
      implicit none
      integer ih,rh,mimp,jpl
      real m_mc,m_rc,m_hit,dr,xmc,ymc,txmc,tymc,m_u,cs_thetu,du

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RHIT.fi"
#include "auto/MIMP.fi"

#include "rang/zfpar.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/RHIT.ff"
#include "auto/MIMP.ff"


      if (ih.le.0.or.ih.gt.iq(jhitb+2)) then
         print *,' () tfresid: invalid hitb=',ih
         go to 999
      endif

      if (rh.le.0.or.rh.gt.iq(jrhit+2)) then
         print *,' () tfresid: invalid rhit=',rh
         go to 999
      endif

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
         print *,' () tfresid: invalid mimp=',mimp
         go to 999
      endif

      jpl = ihitb_gede(ih)

      txmc = fmimp_tx(mimp)
      tymc = fmimp_ty(mimp)
      xmc = fmimp_x(mimp) + (fhitb_z(ih)-fmimp_z(mimp)) * txmc
      ymc = fmimp_y(mimp) + (fhitb_z(ih)-fmimp_z(mimp)) * tymc

*     **** projection
      if (igede_cmp(jpl).eq.2) then
*        **** MC drift distance
         m_u = txmc * fgede_cos(jpl) - tymc * fgede_sin(jpl)
         cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*        **** distance from projection to wire (along u)
         du = xmc * fgede_cos(jpl) - ymc * fgede_sin(jpl) - fhitb_x(ih)
         m_mc = du * cs_thetu

*        **** RC drift distance
         m_u = frhit_tx(rh) * fgede_cos(jpl) 
     +        - frhit_ty(rh) * fgede_sin(jpl)
         cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*        **** distance from projection to wire (along u)
         du = frhit_x(rh) * fgede_cos(jpl) 
     +        - frhit_y(rh) * fgede_sin(jpl) - fhitb_x(ih)
         m_rc = du * cs_thetu
         
         m_hit = fhitb_q(ih)
         dr = fhitb_r(ih)

      elseif (igede_cmp(jpl).eq.3) then
         m_rc = frhit_x(rh) * fgede_rot(1,jpl)
     +        - frhit_y(rh) * fgede_rot(2,jpl)
         m_mc = xmc * fgede_rot(1,jpl)
     +        - ymc * fgede_rot(2,jpl)
         m_hit = fhitb_x(ih)
         dr = fhitb_r(ih)
       elseif (igede_cmp(jpl).eq.1) then
         m_rc = frhit_x(rh) * fgede_cos(jpl)
     +        - frhit_y(rh) * fgede_sin(jpl)
         m_mc = xmc * fgede_cos(jpl)
     +        - ymc * fgede_sin(jpl)
         m_hit = fhitb_x(ih)
         dr = fhitb_r(ih)
      else
         print *,' tfresid: non-supported type for jpl=', jpl
      endif

 999  end

