*-- Author  :    D.Samtleben   16.01.98
*-- Last change  :    18.01.98   by A.Spiridonov
*-- Last change  :    21.01.98   by A.Spiridonov
*-- Last change  :    14.05.98   by A.Spiridonov
c
c-------------------------------------------------------------
c
c       subroutine:   rc99AVTREC(flag)
c
c
c
c       output:   flag
c
c       action:   fills common blocks used for vertex fit
c                 reconstructs primary vertices (VFIT)
c
c
c   modified version of VTREC for 99 data  T.Oest 6/9/99
c
c-------------------------------------------------------------
c
      subroutine  RC99AVTREC(flag)
      implicit none
      integer flag,iret,i,iw,j

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"
#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/GTAR.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/GTAR.ff"

c------------------------------------------------------------
c    Resetting vertex-track pointers and flags
c------------------------------------------------------------
      CALL VTZERO
      NVPRIM = 0
c------------------------------------------------------------
c      initialization of wires for target constraint
c------------------------------------------------------------
      NW = 0
      DO IW=1,NGTAR()

       IF (fgtar_x(iw)**2+fgtar_y(iw)**2 .lt. 1.) THEN

        IF (NW.EQ.NWMAX) THEN
          flag = -1
c          PRINT '("VTREC: too many wires (",I3," ),")',NW
c          PRINT '("        only first",I3," will be used in ",
c     +            "recognition of primary vertizes.")',NWMAX
        ELSE
         NW = NW + 1
         CALL RC99AVTWIR(IW)
        ENDIF
       ENDIF
      ENDDO

* Fill wire buffer

c------------------------------------------------------------
c      fill track buffer of vertex package
c------------------------------------------------------------


      do j=1,NRSEG()

       IF (IRSEG_CMP(j) .eq. 1 .and. PRSEG_RTRA(j) .NE. 0) THEN

         i = MRSEG_RTRA(PRSEG_RTRA(j))

**************************************************************
c-------------------------------------------------------------
c  here cuts can be introduced on the properties of the tracks
c  which shall be used for the primary vertex reconstruction
c-------------------------------------------------------------
*
*     ignore reconstructed K0s                               ! by AS
*
*      if(irtra_fit(i).eq.100) go to 300
*                                           ignore track started
*                                           in stray magetic field
      if(frtra_zf(i).gt.200.) go to 300                       ! by AS
* 
      if(irtra_hsi(i) .eq. 0)  go to 300                       ! by AS
* 
*************************************************************


      if (trmult+1.gt.ntrtot) then            !  by AS
        flag = -2
        goto 100
      endif
 
         call vtrini(i)


 300     continue                                        ! by AS
       endif
      enddo

 100  continue                                           ! by AS 
C       PRINT '(" Number of tracks initialized = ",I4)',TRMULT

c------------------------------------------------------------
c    reconstruction of primary vertices
c------------------------------------------------------------

       CALL VTPRIM(0,iret) 

 999  return

      END
