// 
//  Author:  Rainer Mankel                     Created:  17-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rcevnt.C
// reconstruction main program
// dispatch selecting the appropriate main program according to
// time or geometry version

#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

extern "C" {
  void rcZevnt_();
}
void rc99Aevnt();



extern "C" {
  void rcevnt_() {
    
    // test if MC data
    if (ArteTable<MCIN>::booked()) {

      // MC data: check geometry
      int igeo =  (int) (10000 * (*(ArteTable<MCIN>::begin()))->vgeo + 0.5);
      
      if (igeo >= 00700 && igeo < 10000) {

	rcZevnt_();

      }
      else {
	if (igeo >= 980000 && igeo <= 999999) {
	  rc99Aevnt();
	}
	else {
	  arteMsg 
	    << "rcevnt: reconstruction for this geometry not yet included"
	    << endl;
	  static int id1;
	  arteMsg.allp(id1,10);
	}
      }
    }
    else {

      // real data: check date
      if (! ArteTable<EVHD>::booked()) {
	arteMsg << "rcevnt: event header missing" << endl;
	arteMsg.warn();
	return;
      }
      int date = (*ArteTable<EVHD>::begin())->date;

      if (date < 991231) {
	rc99Aevnt();
      }
      else {
	arteMsg << "rcevnt: reconstruction for this date not yet included"
		<< endl;
	static int id1;
	arteMsg.allp(id1,10);
      }
    }
  }
}
	
