#include <stdio.h>
#include <cstdio>
#include <vector>

#include <arte/arte.hh>
#include "silarte/silarte.hh"
#include "silarte/EVinfo.hh"

#include "grr.h"
#include "aframelib.h"
#include "sildat.h"
#include "sileff.h"

#include "Class_HOLMES.h"

// global variables
static HOLMES_class *HOLMESp = 0; 

//
// ================================
// silicon efficiency determination
// ================================
//
int SvdEffEvent()
{
  // ---------------
  // initializations
  // ---------------
  if ( !HOLMESp ) {

  // Fill GEDE_class in case of MC
    if ( CheckMC() )
      sildat_notifyGede( HolmesFillGEDEfromARTE() );

    // read geometry information
    HOLMESp = sileff_init();

  }

  // -------------
  // process event
  // -------------

  // get target spot(s)
  float *xtarget, *ytarget, *ztarget;
  int   ntarget = HolmesGetTargets( &xtarget, &ytarget, &ztarget );

  // fill Holmes-internal hit list
  HolmesFillHITBfromARTE( HOLMESp );

  // process event
  sileff_event( ntarget, xtarget, ytarget, ztarget );
  
  return GRR_OK;
}

//
//  After accumulating the events the actual alignment is called here
//
int SvdEffStop()
{
  // print efficiencies
  sileff_stop();

  return GRR_OK;
}


