*#define VTREC_DBG
*-- Author  :    D.Samtleben   16.01.98
*-- Last change  :    18.01.98   by A.Spiridonov
*-- Last change  :    21.01.98   by A.Spiridonov
*-- Last change  :    14.05.98   by A.Spiridonov
*-- Last change  :    29.07.99   by A.Spiridonov
c
c-------------------------------------------------------------
c
c       subroutine:   VTREC(flag)
c
c
c       output:   flag
c
c       action:   fills common blocks used for vertex fit
c                 reconstructs primary vertices (VFIT)

c-------------------------------------------------------------
c
      subroutine  VTREC(flag)
      implicit none
      integer flag,iret,i,iw

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"
#include "arte/Arte.fi"
#include "auto/RTRA.fi"
#include "auto/GTAR.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/GTAR.ff"

c------------------------------------------------------------
c    Resetting vertex-track pointers and flags
c------------------------------------------------------------
      CALL VTZERO
c------------------------------------------------------------
c      initialization of wires for target constraint
c------------------------------------------------------------
      NW = NGTAR()
      IF (NW.GT.NWMAX) THEN
        flag = -1
#ifdef VTREC_DBG
        PRINT '("VTREC: too many wires (",I3," ),")',NW
        PRINT '("        only first",I3," will be used in ",
     +          "recognition of primary vertizes.")',NWMAX
#endif
        NW = NWMAX

      else if(nw.le.0) then                           ! by AS
#ifdef VTREC_DBG
        PRINT '("VTREC: wrong number of  wires (",I3," ),")',NW
#endif
      go to 200
      ENDIF

* Fill wire buffer

      DO  iw=1,NW
        CALL vtwir(iw)
      ENDDO
c------------------------------------------------------------
c      fill track buffer of vertex package
c------------------------------------------------------------
  200 continue

*      IF (NRTRA().GT.NTRTOT) THEN
*        flag = -2
*        PRINT '("VTREC: too many reconstructed tracks (",I5," ),")',
*     +                NRTRA()
*        PRINT '("        only first",I4," used for vertex fit.")',NTRTOT
*      ENDIF

*     trmult = 0                           !    to be in vtzero.F
      if(nrtra().le.0) go to 999           !    by AS

         do i=1,NRTRA()

**************************************************************
c-------------------------------------------------------------
c  here cuts can be introduced on the properties of the tracks
c  which shall be used for the primary vertex reconstruction
c-------------------------------------------------------------
*
*     ignore reconstructed K0s                               ! by AS
*
      if(irtra_fit(i).eq.100) go to 300
*                                           ignore track started
*                                           in stray magetic field
      if(frtra_zf(i).gt.200.) go to 300                       ! by AS
* 
*************************************************************


      if (trmult+1.gt.ntrtot) then            !  by AS
        flag = -2
#ifdef VTREC_DBG
        PRINT '("VTREC: too many reconstructed tracks (",I5," ),")',
     +                NRTRA()                 !  by AS
        PRINT '("        only first",I4," used for vertex fit.")',NTRTOT
#endif
        goto 100
      endif
 
         call vtrini(i)

 300     continue                                        ! by AS
         enddo

 100  continue                                           ! by AS 
#ifdef VTREC_DBG
       PRINT '(" Number of tracks initialized = ",I4)',TRMULT
#endif

c------------------------------------------------------------
c    reconstruction of primary vertices
c------------------------------------------------------------

       CALL VTPRIM(0,iret) 

 999  return

      END
