#ifndef __WAX_FUNCTIONVALUE_HH__
#define __WAX_FUNCTIONVALUE_HH__

/** Stores the value, derivative and second derivative of a
    function at a given point */
class waxFunctionValue
{
public:
  // typedefs, enumerates
  typedef float YValue ;
  typedef float XValue ;

  // constructors
  waxFunctionValue() : fX(0),fY(0),fdYdX(0)/*,fdY2dX2(0)*/ {}
  //  waxFunctionValue(HepDouble a, HepDouble b, HepDouble c):
  //  value(a),ddx(b),d2dx2(c) {} ;
  
  waxFunctionValue& operator*=(YValue a) {
    fY *= a; fdYdX *= a ; //fd2YdX2 *= a; 
    return *this;
  }
  waxFunctionValue& operator +=(const waxFunctionValue& rhs) {
    fY += rhs.fY;fdYdX  += rhs.fdYdX; //fdY2dX2 += rhs.fd2YdX2 ;
    return *this ;
  }
  // data is not hidden
  YValue GetValue() const { return fY ; }
  YValue GetDerivative() const { return fdYdX ; } 
  //YValue GetSecondDerivative() const { return fd2YdX2 ; }

  XValue fX ;
  YValue fY ;
  YValue fdYdX ;
  //YValue fd2YdX2 ;
} ;

class ostream ;
ostream& operator<<(ostream& os, const waxFunctionValue& f) ;

inline
waxFunctionValue operator*(double x, waxFunctionValue& fv)
{
  waxFunctionValue y=fv;
  y*=x;
  return y;
}

#endif
