#ifndef __WAX_GEDEMANAGER_HH__
#define __WAX_GEDEMANAGER_HH__

#ifndef __SGI_STL_MAP
#include <map>
#endif
#ifndef __SGI_STL_VECTOR
#include <vector>
#endif
#ifndef __WAX_BASICTYPES_HH__
#include "BasicTypes.hh"
#endif
#ifndef __STRING__
#include <string>
#endif
class waxGede;

class waxGedeManager
{
public:
  //typedef unsigned short GedeIndex_t ;
  typedef vector<waxGede*> GedeContainer ;
  typedef map<string,waxGede*> HWCMap ;

  // constructors, destructors
  waxGedeManager() ;
  waxGedeManager(const char* configdirname) ;
  ~waxGedeManager() ;
  
  // setters and getters
  GedeContainer& GetGedes() { return fGedes ; }
  const GedeContainer& GetGedes() const { return fGedes ; }

  // other inlines
  waxGede* GetGede(GedeIndex_t gedeindex) const {
    assert(fGedes[gedeindex-fMinId]!=0) ;
    return fGedes[gedeindex-fMinId] ; }

  waxGede* GetGede(const string& hwc) const ;

  // other methods
#ifdef USE_ARTE
  void ResetHITBPointers() ; // Resets the hit pointers in the GEDEs
#endif

private:
  void Init() ;
  void Map() ;
  void SetWireIndexOffsets() ;
  GedeIndex_t fMinId ;
  GedeContainer fGedes ;
  HWCMap fHWCMap ;
} ;

#endif
