#ifndef __WAX_DECODE_HH__
#define __WAX_DECODE_HH__

#ifndef __OTR_DECODE_H__
#include "OTrDecode.h"
#endif
#ifndef __WAX_BASICTYPES_HH__
#include "BasicTypes.hh"
#endif

class decodeChannel
{
public:
  TdcCount_t     GetTdcCount()     const ;
  TdcCount_t     GetTZeroCount()   const ;
  Status_t       GetStatus()       const ;
  GedeIndex_t    GetGedeIndex()    const ;
  WireIndex_t    GetWireIndex()    const ;
  AsdIndex_t     GetAsdIndex()     const ;
  ChannelIndex_t GetChannelIndex() const ;
  void SetTZeroCount(TdcCount_t tzc) ; 

  // decoding the tdccount
  DriftTime_t GetTZero()      const ;
  DriftTime_t GetDriftTime()  const ;
  void SetTZero(DriftTime_t tz) ;

  static DriftTime_t GetTZero(TdcCount_t tzcount) ;
  static DriftTime_t GetDriftTime(TdcCount_t tdc,TdcCount_t tzcount) ;
  static const waxChannel* GetChannel(AsdIndex_t asdid, ChannelIndex_t chid) ;
  static void SetDecodeControl(decodeControl* c) { fgDecodeControl=c ; }
private:
  OTrWire fWire ;
  static decodeControl* fgDecodeControl ;
} ;

class decodeAsd
{
public:
  unsigned char GetNChannels() const { return 16 ; }
  const decodeChannel* GetChannels() const { 
    return static_cast<const decodeChannel*> fAsd.wires ; }
private:
  OTrAsd8 fAsd ;
} ;

class decodeWire
{
public:
  AsdIndex_t     GetAsdIndex()     const { return fWire.fAsdIndex ; }
  ChannelIndex_t GetChannelIndex() const { return fWire.fChannelIndex ; }
private:
  OTrGedeWireStruct fWire ;
} ;

class decodeGede
{
  unsigned char     GetNWires() const { return fGede.fNWires ; }
  const decodeWire* GetWires()  const { return static_cast<const decodeWire*>(fGede.fWires) ; }
private:
  OTrGedeStruct fGede ;
} ;

class decodeControl
{
  decodeControl(int mode, const string& tablename, const string& othertablename) ;
  const decodeGede* GetGedes() const { return fDecodetable.fGedes ; }
private:
  OTR_Decode fDecodetable ;
} ;



#endif
