#include "wax/Hit.hh"
#include "wax/Channel.hh"
#include "wax/RTRelation.hh"

//__________________________________________________________________
// waxHit
//
//
// Author: Wouter Hulsbergen
//__________________________________________________________________

const waxGedeManager* waxHit::fgGedeManager=0;

// waxDObservable
// waxHit::GetDriftDistance() const {
//   waxRTRelation* rtr = GetGede()->GetRTRelation() ;
//   double R = 0;
//   double sigmaR = 0;
//   if ( rtr ) {
//     R = rtr->GetR(double(GetDriftTime())) ; // !! Do not forget the (double) !!
//     sigmaR = sqrt(rtr->GetSigma2(R).GetValue()) ;
//     //sigmaR = //rtr->CalcRTResult(R).GetSigmaR().GetValue() ;
//     //  rtr->CalcRTResult(R).GetSigma().GetValue() ;
//   } else {
//     cout << "ERROR in waxHit::GetDriftDistance(), GetRTRelation() == 0"
// 	 << endl; 
//   }
//   waxDObservable o;
//   o.SetValue(R);
//   o.SetError(sigmaR);
//   return o;
// };


#ifdef USE_ARTE
void
waxHit::AppendHITB(ArtePointerHITB hitb) {
  if(fHITB.index()) {
    cout << "waxHit::AppendHITB(): Hit (" << fHITB.index() 
	 << ") already added !!" << endl ;
    return ;
  }
  fHITB=hitb ;
  HITB& hit = *hitb; 
  hit.z    = GetRawZ() ;
  hit.x    = GetRawX() ; 
  hit.y    = GetTdcCount() ;
  waxRTRelation::RTResult rtresult = 
    GetGede()->GetRTRelation()->GetRTResultFromT(GetDriftTime()) ;
  hit.q    = rtresult.fR ;
  hit.r    = rtresult.fSigmaR ;
  hit.gede = GetGedeIndex() ;
  hit.chid = GetCHID(GetWireIndex(),GetAsdIndex(),GetChannelIndex()) ;
}

ArtePointerHITB
waxHit::AppendHITB() {
  if(fHITB.index()) {
    cout << "waxHit::AppendHITB(): Hit (" << fHITB.index() 
	 << ") already added !!" << endl ;
    return fHITB ;
  }
  HITB hitb ;
  hitb.z    = GetRawZ() ;
  hitb.x    = GetRawX() ; 
  hitb.y    = GetTdcCount() ;
  waxRTRelation::RTResult rtresult = 
    GetGede()->GetRTRelation()->GetRTResultFromT(GetDriftTime()) ;
  hitb.q    = rtresult.fR ;
  hitb.r    = rtresult.fSigmaR ;
  hitb.gede = GetGedeIndex() ;
  hitb.chid = GetCHID(GetWireIndex(),GetAsdIndex(),GetChannelIndex()) ;
  fHITB = ArteTable<HITB>::push_back(hitb);
  return fHITB ;
}

ostream& operator<<(ostream& os,const waxHit& hit) {
  os << "Leuk he, zo'n hit ?!" << endl ;
  return os ;
}

void waxHit::DumpHITB( ostream& os ) const
{  
  os << "z = " << fHITB->z << " "
     << "x = " << fHITB->x << " "
     << "y = " << fHITB->y << " "
     << "q = " << fHITB->q << " "
     << "r = " << fHITB->r << " "
     << "gede = " << fHITB->gede << endl;
}

ArtePointer<DIGB> waxHit::GetDIGB() const
{
  ArtePointer<DIGB> digb(0) ;
  ArtePointer<HITB> hitb = GetHITB() ;
  if(hitb.index()>0)
    for(ArteRelationIterator<DIGB> digbIt=hitb->digb.begin() ;
	digbIt!=hitb->digb.end() ; digbIt++) 
      if(fabs((*digbIt)->q - hitb->q) < 0.001) {
	digb = digbIt ;
	break ;
      }
  return digb ;
}

#endif
