*-- Author :    Siegmund Nowak   10/05/93

      SUBROUTINE VXXFND(CIRCL,XINT,IFLG)
C
C     stolen  from ARGUS reconstruction program 10.5.93 by S.Nowak
C
C       SUBROUTINE TO CALCULATE THE INTERSECTION OF TWO CIRCLES
C       IF ONE OR BOTH DEGENERATE, IFLG CONTROLS PROGRAM FLOW
C       --- CALLED FROM VXTKIN
C
C  INPUT:
C        CIRCL(3,2)
C        CIRCL(*,1)        1                2               3
C  IFLG=0          UNSIGNED RADIUS   X-COORD CENTER  Y-COORD CENTER
C  IFLG=1 (SAY)        TANGENT(Y)      -TANGENT(X)   T(X)*Y(0)-T(Y)*X(0)
C  IFLG=      0            1                2               3
C        2 CIRCLES  CIRCL(*,1)=LINE   CIRCL(*,2)=LINE  BOTH LINES
C  OUTPUT:
C         XINT(5)
C  XINT(*)    1            2          3          4          5
C        #INTERSECTS   X-COORD(1) Y-COORD(1) X-COORD(2) Y-COORD(2)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      real circl, xint, xm, a, b, c, aa, bb, cc, disc, sav
      integer ndx, mdx, iflg, ism, irevrs, j2, j3, nerror
      DIMENSION CIRCL(3,2),XINT(5),XM(2,3),NDX(2)
      DIMENSION MDX(4,2)
      DATA MDX/2,3,4,5,3,2,5,4/
C
      IF(IFLG.EQ.0)GO TO 300
      IF(IFLG.EQ.3)GO TO 200
      XINT(1)=0.
      IF(IFLG.GT.3)RETURN
C ----------------->>        CIRCLE AND LINE
      A = CIRCL(1,IFLG)
      B = CIRCL(2,IFLG)
      C = CIRCL(3,IFLG)
      ISM = 3 - IFLG
      GO TO 305
C ----------------->>        LINE AND LINE
 200  CONTINUE
      XM(1,1) = CIRCL(2,1)
      XM(1,2) = CIRCL(3,1)
      XM(1,3) =-CIRCL(1,1)
      XM(2,1) = CIRCL(2,2)
      XM(2,2) = CIRCL(3,2)
      XM(2,3) =-CIRCL(1,2)
**                 CALL MATIN1(XM,2,2,MDIM,1,NDX,NERROR,DET)
*     **** siegmund/s solution
      call rinv(2,xm,2,ndx,nerror,1,xm(1,3))
      XINT(1) = 0.
      IF(NERROR.NE.0)GO TO 900
      XINT(1) = 1.
      XINT(2) = XM(1,3)
      XINT(3) = XM(2,3)
      GO TO 900
C ----------------->>        CASE OF TWO CIRCLES
 300  CONTINUE
      A = 2. * (CIRCL(2,2) - CIRCL(2,1))
      B = 2. * (CIRCL(3,2) - CIRCL(3,1))
      C =   CIRCL(2,1)**2 - CIRCL(2,2)**2
     +    + CIRCL(3,1)**2 - CIRCL(3,2)**2
     +    - CIRCL(1,1)**2 + CIRCL(1,2)**2
      ISM = 1
      IF(CIRCL(1,1) .GT. CIRCL(1,2))ISM=2
C
 305  CONTINUE
      IREVRS = 1
      IF( ABS(B).GT.ABS(A) )GO TO 310
      IREVRS = 2
      SAV = A
      A = B
      B = SAV
 310  CONTINUE
      J2 = MDX(1,IREVRS)
      J3 = MDX(2,IREVRS)
      AA = 1. + (A/B)**2
      BB = 2 * (A/B * (C/B + CIRCL(J3,ISM)) - CIRCL(J2,ISM))
      CC = CIRCL(J2,ISM)**2 + (C/B+CIRCL(J3,ISM))**2 - CIRCL(1,ISM)**2
      DISC = BB**2 - 4. * AA * CC
      XINT(1) = 0.
      IF(DISC .LT. 0. )GO TO 900
      XINT(1) = 1.
      IF( ABS(DISC) .GT. 1.E-2 )GO TO 350
      XINT(MDX(1,IREVRS)) = -0.5 * BB / AA
      XINT(MDX(2,IREVRS)) = -0.5 * (A * XINT(MDX(1,IREVRS)) + C)/B
      GO TO 900
 350  CONTINUE
      XINT(1) = 2.
      DISC = SQRT(DISC)
      XINT(MDX(1,IREVRS)) = 0.5 * (DISC - BB) / AA
      XINT(MDX(3,IREVRS)) = 0.5 * (-DISC - BB) / AA
      XINT(MDX(2,IREVRS)) = - (A * XINT(MDX(1,IREVRS)) + C) / B
      XINT(MDX(4,IREVRS)) = - (A * XINT(MDX(3,IREVRS)) + C) / B
C
 900  CONTINUE
      RETURN
      END
